/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const LONG="A custom rule property must NOT be declared at the top level in the rule's rule.json entry (to avoid potential naming "+"collisions with JAF properties). Instead it should be declared in the top-level property object 'customOpts' of the rule.<p>"+"As of JET 18.0.0 (JAF >= 11.3.0) and JET 17.1.0 (>= JAF 10.6.1), top-level properties in a user rule are handled as follows:<p>"+"1) In API and AMD modes:<br>"+"&nbsp;&nbsp;a) if the rule is marked as '$required', all rules in the associated pack are disabled and the audit continues.<br>"+"&nbsp;&nbsp;b) if the rule IS NOT marked as '$required', the rule is disabled with a warning, and the audit will continue.<p>"+"2) In CLI mode -  the audit is terminated.<p>"+"Prior to JET 18.0.0 (JAF < 11.0.0) and JET 17.1.0 (>= JAF 10.6.1), the action taken was:<p>"+"a) Starting in JAF 5.11.0, the ability to declare custom rule properties at the top-level was deprecated. "+"For compatibility, the audit continued and a 'customOpts' property was automatically created during start-up. "+"Any user options found were moved into it and flagged with warnings.<p>"+"b) In JET 17 (JAF 10.5.6), thd compatibility with 5.11.0 ended, and any user options found at the top-level wwere flagged as errors, and "+"use of 'customOpts' became mandatory. The audit was terminated.";const SHORT="User-declared rule properties must be declared in the 'customOpts' top-level property.";function getName(){return"jaf-sys-rule-opt"}function getDescription(){return LONG}function getShortDescription(){return SHORT}module.exports={getName,getDescription,getShortDescription};