/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULE_NAME="oj-html-bp-title-to-tooltip";const LONG_DESCR="The 'tooltip' attribute matches the Redwood specification, but 'title' does not. "+"Additionally, there are accessibility issues with 'title' that are solved using 'tooltip'.<br>"+"Action: replace attribute 'title' with 'tooltip'.";const SHORT_DESCR="Attribute 'title' does not match the Redwood specifications and should be replaced with 'tooltip'.";function getName(){return RULE_NAME};function getShortDescription(){return SHORT_DESCR};function getDescription(){return LONG_DESCR};function register(){return{"<oj-c-button title=>":_onTitle,"<oj-c-menu-button title=>":_onTitle,"<oj-c-split-menu-button title=>":_onTitle}};function _onTitle(ruleCtx){let msg=`For <${ruleCtx.tagNode.name}> the 'title' attribute should be replaced with 'tooltip'.`;let issue=new ruleCtx.Issue(msg);ruleCtx.reporter.addIssue(issue,ruleCtx)};module.exports={getName,getDescription,getShortDescription,register};