/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULENAME="oj-html-rating-gauge-size";const DESCRIPTION="The use of the <oj-rating-gauge> 'size' attribute set to enumerated value 'fit' is a "+"Redwood theme anti-pattern. The UX recommendation is to use an 'sm', 'md', or 'lg' value instead. "+"For interactive gauges, 'sm' and 'md' sizes are not recommended, since the touch target sizes are not "+"large enough to meet the accessibility guidelines.";const SHORT_DESCRIPTION="Do not use <oj-rating-gauge> with the 'size' attribute set to 'fit' in Redwood";class Rule{getName(){return RULENAME}getDescription(){return DESCRIPTION}getShortDescription(){return SHORT_DESCRIPTION}register(){return{"<oj-rating-gauge size=>":this._onSize}}_onSize(ruleCtx,attr,value){if(value==="fit"){let issue=new ruleCtx.Issue(`<oj-rating-gauge> attribute 'size' value 'fit' is an anti-pattern in Redwood.`);ruleCtx.reporter.addIssue(issue,ruleCtx)}}}module.exports=Rule;