/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
var fs=require("fs");const readlineSync=require("readline-sync");const fileScanner=require("./resource/fileScanner");global.manifestData=require("./resource/manifest.json");const logging=require("./utilities/logging");const migrator=require("./resource/componentMigrator");global.configData=require("./resource/migrationConfig.json");function getVersion(){return"JET Corepack Migrator 2.0.0"}function migrate(){if(global.jaf.options.dryRunMode){const text="Migrator is in Dry Run Mode.\n\tFile changes will not occur.";logging.consoleWarning(text);logging.logMessage(text)}else{logging.consoleWarning("Migrator will make file changes.");if(readlineSync.keyInYNStrict("Do you want to continue?")){logging.consoleLog("\nMigration in progress. Please wait...")}else{logging.consoleLog("\nMigration attempt exited. No changes occured.");return 0}}let start=Date.now();if(global.jaf.configPath){const{jetVersion,excludeFolders,excludeFiles,testFiles,testFilesExtension,excludeComponents,includeFiles,includeFolders,includeComponents,forceMigration,excludeAttributeExpressions,baseMigrationDir,logFileName,logFilePath,refreshWDMethods}=fileScanner.getConfigData(global.jaf.configPath);global.configData=Object.assign(global.configData,{baseMigrationDir,logFileName,logFilePath});if(excludeFiles?.length&&includeFiles?.length){logging.logIncludeExcludeIssue("Files");return 0}if(excludeFolders?.length&&includeFolders?.length){logging.logIncludeExcludeIssue("Folders");return 0}if(excludeComponents?.length&&includeComponents?.length){logging.logIncludeExcludeIssue("Components");return 0}if(jetVersion){const internalVersion=parseFloat(global.configData.jetVersion);const externalVersion=parseFloat(jetVersion);if(externalVersion<internalVersion){global.configData.jetVersion=jetVersion}}if(excludeFiles?.length){global.configData.excludeFiles=excludeFiles}if(excludeFolders?.length){global.configData.excludeFolders=global.configData.excludeFolders.concat(excludeFolders)}if(includeFiles?.length){global.configData.includeFiles=includeFiles}if(includeFolders?.length){global.configData.includeFolders=global.configData.includeFolders.concat(includeFolders)}if(includeComponents?.length&&!excludeComponents?.length){global.manifestData=global.manifestData.filter(obj=>{return includeComponents.includes(obj.componentName)})}if(excludeComponents?.length&&!includeComponents?.length){global.manifestData=global.manifestData.filter(obj=>{return!excludeComponents.includes(obj.componentName)})}if(forceMigration){global.configData.forceMigration=forceMigration}if(excludeAttributeExpressions){global.configData.excludeAttributeExpressions=excludeAttributeExpressions}if(testFiles){global.configData.testFiles=testFiles}if(testFilesExtension){global.configData.testFilesExtension=testFilesExtension}if(refreshWDMethods){global.configData.refreshWDMethods=refreshWDMethods}}const{baseMigrationDir:baseDir,logFileName,logFilePath}=global.configData;const sourcePath=baseDir||process.cwd();global.migrationMetrics={components:0,files:0};const fileSets=fileScanner.scanForFiles(sourcePath);let logFileDestination=global.jaf.logPath;global.testMigration=["classNameToAttribute","migrateAttributes"];let componentsInfo=[];let info;global.manifestData=global.manifestData.filter(obj=>{return!obj.JetVersion||parseFloat(obj.JetVersion)<=parseFloat(global.configData.jetVersion)});for(let extension in fileSets){for(let filepath of fileSets[extension]){global.filePath=filepath;global.fileIsUpdated=false;global.errorInFile=false;let code=fs.readFileSync(filepath,{encoding:"utf8"});if(global.configData.testFiles==="true"&&extension!=".json"){global.plugins=["typescript","decorators"];code=migrator.migrateTest(code)}else{switch(extension){case".html":info=migrator.migrateHTML(code,componentsInfo);code=info.code;componentsInfo=info.compInfo;break;case".js":case".ts":global.plugins=["typescript","decorators"];info=migrator.migrateTSX(code,componentsInfo);code=info.code;componentsInfo=info.compInfo;break;case".jsx":case".tsx":global.plugins=["jsx","typescript","decorators"];info=migrator.migrateTSX(code,componentsInfo);code=info.code;componentsInfo=info.compInfo;break;case".css":break}}if(global.errorInFile){continue}if(!global.jaf.options.dryRunMode&&global.fileIsUpdated){fs.writeFileSync(filepath,code,err=>{if(err){console.error(err)}})}}}let end=Date.now();let time=`${(end-start)/1000}s`;if(componentsInfo){let logFile=fs.readFileSync(global.jaf.logPath).toString();logFile=logging.logCompMetrics(componentsInfo,time,logFile,global.jaf.options.dryRunMode);fs.writeFileSync(global.jaf.logPath,logFile)}logging.logApiLinks();if(logFileName||logFilePath){const defaultPathSplit=global.jaf.logPath.split("/");const defaultFileName=defaultPathSplit[defaultPathSplit.length-1].split(".")[0];defaultPathSplit.pop();const defaultPath=defaultPathSplit.join("/");logFileDestination=`${logFilePath?logFilePath:defaultPath}/${logFileName?logFileName:defaultFileName}.log`;fs.copyFile(global.jaf.logPath,logFileDestination,err=>{if(err)throw err});if(logFilePath){fs.unlink(global.jaf.logPath,err=>{if(err)throw err})}}logging.consoleLog(`
** Migration Complete
** Files Updated: ${global.migrationMetrics.files}
** Component Instances Migrated: ${global.migrationMetrics.components}
** Please refer to the log file found at ${logFileDestination} for more details
** Time for Migration: ${time}`);return 0}exports.migrate=migrate;exports.getVersion=getVersion;