/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
"use strict";const{DomUtils}=require("htmlparser2");const utils=require("./htmlUtils");const astUtils=require("./astUtils");const testUtils=require("./testUtils");const logging=require("../utilities/logging");const traverse=require("ast-traverse");const render=require("dom-serializer").default;function migrateHTML(code,allComponentsInfo){let dom=utils.getDom(code);let components=DomUtils.findAll(elem=>astUtils.inManifestData(elem.name),dom.children);let iniFileCount=global.migrationMetrics.files;let fileComponentsInfo={path:global.filePath,skipped:{},migrated:{}};for(let component of components){let componentInfo=astUtils.inManifestData(component.name);if(componentInfo){if(componentInfo.dataDriven){utils.checkFileUpdate();logging.logIgnoreDataDriven(component.name)}else if(componentInfo.metadata){let componentMetadata=require("../metadata/"+componentInfo.metadata+".json");let componentName=componentMetadata.legacyTag;let componentCopy={...component};let logs=[];if((global.configData.forceMigration.includes(componentName)||!utils.hasAttributesToIgnore(dom,component,componentMetadata))&&!utils.hasExpressionAttributes(component,componentMetadata.legacyTag,componentMetadata.importantAttributes)){if(componentMetadata.migrateTagByAttribute){logs.push(utils["migrateTagByAttribute"](component,componentMetadata["migrateTagByAttribute"]))}else if(componentMetadata.corePackTag){logs.push(utils["migrateTag"](component,componentMetadata.legacyTag,componentMetadata.corePackTag))}else{utils.checkFileUpdate();logs.push(logging.logTagProcessed(componentMetadata.legacyTag))}for(let key in componentMetadata){if(typeof utils[key]=="function"&&key!=="migrateTagByAttribute"&&key!=="migrateImports"){if(key==="migrateDescendants"){let child=utils[key](dom,component,componentMetadata);logs=logs.concat(child.logs);for(let key of Object.keys(child.migrated)){if(!fileComponentsInfo.migrated[key]){fileComponentsInfo.migrated[key]=child.migrated[key]}else{fileComponentsInfo.migrated[key]+=child.migrated[key]}}}else{let newLogs=utils[key](component,componentMetadata[key],dom);if(newLogs&&newLogs.length>0){logs=logs.concat(newLogs)}}}}if(utils.hasExpressionAttributes(component,componentMetadata.legacyTag,componentMetadata.importantAttributes)){DomUtils.replaceElement(component,componentCopy);global.migrationMetrics.components-=1}else{if(componentMetadata.corePackTag){if(!fileComponentsInfo.migrated[componentMetadata.legacyTag]){fileComponentsInfo.migrated[componentMetadata.legacyTag]=1}else{fileComponentsInfo.migrated[componentMetadata.legacyTag]+=1}}for(let log of logs){global.jaf.log.msg(log)}}}else{if(componentMetadata.corePackTag){if(!fileComponentsInfo.skipped[component.name]){fileComponentsInfo.skipped[component.name]=1}else{fileComponentsInfo.skipped[component.name]+=1}}}}else{if(!fileComponentsInfo.skipped[component.name]){fileComponentsInfo.skipped[component.name]=1}else{fileComponentsInfo.skipped[component.name]+=1}}}}if(Object.keys(fileComponentsInfo.migrated).length>0||Object.keys(fileComponentsInfo.skipped).length>0){allComponentsInfo.push(fileComponentsInfo)}if(!Object.keys(fileComponentsInfo.migrated).length&&global.migrationMetrics.files>0){global.migrationMetrics.files=iniFileCount}return{code:render(dom,{decodeEntities:false}),compInfo:allComponentsInfo}}function migrateTSX(code,allComponentsInfo){let ast=astUtils.generateAST(code);let childrenImports=[];let importAdded=false;let iniFileCount=global.migrationMetrics.files;let fileComponentsInfo={path:global.filePath,skipped:{},migrated:{}};if(!errorInFile){traverse(ast,{pre:function(node){if(node.type==="JSXElement"&&node.openingElement.name){let componentInfo=astUtils.inManifestData(node.openingElement.name.name);if(componentInfo){let componentName=componentInfo.componentName;if(componentInfo.dataDriven){astUtils.checkFileUpdate();logging.logIgnoreDataDriven(componentName)}else if(componentInfo.metadata){let componentMetadata=require("../metadata/"+componentInfo.metadata+".json");let copyNode=JSON.parse(JSON.stringify(node));let restoreNode=false;if((global.configData.forceMigration.includes(componentName)||!astUtils.hasAttributesToIgnore(node,componentMetadata,ast))&&!astUtils.hasExpressionAttributes(node.openingElement,componentMetadata.legacyTag,code,componentMetadata.importantAttributes)){let logs=[];if(componentMetadata.migrateTagByAttribute){logs.push(astUtils["migrateTagByAttribute"](node,componentMetadata["migrateTagByAttribute"]))}else if(componentMetadata.corePackTag){logs.push(astUtils["migrateTag"](node,componentMetadata.legacyTag,componentMetadata.corePackTag))}else{astUtils.checkFileUpdate();logs.push(logging.logTagProcessed(componentMetadata.legacyTag))}for(let key in componentMetadata){if(typeof astUtils[key]=="function"&&key!="migrateTagByAttribute"&&key!="migrateImports"){if(key==="migrateDescendants"){let child=astUtils[key](node,componentMetadata,code,ast,childrenImports);if(child){childrenImports=child.imports;logs=logs.concat(child.logs);for(let key of Object.keys(child.migrated)){if(!fileComponentsInfo.migrated[key]){fileComponentsInfo.migrated[key]=child.migrated[key]}else{fileComponentsInfo.migrated[key]+=child.migrated[key]}}}else{restoreNode=true;break}}else{let newLogs=astUtils[key](node,componentMetadata[key],code,ast,componentMetadata.legacyTag);if(newLogs&&newLogs.length>0){logs=logs.concat(newLogs)}else if(newLogs===false){restoreNode=true;break}}}}if(astUtils.hasExpressionAttributes(node.openingElement,componentMetadata.legacyTag,code,componentMetadata.importantAttributes)||restoreNode){node.openingElement=copyNode.openingElement;node.closingElement=copyNode.closingElement;node.children=copyNode.children;global.migrationMetrics.components-=1;if(!fileComponentsInfo.skipped[componentMetadata.legacyTag]){fileComponentsInfo.skipped[componentMetadata.legacyTag]=1}else{fileComponentsInfo.skipped[componentMetadata.legacyTag]+=1}}else{if(componentMetadata.corePackTag){if(!fileComponentsInfo.migrated[componentMetadata.legacyTag]){fileComponentsInfo.migrated[componentMetadata.legacyTag]=1}else{fileComponentsInfo.migrated[componentMetadata.legacyTag]+=1}}for(let log of logs){global.jaf.log.msg(log)}}}else{if(componentMetadata.corePackTag){if(!fileComponentsInfo.skipped[node.openingElement.name.name]){fileComponentsInfo.skipped[node.openingElement.name.name]=1}else{fileComponentsInfo.skipped[node.openingElement.name.name]+=1}}}}else{if(!fileComponentsInfo.skipped[node.openingElement.name.name]){fileComponentsInfo.skipped[node.openingElement.name.name]=1}else{fileComponentsInfo.skipped[node.openingElement.name.name]+=1}}}}}});code=astUtils.generateCode(ast);if(childrenImports){for(let metadata of childrenImports){astUtils.migrateImports(ast,metadata,code)}}code=astUtils.generateCode(ast);for(let obj of global.manifestData){let newImports=[];if(obj.metadata){let componentMetadata=require("../metadata/"+obj.metadata+".json");if(componentMetadata.migrateImports){newImports=astUtils.migrateImports(ast,componentMetadata,code);if(!newImports||newImports.length>0){importAdded=true}if(newImports){for(let i of newImports){astUtils.appendImport(i.name,i.index,ast)}}}}}if(Object.keys(fileComponentsInfo.migrated).length>0||Object.keys(fileComponentsInfo.skipped).length>0){allComponentsInfo.push(fileComponentsInfo)}if(!Object.keys(fileComponentsInfo.migrated).length&&!importAdded&&global.migrationMetrics.files>0){global.migrationMetrics.files=iniFileCount}return{code:astUtils.generateCode(ast),compInfo:allComponentsInfo}}}function migrateTest(code){if(!errorInFile){let imports=[];let ast=testUtils.generateAST(code);let importIndex;let corePackImport;for(let obj of global.manifestData){if(obj.metadata){let componentMetadata=require("../metadata/"+obj.metadata+".json");if(!Array.isArray(componentMetadata.corePackTag)){let globalInstances=[];let instances=[...globalInstances];traverse(ast,{pre:function(node){if(componentMetadata.migrateTest&&(node.type==="VariableDeclarator"&&node.id.typeAnnotation&&node.id.typeAnnotation.typeAnnotation.typeName&&node.id.typeAnnotation.typeAnnotation.typeName.name===componentMetadata.migrateTest.type.from||node.type==="MemberExpression"&&node.object&&node.object.name===componentMetadata.migrateTest.type.from)){globalInstances=testUtils.migrateType(node,componentMetadata.migrateTest.type,globalInstances)}else if(node.type==="CallExpression"&&(node.callee.name&&node.callee.name==="it"||node.callee.object&&node.callee.object.name==="it")||node.type==="FunctionDeclaration"||node.type==="ClassMethod"){let n=node.type==="CallExpression"?node.arguments[1]:node;let body=n.body.body;instances=[...globalInstances];if(componentMetadata.migrateTest){testUtils.hasMethodToIgnore(body,componentMetadata.migrateTest,instances);instances=testUtils.migrateLocator(body,componentMetadata.migrateTest.locator,instances);for(let key of global.testMigration){if(componentMetadata[key]){testUtils[key](body,componentMetadata[key],instances,componentMetadata.migrateTest.type.to)}}}testUtils.migrateCssLoc(body,componentMetadata)}else if(componentMetadata.migrateTest&&node.type==="CallExpression"&&node.callee.name&&node.callee.name==="before"){instances=testUtils.migrateLocator(node.arguments[0].body.body,componentMetadata.migrateTest.locator,instances)}else if(componentMetadata.migrateTest&&node.type==="ImportDeclaration"){if(node.source.value==="@oracle/oraclejet-webdriver/elements"){importIndex=importIndex?importIndex:ast.program.body.indexOf(node);imports=testUtils.migrateImports(node,componentMetadata.migrateTest,imports)}else if(node.source.value==="@oracle/oraclejet-core-pack/webdriver"){corePackImport=node}}else if(componentMetadata.migrateTest&&node.type==="TSTypeReference"&&node.typeName.name===componentMetadata.migrateTest.type.from){node.typeName.name=componentMetadata.migrateTest.type.to;astUtils.checkFileUpdate();logging.logTypeMigration(componentMetadata.migrateTest.type.from,componentMetadata.migrateTest.type.to)}}})}}}code=testUtils.generateCode(ast);for(let obj of global.manifestData){if(obj.metadata){let componentMetadata=require("../metadata/"+obj.metadata+".json");if(componentMetadata.migrateTest){let type=componentMetadata.migrateTest.type.to;let locator=componentMetadata.migrateTest.locator.to;if(code.includes(type)&&!imports.includes(type)){imports.push(type)}else if(code.includes(locator)&&!imports.includes(locator)){imports.push(locator)}}}}if(imports.length>0){testUtils.appendImports(ast,importIndex,imports,corePackImport)}code=testUtils.generateCode(ast)}return code}exports.migrateHTML=migrateHTML;exports.migrateTSX=migrateTSX;exports.migrateTest=migrateTest;