/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const{parseDocument,DomUtils}=require("htmlparser2");const render=require("dom-serializer").default;const logging=require("../utilities/logging");const self=require("./htmlUtils");function checkFileUpdate(){if(!global.fileIsUpdated){global.fileIsUpdated=true;global.migrationMetrics.files+=1;logging.logFilePath(global.filePath);return true}return false}function _getLabelFromDOMNode(node,slotName,cnodes=[],label=""){if(node&&node.children&&!!node.children.length){for(let child of node.children){if(child.type&&child.type=="text"){if(/\S/.test(child.data)){if(label){if(/[\[{].*?[\]}]/g.test(label)){if(/[\[{].*?[\]}]/g.test(child.data.trim())){label=`${label.substring(0,label.length-2)}() + ${child.data.trim().substring(2,child.data.length-2)}()]]`}else{label=`${label.substring(0,label.length-2)}() + ' ${child.data.trim()}']]`}}else{if(/[\[{].*?[\]}]/g.test(child.data.trim())){label=`[['${label} ' + ${child.data.trim().substring(2,child.data.length-2)}()]]`}else{label+=" "+child.data.trim()}}}else{label=child.data.trim()}cnodes.push(child)}}else if(child.type&&child.type=="tag"&&child.name.toUpperCase()=="OJ-BIND-TEXT"&&(!slotName&&!child.attribs.slot||slotName&&child.attribs.slot===slotName)){if(label){if(/[\[{].*?[\]}]/g.test(label)){if(/[\[{].*?[\]}]/g.test(child.attribs.value)){label=`${label.substring(0,label.length-2)}() + ${child.attribs.value.substring(2,child.attribs.value.length-2)}()]]`}else{label=`${label.substring(0,label.length-2)}() + ' ${child.attribs.value}']]`}}else{if(/[\[{].*?[\]}]/g.test(child.attribs.value)){label=`[['${label} ' + ${child.attribs.value.substring(2,child.attribs.value.length-2)}()]]`}else{label+=" "+child.attribs.value}}}else{label=child.attribs.value}cnodes.push(child)}else if(child.children&&!!child.children.length){if(child.attribs.slot===slotName){label=_getLabelFromDOMNode(child,slotName,cnodes,label);var regex=new RegExp("^[^\\dA-Za-z]*$");for(let c of child.children){if(c.type==="text"&&regex.test(c.data)){cnodes.push(c)}}cnodes.push(child)}}}}if(cnodes.length>0){for(let node of cnodes){DomUtils.removeElement(node)}}return label}function _findDescendant(component,tagName,slotName){if(component.children){for(let child of component.children){if(child.name===tagName){if(!slotName||child.attribs.slot&&child.attribs.slot===slotName){return child}}else if(child.children){const descendant=_findDescendant(child,tagName);if(descendant){return descendant}}}}return false}function getDom(text=""){return parseDocument(text,{withStartIndices:true,withEndIndices:true})}function _transferAttribute(fromTag,toTag,attribute,value,joined){if(fromTag.attribs[attribute]||joined&&fromTag.attribs[joined]){toTag.attribs[attribute]=value;delete fromTag.attribs[attribute]?fromTag.attribs[attribute]:fromTag.attribs[joined]}}function _hasAttributesToIgnoreHelper(dom,component,rule,key,parent,corePackTag){if(rule.missPeerTag){const peerRule=rule.missPeerTag;for(let tag of peerRule.tag){for(let attrSet of peerRule.matchValues){const peer=_findPeer(dom,component,tag,attrSet.ownAttribute,attrSet.peerAttribute);if(peer&&(!peerRule.attribute||!_findAttribute(peer,peerRule.attribute))&&(!peerRule.missSlot||_findAttribute(peer,"slot",peerRule.missSlot))){return false}}}return true};if(rule.missDescendant){const descRule=rule.missDescendant;for(let tag of descRule.tag){const desc=_findDescendant(component,tag,descRule.missSlot);if(desc&&(!descRule.attribute||!_findAttribute(desc,descRule.attribute))){return false}}return true};if(!rule.descendant&&component.attribs){if(rule.missAttribute){for(let key in rule.missAttribute){if(_findAttribute(component,key,rule.missAttribute[key])){return false}}if(corePackTag){checkFileUpdate();logging.logIgnoreComponent(component.name,rule.missAttribute,"",parent,true)}return true}if(rule.attribute&&!rule.typeDefined){let attr=_findAttribute(component,rule.attribute);if(attr){rule.attribute=attr.attribute;if(rule.allowedValues&&!rule.allowedValues.includes(component.attribs[rule.attribute])||rule.prohibitedValues&&rule.prohibitedValues.includes(component.attribs[rule.attribute])||!rule.allowedValues&&!rule.prohibitedValues){if(corePackTag){checkFileUpdate();let value=(rule.allowedValues||rule.prohibitedValues)&&component.attribs[rule.attribute]?component.attribs[rule.attribute]:"";logging.logIgnoreComponent(component.name,rule.attribute,value,parent)}return true}}}else if(component.attribs[key]&&component.attribs[key]===rule[key]){if(corePackTag){checkFileUpdate();logging.logIgnoreComponent(component.name,key,rule[key],parent)}return true}}if(component.children){for(let j=0;j<component.children.length;j++){const child=component.children[j];if(child.type==="tag"){if(rule.descendant){if(child.name===rule.descendant){if(rule.attribute){const attr=_findAttribute(child,rule.attribute);if(attr){rule.attribute=attr.attribute;if(rule.allowedValues&&!rule.allowedValues.includes(child.attribs[rule.attribute])||rule.prohibitedValues&&rule.prohibitedValues.includes(child.attribs[rule.attribute])||!rule.prohibitedValues&&!rule.allowedValues){if(corePackTag){checkFileUpdate();logging.logIgnoreComponent(child.name,rule.attribute,child.attribs[rule.attribute],parent)}return true}return false}else{return false}}else if(rule.slotName&&child.attribs["slot"]&&child.attribs["slot"]===rule.slotName){if(corePackTag){checkFileUpdate();logging.logIgnoreComponent(child.name,"slot",child.attribs[rule.attribute],parent)}return true}else if(rule.missSlot){if(!child.attribs["slot"]||child.attribs["slot"]!==rule.missSlot){if(corePackTag){checkFileUpdate();logging.logIgnoreComponent(child.name,"slot",rule.missSlot,parent,true)}return true}else if(child.attribs["slot"]&&child.attribs["slot"]===rule.missSlot){return false}}if(corePackTag){checkFileUpdate();logging.logIgnoreComponent(rule.descendant,"","",parent)}return true}else if(_hasAttributesToIgnoreHelper(dom,child,rule,key,parent,corePackTag)){return true}}if(!rule.attribute&&!rule.missAttribute&&_hasAttributesToIgnoreHelper(dom,child,rule,key,parent,corePackTag)){if(corePackTag){checkFileUpdate();logging.logIgnoreComponent(component.name,key,rule[key])}return true}}}}}function _toCamelCase(attribute){let camelCaseName=attribute.split("-");for(let i in camelCaseName){if(i>0){camelCaseName[i]=camelCaseName[i][0].toUpperCase()+camelCaseName[i].slice(1)}}camelCaseName=camelCaseName.join("");return camelCaseName}function _findAttribute(component,name,value=""){if(name){const joined=name.split("-").join("");if(DomUtils.hasAttrib(component,name)&&(!value||value===component.attribs[name])){return{attribute:name,attrValue:component.attribs[name]}}else if(DomUtils.hasAttrib(component,joined)&&(!value||value===component.attribs[joined])){return{attribute:joined,format:"camel",attrValue:component.attribs[joined]}}else if(DomUtils.hasAttrib(component,`:${name}`)&&(!value||value===component.attribs[`:${name}`])){return{attribute:`:${name}`,format:"colon",attrValue:component.attribs[`:${name}`]}}else if(DomUtils.hasAttrib(component,`:${joined}`)&&(!value||value===component.attribs[`:${joined}`])){return{attribute:`:${joined}`,format:"colonCamel",attrValue:component.attribs[`:${joined}`]}}}return false}function _findPeer(dom,component,peerTag,componentAttr,peerAttr){const attributeValue=_findAttribute(component,componentAttr).attrValue;if(attributeValue){const peer=DomUtils.findOne(elem=>elem.name===peerTag&&_findAttribute(elem,peerAttr,attributeValue),dom.children);return peer}}function hasAttributesToIgnore(dom,component,metadata,parent=""){const ignoreRuleData=metadata.ruleSetToIgnore;if(ignoreRuleData){for(let i=0;i<ignoreRuleData.length;i++){rule=ignoreRuleData[i];let arr=Object.keys(rule);let key=arr[0];if(!rule.type){if(rule.descendant){parent=component.name}if(_hasAttributesToIgnoreHelper(dom,component,rule,key,parent,metadata.corePackTag)){return true}}}}return false}function hasExpressionAttributes(component,componentName,importantAttributes){const excludedAttributes=global.configData.excludeAttributeExpressions[componentName];const regex=new RegExp(`((\\{\\{)|(\\[\\[)).*((\\}\\})|(\\]\\]))`);if(global.jaf.options.dryRunMode&&importantAttributes){for(let attribute of importantAttributes){if(component.attribs[`:${attribute}`]){attribute=`:${attribute}`}if(regex.test(component.attribs[attribute])){if(checkFileUpdate()){logging.logAttributeExpression(componentName,attribute,component.attribs[attribute])}}}}if(excludedAttributes&&excludedAttributes.length){for(let i=0;i<excludedAttributes.length;i++){if(component.attribs[`:${excludedAttributes[i]}`]){excludedAttributes[i]=`:${excludedAttributes[i]}`}if(regex.test(component.attribs[excludedAttributes[i]])){checkFileUpdate();logging.logExcludeAttributeExpression(componentName,excludedAttributes[i],component.attribs[excludedAttributes[i]]);return true}}}return false}function commentSlotContent(component,data){const slotValue=data.slot;for(let child of component.children){if(child.name&&child.attribs.slot==slotValue){const cnode=getDom("<!-- "+render(child,{decodeEntities:false})+" -->");DomUtils.replaceElement(child,cnode);checkFileUpdate();return[logging.logCommentSlotContent(component.name,slotValue,child.name)]}};}function slotContentToAttribute(component,data,dom){let logs=[];for(let obj of data){let toNode;if(obj.toDescendant){const descendant=_findDescendant(component,obj.toDescendant,obj.slotNameTo?obj.slotNameTo:"");if(descendant){toNode=descendant}else{continue}}if(obj.fromDescendant){const descendant=_findDescendant(component,obj.fromDescendant,obj.slotNameFrom?obj.slotNameFrom:"");if(descendant){component=descendant}else{continue}}if(obj.toPeer||obj.fromPeer){const peer=_findPeer(dom,component,obj.toPeer?obj.toPeer:obj.fromPeer,obj.ownAttribute,obj.peerAttribute);if(peer){if(obj.toPeer){toNode=peer}else{component=peer}}else{continue}}if(!Object.keys(component.attribs).includes(obj.attribute)){component.attribs[obj.attribute]=_getLabelFromDOMNode(component,data.slotNameFrom);if(!component.attribs[obj.attribute]){delete component.attribs[obj.attribute]}else{checkFileUpdate();logs.push(logging.logSlotContentToAttribute(component.name,obj.attribute,component.attribs[obj.attribute]));if(toNode){_transferAttribute(component,toNode,obj.attribute,component.attribs[obj.attribute]);logs.push(logging.logAttributeTransfer(component.name,toNode.name,obj.attribute,toNode.attribs[obj.attribute]))}return logs}}}}function migrateTag(component,legacyComponentName,coreComponentName,isChild){component.name=coreComponentName;checkFileUpdate();global.migrationMetrics.components+=1;return logging.logTagMigration(legacyComponentName,coreComponentName,isChild)}function migrateTagByAttribute(component,data,isChild){for(const tagSet of data){if(tagSet.attribute){const attribute=_findAttribute(component,tagSet.attribute,tagSet.attributeValue);if(attribute){component.name=tagSet.toTag;checkFileUpdate();global.migrationMetrics.components+=1;return logging.logTagMigration(tagSet.fromTag,tagSet.toTag,isChild)}}else{component.name=tagSet.toTag;checkFileUpdate();global.migrationMetrics.components+=1;return logging.logTagMigration(tagSet.fromTag,tagSet.toTag)}}};function classNameToAttribute(component,data){let logs=[];data.forEach(obj=>{const from=obj.className;const to=obj.attributeValue;const attribute=obj.attribute;if(component.attribs.class){classNames=component.attribs.class.split(" ");index=classNames.indexOf(from);if(index!=-1&&attribute){classNames.splice(index,1);if(classNames.length==0)delete component.attribs.class;else component.attribs.class=classNames.join(" ");component.attribs[attribute]=to;checkFileUpdate();logs.push(logging.logClassNameToAttribute(from,attribute,to))}}});return logs}function migrateAttributes(component,data,dom){let toNode;let logs=[];for(const attributeSet in data){let camelFromAttribute="";let camelToAttribute="";let tagExists=true;let obj=data[attributeSet];if(obj.fromDescendant||obj.fromPeer||obj.toDescendant||obj.toPeer){tagExists=false;if(obj.fromDescendant||obj.toDescendant){const descendant=_findDescendant(component,obj.fromDescendant?obj.fromDescendant:obj.toDescendant,obj.slotName);if(component.children&&descendant){tagExists=true;if(obj.fromDescendant){toNode=component;component=descendant}else{toNode=descendant}}else{continue}}else{const peerTag=_findPeer(dom,component,obj.toPeer?obj.toPeer:obj.fromPeer,obj.ownAttribute,obj.peerAttribute);if(peerTag){tagExists=true;if(obj.fromPeer){toNode=component;component=peerTag}else{toNode=peerTag}}else{continue}}}if(tagExists){let hasDepAttribute=true;if(obj.depAttribute){hasDepAttribute=_findAttribute(component,obj.depAttribute)}const hasFromAttribute=_findAttribute(component,obj.fromAttribute,obj.fromValue);let fromAttribute=obj.fromAttribute;if(hasFromAttribute){fromAttribute=hasFromAttribute.attribute}let toAttribute=obj.toAttribute;if(hasFromAttribute.format){if(toAttribute){if(hasFromAttribute.format==="camel"){toAttribute=toAttribute.split("-").join("")}else if(hasFromAttribute.format==="colonCamel"){toAttribute=`:${toAttribute.split("-").join("")}`}else{toAttribute=`:${toAttribute}`}}}const hasToAttribute=_findAttribute(component,toAttribute);if(!(obj.fromAttribute===obj.toAttribute&&obj.fromValue===obj.toValue)){if(hasDepAttribute&&hasFromAttribute&&toAttribute&&(!hasToAttribute||fromAttribute===toAttribute)){if(obj.toValue){switch(hasFromAttribute.format){case"camel":camelFromAttribute=_toCamelCase(obj.fromAttribute);camelToAttribute=_toCamelCase(obj.toAttribute);break;case"colonCamel":camelFromAttribute=`:${_toCamelCase(obj.fromAttribute)}`;camelToAttribute=`:${_toCamelCase(obj.toAttribute)}`;break}component.attribs[camelToAttribute?camelToAttribute:toAttribute]=obj.toValue;checkFileUpdate();logs.push(logging.logAttributeMigration(camelFromAttribute?camelFromAttribute:fromAttribute,obj.fromValue,camelToAttribute?camelToAttribute:toAttribute,obj.toValue))}else{let fromValue=obj.fromValue?obj.fromValue:component.attribs[fromAttribute];switch(hasFromAttribute.format){case"camel":camelFromAttribute=_toCamelCase(obj.fromAttribute);camelToAttribute=_toCamelCase(obj.toAttribute);break;case"colonCamel":camelFromAttribute=`:${_toCamelCase(obj.fromAttribute)}`;camelToAttribute=`:${_toCamelCase(obj.toAttribute)}`;break}if(obj.fromValue){component.attribs[camelToAttribute?camelToAttribute:toAttribute]=""}else{component.attribs[camelToAttribute?camelToAttribute:toAttribute]=component.attribs[fromAttribute]}checkFileUpdate();logs.push(logging.logAttributeMigration(camelFromAttribute?camelFromAttribute:fromAttribute,fromValue,camelToAttribute?camelToAttribute:toAttribute))}if(fromAttribute!==toAttribute){delete component.attribs[fromAttribute]}}else if(hasDepAttribute&&hasFromAttribute&&!toAttribute){delete component.attribs[fromAttribute];switch(hasFromAttribute.format){case"camel":fromAttribute=_toCamelCase(obj.fromAttribute);break;case"colonCamel":fromAttribute=`:${_toCamelCase(obj.fromAttribute)}`;break}checkFileUpdate();logs.push(logging.logAttributeDeprecation(fromAttribute,obj.fromValue))}else if(hasDepAttribute&&!obj.fromAttribute&&obj.toAttribute&&!hasToAttribute){if(toNode){toNode.attribs[obj.toAttribute]=obj.toValue}else{component.attribs[obj.toAttribute]=obj.toValue}checkFileUpdate();logs.push(logging.logAttributeAddition(obj.toAttribute,obj.toValue,toNode?toNode.name:""))}}if(toNode&&hasFromAttribute){switch(hasFromAttribute.format){case"camel":camelToAttribute=_toCamelCase(obj.toAttribute);break;case"colonCamel":camelToAttribute=`:${_toCamelCase(obj.toAttribute)}`;break}checkFileUpdate();_transferAttribute(component,toNode,camelToAttribute?camelToAttribute:toAttribute,component.attribs[camelToAttribute?camelToAttribute:toAttribute],toAttribute);const toValue=toNode.attribs[camelToAttribute?camelToAttribute:toAttribute];logs.push(logging.logAttributeTransfer(component.name,toNode.name,camelToAttribute?camelToAttribute:toAttribute,toValue));if(obj.fromDescendant||obj.fromPeer){component=toNode}}}}return logs}function handleSpecialCase(code,componentName,data){let obj;let regex;if(data[1]){obj=data[1];regex=new RegExp(obj.fromString.split(" ").join("\\s*"),"igm");code=code.replace(regex,obj.toString)}obj=data[0];regex=new RegExp(obj.fromString.split(" ").join("\\s*"),"igm");code=code.replace(regex,obj.toString);return code}function _migrateDescendantsHelper(dom,children,componentMetadata,parent,migratedComp,logs=[]){for(let child of children){if(child.name===componentMetadata.legacyTag){if(!hasAttributesToIgnore(dom,child,componentMetadata,parent)&&!hasExpressionAttributes(child,componentMetadata.legacyTag,componentMetadata.importantAttributes)){if(componentMetadata["migrateTagByAttribute"]){logs.push(migrateTagByAttribute(child,componentMetadata["migrateTagByAttribute"],true))}else{logs.push(migrateTag(child,componentMetadata.legacyTag,componentMetadata.corePackTag,true))}for(let key in componentMetadata){if(typeof self[key]=="function"&&key!="migrateTagByAttribute"&&key!="migrateImports"){logs=logs.concat(self[key](child,componentMetadata[key]))}}if(!migratedComp[componentMetadata.legacyTag]){migratedComp[componentMetadata.legacyTag]=1}else{migratedComp[componentMetadata.legacyTag]+=1}}}else{if(child.children){returnValue=_migrateDescendantsHelper(dom,child.children,componentMetadata,parent,migratedComp);logs=logs.concat(returnValue.logs);migratedComp=returnValue.migrated}}}return{logs:logs,migrated:migratedComp}}function migrateDescendants(dom,component,metadata,logs=[]){let migratedComp={};const data=metadata.migrateDescendants;let returnValue=false;for(let metaName of data){let componentMetadata=require("../metadata/"+metaName+".json");if(component.children){returnValue=_migrateDescendantsHelper(dom,component.children,componentMetadata,metadata.legacyTag,migratedComp);if(returnValue){logs=logs.concat(returnValue.logs)}}}return{logs:logs,migrated:returnValue.migrated}}function removeComponent(component){DomUtils.removeElement(component);return logging.logComponentRemoved(component.name)}function replaceComponent(fromNode,data){for(let obj of data){let descendant=_findDescendant(fromNode,obj.descendant);if(descendant){DomUtils.replaceElement(fromNode,descendant);return logging.logComponentReplacement(fromNode.name,descendant.name)}}}exports.getDom=getDom;exports.checkFileUpdate=checkFileUpdate;exports.hasAttributesToIgnore=hasAttributesToIgnore;exports.hasExpressionAttributes=hasExpressionAttributes;exports.slotContentToAttribute=slotContentToAttribute;exports.commentSlotContent=commentSlotContent;exports.migrateTag=migrateTag;exports.classNameToAttribute=classNameToAttribute;exports.handleSpecialCase=handleSpecialCase;exports.migrateAttributes=migrateAttributes;exports.migrateTagByAttribute=migrateTagByAttribute;exports.migrateDescendants=migrateDescendants;exports.replaceComponent=replaceComponent;exports.removeComponent=removeComponent;