/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
function consoleLog(text){global.jaf.log.console(text)}function consoleWarning(text){let clr=global.jaf.utils.color;let warnMsg=`\n[Warn]: ${text}`;global.jaf.log.console(clr.PINK(warnMsg))}function logMessage(text){global.jaf.log.msg(text)}function logFilePath(filepath,err){if(err){global.jaf.log.msg(`\nFile in: ${filepath}`)}else{global.jaf.log.msg(`\nMigrating in: ${filepath}`)}}function logImportUpdate(from,to){global.jaf.log.msg(`\tImport: Updated from "${from}" to "${to}"`)}function logImportAppend(to,from){global.jaf.log.msg(`\tImport: Appended "${to}" ${from?`to "${from}"`:""}`)}function logMissingImport(component,to){global.jaf.log.msg(`\tImport: Added "${to}" for "${component}" to top of file due to missing import`)}function logTagMigration(from,to,isDescendant){let msg="";isDescendant?msg=`\t\tDescendant tag migrated from "${from}" to "${to}"`:msg=`\tTag migrated from "${from}" to "${to}"`;return msg}function logTagProcessed(component){return`\tProcessed tag: "${component}"`}function logClassNameToAttribute(className,attribute,value){return`\t\tClass name of "${className}" migrated to "${attribute}" attribute with value of "${value}"`}function logAttributeMigration(fromAtt,fromVal,toAtt,toVal){let msg="";toVal?msg=`\t\tAttribute migrated from "${fromAtt}" with a value of "${fromVal}" to "${toAtt}" with a value of "${toVal}"`:msg=`\t\tAttribute migrated from "${fromAtt}" to "${toAtt}"`;return msg}function logAttributeDeprecation(from,fromVal){return`\t\tAttribute deprecated, removed "${from}" ${fromVal?`with a value of "${fromVal}"`:""}`}function logAttributeAddition(toAtt,toVal,toTag){return`\t\tAttribute added, "${toAtt}" with a value of "${toVal}"${toTag?` to "${toTag}"`:""}`}function logAttributeTransfer(fromTag,toTag,att,val){return`\t\tAttribute "${att}" with value "${val}" transferred from "${fromTag}" to "${toTag}"`}function logObjectManipulation(attribute,key,newKey,value,newValue){return`\t\tKey value pair in "${attribute}" value migrated from key "${key}" with value "${value}" to key "${newKey}" with value "${newValue}"`}function logTypeMigration(fromType,toType){global.jaf.log.msg(`\tType migrated from "${fromType}" to "${toType}"`)}function logLocatorMigration(fromLoc,toLoc,variable){global.jaf.log.msg(`\tLocator migrated from "${fromLoc}" to "${toLoc}" ${variable?`on "${variable}"`:""}`)}function logMethodDeprecation(method,webElement){global.jaf.log.msg(`\tTest will fail: Method "${method}" is not supported for corepack "${webElement}"`)}function logTestAttributeDeprecation(attribute,value,webElement){global.jaf.log.msg(`\tTest will fail: Attribute "${attribute}" ${value?`with a value of "${value}"`:""} was dprecated for core pack "${webElement}"`)}function logTestAttributeMigration(fromAtt,toAtt,fromVal,toVal){global.jaf.log.msg(`\tAttribute migrated from "${fromAtt}" ${fromVal?`with a value of "${fromVal}" to "${toAtt}" ${toVal?`with a value of "${toVal}"`:""}`:`to "${toAtt}"`}`)}function logIgnoreComponent(component,attribute,value,parent,missingAtt=false,msg){if(parent){if(attribute){global.jaf.log.msg(`\tRule to ignore: "${parent}" filtered out due to${missingAtt?" missing ":" "}attribute "${attribute}" ${value?`with value of "${value}" `:""}on descendant "${component}"`)}else{global.jaf.log.msg(`\tRule to ignore: "${parent}" filtered out due to descendant "${component}"`)}}else if(attribute){if(typeof attribute==="object"){const keys=Object.keys(attribute);let key=keys[0];value=attribute[key];attribute=key}global.jaf.log.msg(`\tRule to ignore: "${component}" filtered out due to${missingAtt?" missing ":" "}attribute "${attribute}"${value?` with value of "${value}"`:""}${msg?`. ${msg}`:""}`)}else{global.jaf.log.msg(`\tIgnored "${component}" processing. There is nothing to process for this component`)}}function logComponentReplacement(component,replacement){return`\t\tComponent "${component}" replaced by "${replacement}"`}function logComponentRemoved(component){return`\t\tComponent "${component}" was removed`}function logIgnoreDataDriven(component){global.jaf.log.msg(`\t"${component}" migration ignored due to being data driven. Manual migration is required until the component migration is supported.`)}function logCommentSlotContent(component,value,child){const msg=`\t\tCommented out "${component}"'s descendant ${child?`"${child}"`:""} with "slot" attribute having value of "${value}"`;return msg}function logSlotContentToAttribute(component,attribute,value){let msg="";value?msg=`\t\tSlot migrated: "${component}" added attribute "${attribute}" with value of "${value}"`:msg=`\t\tSlot migration ignored: "${component}" did not add attribute "${attribute}" due to value of "${value}"`;return msg}function logAttributeExpression(component,attribute,value){global.jaf.log.msg(`\t\tAttribute expression: "${component}" has attribute "${attribute}" with value as expression of "${value}"`)}function logExcludeAttributeExpression(component,attribute,value){global.jaf.log.msg(`\tMigration skipped: "${component}" has attribute "${attribute}" with value as expression of "${value}"`)}function logIncludeExcludeIssue(type){const text=`\nMigration attempt exited. The migration config file used has values for both include${type} and exclude${type}. Please use only one or the other.`;global.jaf.log.msg(text);consoleLog(text)}function logAttributeWarning(attribute){return`\t\tWarning: Attribute "${attribute}" might need manual migration. Please see component's migration section`}function logCompMetrics(componentsInfo,time,logFile,dr){logFile=logFile.split("\n");let overallMetrics=`
Overall metrics
  \tFiles Updated: ${global.migrationMetrics.files}
  \tComponent Instances Migrated: ${global.migrationMetrics.components}
  \tTime for migration: ${time}`;let appTotal=0;let appMigrated=0;let appInfo={skipped:{},migrated:{}};let fileSpecificMetrics=``;let componentMetrics=`\n\nComponent Migration Metrics`;for(let fileInfo of componentsInfo){let fileTotal=0;let fileMigrated=0;let percentage=0;let compTotal=0;fileSpecificMetrics+=`\n\nFile in: ${fileInfo.path}`;for(let key of Object.keys(fileInfo.migrated)){if(appInfo.migrated[key]){appInfo.migrated[key]+=fileInfo.migrated[key]}else{appInfo.migrated[key]=fileInfo.migrated[key]}compTotal=0;fileTotal+=fileInfo.migrated[key];fileMigrated+=fileInfo.migrated[key];compTotal+=fileInfo.migrated[key];if(fileInfo.skipped[key]){fileTotal+=fileInfo.skipped[key];compTotal+=fileInfo.skipped[key];if(appInfo.skipped[key]){appInfo.skipped[key]+=fileInfo.skipped[key]}else{appInfo.skipped[key]=fileInfo.skipped[key]}}percentage=fileInfo.migrated[key]*100/compTotal;fileSpecificMetrics+=`\n\t"${key}": ${fileInfo.migrated[key]}/${compTotal} ${Math.floor(percentage)}%`}for(let key of Object.keys(fileInfo.skipped)){if(!fileInfo.migrated[key]){if(appInfo.skipped[key]){appInfo.skipped[key]+=fileInfo.skipped[key]}else{appInfo.skipped[key]=fileInfo.skipped[key]}fileTotal+=fileInfo.skipped[key];fileSpecificMetrics+=`\n\t"${key}": 0/${fileInfo.skipped[key]} 0%`}}appTotal+=fileTotal;appMigrated+=fileMigrated;percentage=fileTotal?fileMigrated*100/fileTotal:0;fileSpecificMetrics+=`\n\tFile total: ${fileMigrated}/${fileTotal} ${Math.floor(percentage)}%`}for(let key of Object.keys(appInfo.migrated)){compTotal=appInfo.migrated[key];if(appInfo.skipped[key]){compTotal+=appInfo.skipped[key]}percentage=appTotal?appInfo.migrated[key]*100/compTotal:0;componentMetrics+=`\n\t"${key}": ${appInfo.migrated[key]}/${compTotal} ${Math.floor(percentage)}%`}for(let key of Object.keys(appInfo.skipped)){if(!appInfo.migrated[key]){componentMetrics+=`\n\t"${key}": 0/${appInfo.skipped[key]} 0%`}}percentage=appTotal?appMigrated*100/appTotal:0;componentMetrics+=`\n\tTotal: ${appMigrated}/${appTotal} ${Math.floor(percentage)}%`;let data=overallMetrics+componentMetrics+fileSpecificMetrics;if(dr){logFile.splice(2,0,data)}else{logFile.unshift(data)}logFile=logFile.join(`\n`);return logFile}function logApiLinks(){global.jaf.log.msg(`\nComponent API Migration Sections`);global.manifestData.forEach(component=>{if(component.migrationApiLink){global.jaf.log.msg(`\t${component.componentName}: ${component.migrationApiLink}`)}})}exports.consoleLog=consoleLog;exports.consoleWarning=consoleWarning;exports.logMessage=logMessage;exports.logFilePath=logFilePath;exports.logImportUpdate=logImportUpdate;exports.logImportAppend=logImportAppend;exports.logMissingImport=logMissingImport;exports.logTagMigration=logTagMigration;exports.logTagProcessed=logTagProcessed;exports.logClassNameToAttribute=logClassNameToAttribute;exports.logAttributeMigration=logAttributeMigration;exports.logAttributeDeprecation=logAttributeDeprecation;exports.logAttributeAddition=logAttributeAddition;exports.logAttributeTransfer=logAttributeTransfer;exports.logObjectManipulation=logObjectManipulation;exports.logTypeMigration=logTypeMigration;exports.logLocatorMigration=logLocatorMigration;exports.logMethodDeprecation=logMethodDeprecation;exports.logTestAttributeDeprecation=logTestAttributeDeprecation;exports.logTestAttributeMigration=logTestAttributeMigration;exports.logIgnoreComponent=logIgnoreComponent;exports.logComponentReplacement=logComponentReplacement;exports.logComponentRemoved=logComponentRemoved;exports.logIgnoreDataDriven=logIgnoreDataDriven;exports.logCommentSlotContent=logCommentSlotContent;exports.logCompMetrics=logCompMetrics;exports.logSlotContentToAttribute=logSlotContentToAttribute;exports.logAttributeExpression=logAttributeExpression;exports.logExcludeAttributeExpression=logExcludeAttributeExpression;exports.logIncludeExcludeIssue=logIncludeExcludeIssue;exports.logAttributeWarning=logAttributeWarning;exports.logApiLinks=logApiLinks;