/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
var parser=require("markdown-it");const PARA_OPEN="paragraph_open";const PARA_CLOSE="paragraph_close";const HEADING_OPEN="heading_open";const HEADING_CLOSE="heading_close";const LINK_OPEN="link_open";const IMAGE="image";const INLINE="inline";const FENCE="fence";const TEXT="text";const UL_OPEN="bullet_list_open";const UL_CLOSE="bullet_list_close";const OL_OPEN="ordered_list_open";const OL_CLOSE="ordered_list_close";const CODE="code";const HTTP="http://";const RE_BRACKET=/\[([^)]+)\].*:/g;const RE_DEL_BRACKET_COLON=/\[|\]|:/g;const RE_REFLINK=/\[[^[]*\]\s*\[([^[]*)\]/;function AstMd(appCtx){this._parser=new parser;this._parser.set({linkify:appCtx.config.getMarkdownOptions().linkify});this._appCtx=appCtx;this._utils=appCtx.utils;this._state={};this._links=[];this._paras=[];this._images=[];this._code=[];this._lists=[];this._refLinks=undefined;this._lineMap=new Map};AstMd.prototype.parse=function(data){var state=this._state;state.para=state.heading=state.list=false;state.level=0;state.listType=undefined;this._curListItem=null;this._listsStack=[];this._listItemStack=[];this._stateStack=[];this._mapStack=[];this._links.length=this._paras.length=this._images.length=this._code.length=this._lists.length=0;this._refLinks={};this._ast=this._parser.parse(data,{});this._data=data;this._loadLineMap();return this._ast};AstMd.prototype.createHandler=function(){this._createHandlerContent();return{getLinks:this._getLinks.bind(this),getParas:this._getParas.bind(this),getImages:this._getImages.bind(this),getCode:this._getCode.bind(this),getLists:this._getLists.bind(this),getRefLinks:this._getRefLinks.bind(this),test:this._testParas.bind(this),getLine:this._getLine.bind(this),getLineDisp:this._getLineDisp.bind(this),getLineMap:this._getLineMap.bind(this)}};AstMd.prototype._createHandlerContent=function(){this._createRefs();this._walkChildren(this._ast,this._state)};AstMd.prototype._walkChildren=function(ast,state){var i,o,txt,link,refLink,obj,pos,pos2,start;for(i=0;i<ast.length;i++){o=ast[i];if(o.type===PARA_OPEN&&!state.list){state.para=true;this._map=this._setPos(o.map)}else if(o.type===PARA_CLOSE&&!state.list){state.para=false}else if(o.type===HEADING_OPEN&&!state.list){state.heading=true;this._map=this._setPos(o.map);state.level=_getLevel(o.tag)}else if(o.type===HEADING_CLOSE&&!state.list){state.heading=false;state.level=0}else if(o.type===UL_OPEN||o.type===OL_OPEN){if(this._curListItem){this._listItemStack.push(this._curListItem);this._stateStack.push(state);this._listsStack.push(this._lists);this._lists=this._curListItem.items[this._curListItem.items.length-1].children=[];state={};this._mapStack.push(this._map);this._map=this._setPos(o.map)}state.list=true;state.listType=o.tag;this._map=this._setPos(o.map);pos=this._lineMap.get(o.map[0]+1);pos2=null;if(o.map[0]+1<o.map[1]){pos2=this._lineMap.get(o.map[1])}this._curListItem={ordered:state.listType==="ol",items:[],pos:[{line:o.map[0]+1,start:pos.start,end:pos.end}]};if(pos2){this._curListItem.pos.push({line:o.map[1],start:pos2.start,end:pos2.end})}}else if(o.type===UL_CLOSE||o.type===OL_CLOSE){state.list=false;state.listType=undefined;this._lists.push(this._curListItem);this._curListItem=null;if(this._listItemStack.length){this._curListItem=this._listItemStack.pop();this._lists=this._listsStack.pop();state=this._stateStack.pop();this._map=this._mapStack.pop()}}else if(o.type===INLINE){if(state.list){this._curListItem.items.push({item:o.children[0].content})}else if(state.para||state.heading){pos=this._lineMap.get(o.map[0]+1);pos2=null;if(o.map[0]+1<o.map[1]){pos2=this._lineMap.get(o.map[1])}obj={level:state.level,text:o.content,pos:[{line:o.map[0]+1,start:pos.start,end:pos.end}]};if(pos2){obj.pos.push({line:o.map[1],start:pos2.start,end:pos2.end})}this._paras.push(obj)}else if(o.content.charAt(0)==="!"){var jj=42}}else if(o.type===LINK_OPEN){let bContinue=true;txt=_peekContent(ast,i,TEXT);link=o.attrs[0][1];if(this._map){pos=this._getColsExtent(txt?txt:link)}if(o.markup==="linkify"){let t=ast[i+1].content;if(t.toLowerCase().endsWith(".md")&&!t.startsWith("http")){bContinue=false}}if(bContinue){if(refLink=this._isRefLink(pos.line)){pos=this._getRefLinkPos(pos.line,refLink);obj={text:txt||null,inline:false,refKey:refLink,pos:pos}}else{start=this._getLineDisp(pos.line,pos.col);obj={inline:true,link:link,text:txt||null,pos:{line:pos.line,col:pos.col,start:start,end:start+=link.length-1}}}this._links.push(obj)}}else if(o.type===IMAGE){link=o.attrs[0][1];pos=this._getColsExtent(link);start=this._getLineDisp(pos.line,pos.col);obj={alt:o.content,pos:{line:pos.line,col:pos.col,start:start,end:start+=link.length-1}};if(this._refLinks[link]){obj.inline=false,obj.refKey=link}else{obj.inline=true,obj.link=link}this._images.push(obj)}else if(o.type===FENCE&&o.tag===CODE){pos=this._lineMap.get(o.map[0]+1);pos2=null;if(o.map[0]+1<o.map[1]){pos2=this._lineMap.get(o.map[1])}obj={code:o.content,pos:[{line:o.map[0]+1,start:pos.start,end:pos.end}]};if(pos2){obj.pos.push({line:o.map[1],start:pos2.start,end:pos2.end})}this._code.push(obj)}if(o.children){this._walkChildren(o.children,state)}}};AstMd.prototype._getLinks=function(){return this._links};AstMd.prototype._getParas=function(){return this._paras};AstMd.prototype._getImages=function(){return this._images};AstMd.prototype._getCode=function(){return this._code};AstMd.prototype._getLists=function(){return this._lists};AstMd.prototype._getRefLinks=function(){return this._refLinks};AstMd.prototype._getLineMap=function(){return this._lineMap};AstMd.prototype._testParas=function(regexp,firstMatch){var ret=null;var paras=this._getParas();try{for(let i=0;i<paras.length;i++){regexp.lastIndex=0;if(regexp.test(paras[i].text)){if(!ret){ret=[]}ret.push(paras[i]);if(firstMatch){break}}}}catch(e){}return ret?ret:null};AstMd.prototype._getColsExtent=function(txt){var lineNum,line,txt2,x=-1;for(lineNum=this._map[0];lineNum<=this._map[1];lineNum++){line=this._getLine(lineNum);line=line.replace(/\\/g,"");if(txt.startsWith(HTTP)){txt2=txt.substring(HTTP.length)}if((x=line.indexOf(txt))<0){if(txt2){x=line.indexOf(txt2)}}if(x>=0){return{line:lineNum,col:x+1}}}return null};AstMd.prototype._getLineDisp=function(lineNum,col){var ret=-1;if(lineNum<=this._lineMap.size){ret=this._lineMap.get(lineNum).start;if(typeof col==="number"){ret+=col-1}}return ret};AstMd.prototype._getLine=function(lineNum){var start,end,line,pos;;if(lineNum<=this._lineMap.size){pos=this._lineMap.get(lineNum);start=pos.start;end=pos.end;line=this._data.substring(start,end+1)}return line};AstMd.prototype._isRefLink=function(line){var line=this._getLine(line);var match=line.match(RE_REFLINK);return match?match[1]:null};AstMd.prototype._getRefLinkPos=function(lineNum,refLink){var line=this._getLine(lineNum);var x=line.indexOf(refLink);var pos=this._lineMap.get(lineNum);var start=pos.start+x;return{line:lineNum,col:x+1,start:start,end:start+refLink.length-1}};AstMd.prototype._setPos=function(ar){return[ar[0]+1,ar[1]]};AstMd.prototype._loadLineMap=function(){let data,map,line=1,lastDisp,i;this._lineMap.clear();data=this._data;map=this._lineMap;if(data.length){lastDisp=0;for(i=0;i<data.length;i++){if(data.charAt(i)==="\n"){map.set(line++,{start:lastDisp,end:i});lastDisp=i+1;if(lastDisp===data.length){return map}}}map.set(line,{start:lastDisp,end:i-1})}return map};AstMd.prototype._createRefs=function(){var line,col,match,ref,start,i,j,x;var link,title,obj;var lineCount=this._lineMap.size;for(i=1;i<=lineCount;i++){line=this._getLine(i);if((x=this._utils.eatWhitespace(line,0))<0){continue}if(line.charAt(x)==="["){if(match=line.match(RE_BRACKET)){match=match[0];j=match.indexOf(":");match=match.substring(0,j+1);ref=match.replace(RE_DEL_BRACKET_COLON,"").trim();x+=match.length;link=line.substr(x).trim();title=undefined;if(link.charAt(0)==="<"){j=link.indexOf(">",1);if(j>=0){title=link.substring(j+1).trim();title=title.replace(/[\'\\(\)"']*/g,"");link=link.substring(1,j)}}else{if((j=this._utils.getIndexToWhitespace(link))>=0){title=link.substring(j+1).trim();title=title.replace(/[\"\'"]/g,"");link=link.substring(0,j)}}col=x+1;for(j=x;j<line.length;j++){if(this._utils.isWhitespace(line.charAt(j))){col++}else{break}}start=this._getLineDisp(i,col);obj={link:link,pos:{line:i,col:col,start:start,end:start+link.length-1}};if(title){obj.title=title}this._refLinks[ref]=obj}}}};function _peekContent(ast,i,type){var o,ret;if(ast[i].markup!=="linkify"){o=ast[i+1];if(o.type===type){ret=o.content}}return ret?ret:""};function _getLevel(level){var val=0;if(level.charAt(0)==="h"){val=level.charCodeAt(1)-48}return val};module.exports=AstMd;