/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const _cmdLine=require("./cmdline");const SUP="\xB9";const ENV_JAF_COLOR="JAF_COLOR";const ENV_JAF_COLOUR="JAF_COLOUR";var Cli=function(nd,cwd,appCtx){this._nd=nd;this._cwd=cwd;this._appCtx=appCtx;this._utils=appCtx.utils;this._fsUtils=appCtx.fsUtils;this._rtf=null;this._clr=appCtx.colors;this._manual=null;this._groupList=null};Cli.prototype.checkArgs=function(rtf,fnShowVersion){this._rtf=rtf;this._showVersion=fnShowVersion;return _cmdLine.checkArgs(this._nd,rtf,this.showHelp.bind(this),fnShowVersion,this._appCtx)};Cli.prototype.checkImmedCmds=function(rtf,JafVersion,fnShowVersion,fnOpenWriter){var ret=1;if(rtf.migrator){let mig=require("./migrator");mig.run(this._cwd,rtf,this._appCtx,fnOpenWriter,JafVersion,fnShowVersion)}else if(rtf.cmdMetaHist){let metahist=require("./metahist");metahist.show(this._nd,this._fsUtils)}else if(rtf.isManual){if(!this._manual){this._manual=require("./manual")}if(this._manual.showBuiltinMsgHelp(this._nd,rtf.manCheckL,rtf.isManPage,this._appCtx)){return 1}ret=-1}else if(rtf.jetverList){this._showJetVerList()}else if(rtf.defList){let defList=require("./deflist");defList.showList(this._nd,this._appCtx.colors)}else if(rtf.cmdNSList){let nslist=require("./nslist");nslist.showNamespaces()}else if(rtf.groupList){if(!this._grouplist){this._grouplist=require("./grouplist")}this._grouplist.showBuiltinGroups(this._nd,rtf.cmdArg,this._appCtx)}else if(rtf.disList){let dislist=require("./dislist");dislist.show(this._nd,rtf.cmdArg,this._appCtx)}else if(rtf.depList){let deplist=require("./deplist");deplist.show(this._nd,rtf.cmdArg,this._appCtx)}else if(rtf.profList){let proflist=require("./proflist");proflist.show(this._nd,rtf.cmdArg,this._appCtx)}else if(rtf.amdList){let amdlist=require("./amdlist");amdlist.show(this._nd,rtf.cmdArg,this._appCtx)}else if(rtf.rloList){let rlolist=require("./rlolist");rlolist.show(this._nd,rtf.cmdArg,this._appCtx)}else if(rtf.betaList){let betalist=require("./betalist");betalist.show(this._nd,rtf.cmdArg,this._appCtx)}else if(rtf.scaffoldRuleSet){return this._nd.scaffoldRule.genRule(this._cwd,rtf.scaffoldRuleSet,this._nd,this._fsUtils)?1:-1}else{ret=0}return ret};Cli.prototype.checkEnvColor=function(){var env,theme;if((env=process.env[ENV_JAF_COLOR])||(env=process.env[ENV_JAF_COLOUR])){env=env.replace(/["']/g,"").toLowerCase().charAt(0);if(env==="y"||env==="t"||env==="d"||env==="l"){theme=env==="l"?"light":"dark"}else{theme="no"}}return theme};Cli.prototype.showExternalGroups=function(ruleSets){if(!this._grouplist){this._grouplist=require("./grouplist")}this._grouplist.showExternalGroups(ruleSets,this._rtf.cmdArg,this._nd,this._appCtx)};Cli.prototype.displayCmdLineOptionsSet=function(){if(this._rtf.verboseMode&&_cmdLine.isCmdLineOptionsSet(this._rtf)){_cmdLine.displayCmdLineOptionsSet(this._rtf,this._appCtx)}};Cli.prototype.showHelp=function(){let help=require("./help");help(this._showVersion,this._appCtx)};Cli.prototype.manualCheckForNonJet=function(rules){if(this._rtf.isManual){if(!this._manual){this._manual=require("./manual")}return this._manual.showExternalMsgHelp(rules,this._rtf.manCheckL,this._rtf.manCheckS,this._nd,this._appCtx)}return false};Cli.prototype.dumpMaintenance=function(metaLib){if(this._rtf.maintenance){if(!this._maint){this._maint=require("./maint")}return this._maint.showMaintenance(metaLib,this._appCtx)}return false};Cli.prototype._showJetVerList=function(){let keys,ver,a,built,isDefVer,list=this._nd.jetver.getVersions(),indent="    \u2022 ";let clr=this._clr;let sup=clr.BRIGHTYELLOW(SUP);keys=Object.keys(list).sort(function(a,b){var va=a.split(".");var vb=b.split(".");va.forEach(function(v,i,a){a[i]=parseInt(v)});vb.forEach(function(v,i,a){a[i]=parseInt(v)});if(va[0]>vb[0]){return 1}if(va[0]<vb[0]){return-1}if(va[1]>vb[1]){return 1}if(va[1]<vb[1]){return-1}if(va[2]>vb[2]){return 1}if(va[2]<vb[2]){return-1}return 0}).reverse();console.log("\n"+"  JET versions supported:");const DEFAULTS=require("./defaults");keys.forEach(function(verName){ver=list[verName];a=verName.split(".");a.forEach(function(s,x){a[x]=parseInt(s)});if(a[0]<10){verName=" "+verName}built="   ("+ver.date+" "+ver.time+")";if(isDefVer=verName===DEFAULTS.JETVER){let def=" Default";built+=clr.BRIGHTYELLOW(def)+sup}verName=isDefVer?clr.BRIGHTYELLOW(verName):clr.CYAN(verName);console.log(indent+verName+built)});let footnote=clr.BRIGHTYELLOW("Default config 'jetVer' value if not specified.");console.log(`\n${sup} ${footnote}`)};Cli.prototype.dumpRules=function(rules,outPath){var ret=false;if(!(this._rtf.dumpRulesSet||this._rtf.dumpRulesJsonSet||this._rtf.dumpRulesSonarSet||this._rtf.dumpRulesInternalSet)){return ret}let ro;if(this._rtf.dumpRulesJsonSet){ro=rules.getRulesJson(true)}else if(this._rtf.dumpRulesSonarSet){ro=rules.getRulesSonar()}else{ro=rules.getRulesProse(this._rtf.dumpRulesInternalSet)}if(ro){if(outPath){let OutFile=require("../lib/outfile");OutFile.writeFileSync(this._nd,outPath,ro)}else{if(this._rtf.dumpRulesJsonSet){console.log(JSON.stringify(ro,null,3))}else{console.log(ro)}}ret=true}return ret};Cli.prototype.displayFinalStats=function(stats,severity,fnConsole,fnInfo,unitTest,useStderr,elapsed){var CliStats=require("./cliStats");var cliStats=new CliStats(this._nd,stats,severity,fnConsole,fnInfo,unitTest,this._appCtx,useStderr);cliStats.displayStatsAndHisto(elapsed);cliStats.displayErrorsAndAsserts()};module.exports=Cli;