/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const PREFIX="jaf-";const JAF_DISABLE="jaf-disable";const JAF_ENABLE="jaf-enable";const JAF_DISABLE_NEXT_LINE="jaf-disable-next-line";const JAF_DISABLE_LINE="jaf-disable-line";const JAF_GROUP="jaf-group";const CMDS=[JAF_DISABLE,JAF_ENABLE,JAF_DISABLE_LINE,JAF_DISABLE_NEXT_LINE,JAF_GROUP];const EOF=Infinity;function Comments(nodeDeps,rules,msgCtx,utils,isTS){this._rules=rules;this._msgCtx=msgCtx;this._utils=utils;this._isTS=isTS;this._comObj={}};Comments.prototype.reset=function(fnAst){if(this._comments){this._comments.length=0}if(this._groups){this._groups.length=0}if(fnAst){this._Ast=fnAst;this._data=fnAst.getData();this._rawComments=fnAst.getRawComments();this._processRawComments();if(this._comments&&this._comments.length){this._rationalize()}}};Comments.prototype.isDisabled=function(node){var index,i,c,ret=null;index=this._isTS?node.range[0]:node.start;if(this._comments){for(i=0;i<this._comments.length;i++){c=this._comments[i];if(c.end!=undefined&&index>=c.start&&index<c.end){this._comObj.rules=c.rules;this._comObj.invert=c.invert;ret=this._comObj;break}}}return ret};Comments.prototype._processRawComments=function(){if(this._isTS){this._SetTSRawPositions()}var i,cmd,raw;raw=this._rawComments;if(raw===undefined){this._comments=null;return}for(i=0;i<raw.length;i++){cmd=this._getCmd(raw[i],this._data);if(!cmd){continue}if(cmd){if(cmd.cmd!==JAF_GROUP){if(!this._comments){this._comments=[]}this._comments.push(cmd)}else{if(!this._groups){this._groups={}}this._groups[cmd.group]=cmd.rules}}}};Comments.prototype._SetTSRawPositions=function(){var rcoms,raw,i;rcoms=this._rawComments;for(i=0;i<rcoms.length;i++){raw=rcoms[i];raw.start=raw.range[0];raw.end=raw.range[1]}};Comments.prototype._rationalize=function(){this._dump();this._check1();this._check2();this._check3();this._check4();this._check5();this._check6();this._check7();this._check8();this._compact()};Comments.prototype._check1=function(){var com,i,prev,haveEnable=false,haveDisable=false,a=this._comments;for(i=0;i<a.length;i++){com=a[i];if(com){if(!com.cmd.startsWith(JAF_ENABLE)){break}a[i]=null}}for(i=0;i<a.length;i++){com=a[i];if(!com){continue}if(com.cmd===JAF_ENABLE){haveDisable=false;if(haveEnable){if(!com.rules){a[i]=null;haveEnable=true;continue}haveEnable=false}}else if(com.cmd===JAF_DISABLE){haveEnable=false;if(haveDisable){if(!com.rules){a[i]=null;haveDisable=true;continue}}haveDisable=false}else{haveEnable=haveDisable=false}}haveDisable=false;for(i=0;i<a.length;i++){com=a[i];if(!com){continue}if(com.cmd===JAF_DISABLE){if(haveDisable){if(!prev.rules&&com.rules){a[i]=null}}else{prev=com;haveDisable=true}}else{haveDisable=false}}this._dump("end check1")};Comments.prototype._check2=function(){var a,com,i,j;a=this._comments;for(i=0;i<a.length;i++){com=a[i];if(com&&com.rules){for(j=0;j<com.rules.length;j++){if(!this._rules.isRuleEnabled(com.rules[j])){com.rules.splice(j,1);j--}}if(!com.rules.length){a.splice(i,1);i--}}}this._dump("end check2")};Comments.prototype._check3=function(){var com,i,len;len=this._comments.length;for(i=0;i<len;i++){com=this._comments[i];if(com&&com.cmd===JAF_DISABLE_LINE){com.start=this._utils.eatWhitespace(this._data,com.start)}}this._dump("end check3")};Comments.prototype._check4=function(){var a,com,prev,lastQ,isLast,c,i,j,x,found=false;a=this._comments;for(i=0;i<a.length;i++){com=a[i];if(!com){continue}isLast=i===_getLast(a);if(com.cmd===JAF_DISABLE){if(!com.rules){for(j=i+1;j<a.length;j++){c=a[j];if(!c){continue}if(c.cmd===JAF_ENABLE){found=true;com.end=c.startX;if(!c.rules){a[j]=null;for(x=i+1;x<j;x++){a[x]=null}}else{c.invert=true;c.cmd=JAF_DISABLE;lastQ=c}i=j;break}else if(c.cmd.startsWith(JAF_DISABLE)){if(!c.rules){a[j]=null}else{com.end=c.startX;i--}break}else{a[j]=null}}if(!found){com.end=EOF}found=false}else{i=this._mergeScope(i)}}else if(com.cmd===JAF_DISABLE_NEXT_LINE||com.cmd===JAF_DISABLE_LINE){if(lastQ&&lastQ.end===undefined){lastQ.end=com.startX}}else if(com.cmd===JAF_ENABLE){prev=this._getPrevComment(i);prev=prev>=0?a[prev]:null;if(prev&&prev.cmd===JAF_DISABLE){if(prev.rules&&!isLast){com.cmd=JAF_DISABLE;if(com.rules){_mergeScopeRules(prev,com,true);com.invert=prev.invert}}else{this._comments.splice(i,1);i--}prev.end=com.start}}}this._dump("end check4")};Comments.prototype._check5=function(){var com,stmt,prev,obj,next,i;for(i=0;i<this._comments.length;i++){com=this._comments[i];if(com&&com.cmd===JAF_DISABLE_NEXT_LINE){stmt=this._Ast.getNodeFromIndex(this._utils.eatWhitespace(this._data,com.start));if(stmt){if(this._isTS){com.start=stmt.range[0];com.end=stmt.range[1]}else{com.start=stmt.start;com.end=stmt.end}}else{this._comments[i]=null;continue}prev=this._getPrevComment(i);prev=prev>=0?this._comments[prev]:null;if(prev&&prev.cmd===JAF_DISABLE){if(prev.end===undefined){prev.end=com.start;next=this._getNextComment(i);obj={cmd:JAF_DISABLE,rules:prev.rules,invert:prev.invert,start:com.end+1,end:next?next.start-1:EOF};this._comments.splice(i+1,0,obj);i++}}}}this._dump("end check5")};Comments.prototype._check6=function(){var com,stmt,prev,obj,next,i;for(i=0;i<this._comments.length;i++){com=this._comments[i];if(com&&com.cmd===JAF_DISABLE_LINE){stmt=this._Ast.getNodeFromIndex(this._utils.eatWhitespace(this._data,com.start));if(stmt){if(this._isTS){com.start=stmt.range[0];com.end=stmt.range[1]}else{com.start=stmt.start;com.end=stmt.end}}else{this._comments[i]=null;continue}prev=this._getPrevComment(i);prev=prev>=0?this._comments[prev]:null;if(prev&&prev.cmd===JAF_DISABLE){if(prev.end===undefined){prev.end=com.start;next=this._getNextComment(i);obj={cmd:JAF_DISABLE,rules:prev.rules,invert:prev.invert,start:com.end+1,end:next?next.start-1:EOF};this._comments.splice(i+1,0,obj);i++}}}}this._dump("end check6")};Comments.prototype._check7=function(){var com,prev,i;i=_getLast(this._comments);if(i>=0){com=this._comments[i];if(com.cmd===JAF_ENABLE){prev=this._getPrevComment(i);this._comments.splice(i,1);i--;prev=prev>=0?this._comments[prev]:null;if(prev&&prev.end===undefined){prev.end=com.start}}}this._dump("end check7");return i};Comments.prototype._check8=function(){var com,haveEOF=false,last,i;for(i=0;i<this._comments.length;i++){com=this._comments[i];if(com){last=com;if(com.end===EOF){if(haveEOF){this._comments[i]=null}else{haveEOF=true}}}}if(!haveEOF&&last&&last.cmd!==JAF_ENABLE&&last.end===undefined){if(this._comments.length){this._comments[this._comments.length-1].end=EOF}}this._dump("end check8")};Comments.prototype._compact=function(){var a=this._comments,i;for(i=0;i<a.length;i++){if(!a[i]){a.splice(i,1);i--}}this._dump("end compact",true)};Comments.prototype._mergeScope=function(i){var a,scope,prev,com,isEnable,isLast;a=this._comments;isLast=i===_getLast(a);com=this._comments[i];isEnable=com.cmd===JAF_ENABLE;scope=this._getPrevScope(i);if(scope<0){return i}scope=a[scope];prev=this._getPrevComment(i);prev=a[prev];if(isEnable||prev.rules){if(isEnable){if(!com.rules){prev.end=com.start;this._comments.splice(i,1);return i-1}com.cmd=JAF_DISABLE}if(com.rules){_mergeScopeRules(prev,com,isEnable);prev.end=com.start}}else{if(prev.end){return i}if(prev.cmd!==JAF_DISABLE){return i}this._comments.splice(i,1);i--}return i};function _mergeScopeRules(prev,com,isEnable){var prevRules,comRules,prevRulesLen,comRulesLen,i;prevRules=prev.rules;comRules=com.rules;prevRulesLen=prevRules?prevRules.length:0;comRulesLen=comRules?comRules.length:0;if(isEnable){if(prevRulesLen){for(i=0;i<prevRules.length;i++){if(!comRules.includes(prevRules[i])){comRules.push(prevRules[i])}}com.invert=prev.invert}else{com.invert=true}}else{if(prevRulesLen&&comRulesLen){if(!prev.invert){for(i=0;i<prevRulesLen;i++){if(!comRules.includes(prevRules[i])){comRules.push(prevRules[i])}}}else{for(i=0;i<comRulesLen;i++){var temp=[];if(!comRules.includes(prevRules[i])){temp.push(prevRules[i])}}com.rules=temp;com.invert=true}}}};Comments.prototype._getPrevComment=function(i){var i;for(--i;i>=0;i--){if(this._comments[i]){break}}return i};Comments.prototype._getPrevScope=function(i){var com,i;for(--i;i>=0;i--){com=this._comments[i];if(com&&com.cmd===JAF_DISABLE){break}}return i};Comments.prototype._getNextComment=function(index){var o;while(++index<this._comments.length){o=this._comments[index];if(o)return o}return null};function _getLast(a){var last=-1,i;for(i=a.length-1;i>=0;i--){if(a[i]){last=i;break}}return last};Comments.prototype._getCmd=function(comment,data){var ret=null,value,cmdIndex,x,cmd,rest,rules,a,i,entry,startOfLine=-1;value=comment.value.trim();if(!value.startsWith(PREFIX)){return null}x=this._utils.getIndexToWhitespace(value,0);cmd=x>=0?value.substring(0,x):value;cmdIndex=CMDS.indexOf(cmd);if(cmdIndex<0){return null}if(cmd===JAF_GROUP){return this._getGroup(value,x)}if(cmd===JAF_DISABLE_LINE){startOfLine=_getStartOfLineIndex(data,comment.start)}ret={cmd:cmd,rules:null,start:startOfLine>=0?startOfLine:comment.end,end:undefined,startX:comment.start,endX:comment.end};rest=x>=0?value.substring(x).trim():"";if(rest.length){a=rest.split(",");for(i=0;i<a.length;i++){entry=a[i];if(entry){entry=entry.trim();if(entry){if(!rules){ret.rules=rules=[]}rules.push(entry)}}}}return ret};function _getStartOfLineIndex(data,index){while(index){if(data.charAt(index)==="\n"){return index+1}index--}};Comments.prototype._getGroup=function(value,x){var group,rules,rule,rest,t,i,j,ret,ruleCount=0,x;rest=x>=0?value.substring(x).trim():"";if(!rest.length){return null}x=rest.charAt(0)==="{"?1:0;t=this._getToken(rest,x);if(t.tok==="STRING"){group=rest.substring(x,t.next)}rest=rest.substring(t.next);i=this._expect(rest,":");if(i>=0){i=this._expect(rest,"[",i);if(i>=0){j=rest.indexOf("]",i);if(j>=0){rules=rest.substring(i,j).trim().split(",");if(rules.length){ret={cmd:JAF_GROUP,group:group,rules:[]};for(i=0;i<rules.length;i++){rule=rules[i].trim();if(rule.length){rule=rule.replace(/\"/g,"");if(!/\s/.test(rule)){if(this._isValidRuleName(rule)){ret.rules.push(rule);ruleCount++}}}}if(ruleCount){return ret}}}}}return null};Comments.prototype._expect=function(str,need,x){var t;t=this._getToken(str,x);if(t.tok===need||t.tok===t.value){return t.next}return-1};Comments.prototype._getToken=function(str,x){var c,raw,len,i,j;i=x|0;len=str.length;for(;i<len;i++){c=str[i];if(this._utils.isWhitespace(c)){continue}if(this._isGroupChar(c)){for(j=i+1;j<len;j++){c=str[j];if(this._isGroupChar(c)){continue}raw=str.substring(i,j);return{tok:"STRING",value:raw,next:j}}}else if(this._utils.isDigit(c)){for(j=i+1;j<len;j++){c=str[j];if(this._utils.isAdigit(c)){continue}raw=str.substring(i,j);return{tok:"NUMBER",value:parseInt(raw),raw:raw,next:j}}}else{return{tok:c,value:c,next:i+1}}}return null};Comments.prototype._isGroupChar=function(c){return this._utils.isAlphaNum(c)||c==="-"||c=="_"};Comments.prototype._isValidRuleName=function(rule){var c,i,len,ret=true;len=rule?rule.length:0;for(i=0;i<len;i++){c=rule.charAt(i);if(!this._isGroupChar(c)||i===0&&this._utils.isDigit(c)){ret=false;break}}return ret};Comments.prototype._dump=function(title,newLine){var show=this._msgCtx.isDebug?this._msgCtx.debug:function(){};var i,j,com,rules,s,len;len=this._comments?this._comments.length:0;show("\nComments"+(title?" ("+title+")":"")+": "+(len===0?" - empty":""));for(i=0;i<len;i++){com=this._comments[i];if(!com){show("["+i+"]");continue}s="";rules=com.rules;if(rules){s="[";for(j=0;j<rules.length;j++){if(j){s+=", "}s+=rules[j]}s+="]";s+=com.invert?":invert":""}show("["+i+"] "+com.cmd+(rules?" "+s:""));show("    ("+com.start+", "+(com.end===EOF?"EOF":com.end)+")  ["+com.startX+", "+com.endX+"]")}if(newLine)show("\n")};module.exports=Comments;