/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
"use strict";const COMPONENT_JSON="component.json";const PROPERTIES="properties";const PROP_SLOTS="slots";const PROP_DYNAMIC_SLOTS="dynamicSlots";const PROP_PROPS="props";const PROP_EVENTS="events";const PROP_STYLECLASSES="styleClasses";const PROP_IMPLEMENTS="implements";const PROP_REQUIRED="required";const PROP_FOLDER="folder";const PROP_VERSION="version";const PROP_UNSUP_THEME="unsupTheme";const PROP_STATUS="status";const PROP_SUBCOMPONENT_TYPE="subcomponentType";const PROP_DEPENDENCIES="dependencies";const PROP_TYPE="type";const PROP_PACK="pack";const PROPERTY_VALUE="propertyValue";const PROPERTY_TYPE="propertyType";const PACK_PRIVATE="packPrivate";const DEPRECATED="deprecated";const MAINTENANCE="maintenance";const SUPERSEDES="supersedes";const ANTIPATTERN="antiPattern";const DYNAMIC_FORM_ELEM="DynamicFormElement";const DYNAMIC_TABLE_ELEM="DynamicTableElement";const VB_FRAGMENT_ELEM="VbFragmentElement";const CUSTOM_ELEMENT="@customElement";const REGISTER_CUSTOM_ELEMENT="registerCustomElement";const OJ_C="oj-c";const DOT=".";const CHANGED="Changed";const FT_HTML="html";const FT_TSX="tsx";const REGXPR=/string|number|object|array|boolean|[\|.<>]/gi;function Components(nd,runMode,cwd,compSvcs,urlBase,urls,filePaths,metaLib,ojcPack,jetCore,runOpts,msgCtx,appCtx){this._nd=nd;this._tagLookup={};this._jetTagLookup={};this._VCompLookup={};this._styleLookup={};this._ojcPathLookup={};this._packs={};this._meta={};this._resources={};this._ignored={};this._maintenance=null;this._supersedes=null;this._antiPattern=null;this._meta={};this._path=null;this._reqAttrs=null;this._metaLib=metaLib;this._ojcPack=ojcPack;this._utils=appCtx.utils;this._fsUtils=appCtx.fsUtils;this._tsUtils=appCtx.tsUtils;this._curFileType=null;this._oConfig=appCtx.config;this._VFilesInspected=null;this._VTypes=null;this._compSvcs=compSvcs;this._isAMD=runMode==="amd";this._cwd=cwd;this._error=msgCtx.error;this._warn=msgCtx.warn;this._debug=msgCtx.debug;this._info=msgCtx.info;this._msg=msgCtx.msg;this._console=msgCtx.console;this._jafMsg=msgCtx.jafMsg;this._isDebug=msgCtx.isDebug;this._isVerbose=msgCtx.isVerbose;this._count=0;this._isOk=true;this._runOpts=runOpts;this._init(urlBase,urls,filePaths,jetCore);if(this._tsUtils){this._initVComponents()}};Components.prototype.isUserTag=function(tagName){var tag=_removeChevrons(tagName);return!!(this._tagLookup[tag]||this._VCompLookup[tag])};Components.prototype.isJetCoreTag=function(tagName){return!!this._jetTagLookup[_removeChevrons(tagName)]};Components.prototype.isVComponentTag=function(tagName){return!!this._VCompLookup[_removeChevrons(tagName)]};Components.prototype.isKnownTag=function(tagName){return!!this._lookupTag(tagName)};Components.prototype._lookupTag=function(tagName){tagName=_removeChevrons(tagName);return this._jetTagLookup[tagName]||this._tagLookup[tagName]||this._VCompLookup[tagName]};Components.prototype.isTagAttr=function(tagName,attrName){return this.isTagProp(tagName,attrName)||this.isJetTagProp(tagName,attrName)};Components.prototype.isJetTagAttr=function(tagName,attrName){return this.isJetTagProp(tagName,attrName)};Components.prototype.isTagDeprecated=function(tag){var comp,stats,status,ret=null;if(comp=this._lookupTag(_removeChevrons(tag))){if(stats=comp.status){for(status of stats){if((!status.type||status.type===DEPRECATED)&&!status.hasOwnProperty("target")){ret=status;if(ret.description){ret.description=this._utils.removeLink(ret.description)}break}}}}return ret};Components.prototype.isTagAttrDeprecated=function(tagName,attrName){var prop,status,stats,o,ret=null;if((prop=this.getAnyTagProp(tagName,attrName))&&(stats=prop.status)){ret=[];for(status of stats){if(!status.type||status.type===DEPRECATED){o={type:DEPRECATED};if(status.hasOwnProperty("target")){o.target=status.target}if(status.hasOwnProperty("description")){o.description=status.description}if(status.hasOwnProperty("since")){o.since=status.since}if(status.hasOwnProperty("value")){o.value=status.value}ret.push(o)}}ret=ret.length?ret:null}return ret};Components.prototype.isTagEventDeprecated=function(tagName,eventName){var event,stats,ret=null;if(event=this.getAnyTagEvent(tagName,eventName)){if(stats=event.status){stats.forEach(stat=>{if(!stat.type||stat.type===DEPRECATED){if(!ret){ret=[]}ret.push(stat)}})}}return ret};Components.prototype.getTagPropertyFromEvent=function(tagName,eventName){var o,ret;if(o=this.getTagEventName(tagName,eventName)){ret=o.name}return ret?ret:null};Components.prototype.isTagAttrTranslatable=function(tag,attr){var prop=this.getAnyTagProp(tag,attr);return prop&&prop.translatable};Components.prototype.isTagAttrReadOnly=function(tag,attr){var prop=this.getAnyTagProp(tag,attr);return prop&&prop.readonly};Components.prototype.isTagAttrWriteback=function(tag,attr){var prop=this.getAnyTagProp(tag,attr);return prop&&prop.writeback};Components.prototype.isTagProp=function(tagName,propName){return!!this.getTagProp(tagName,propName)};Components.prototype.isJetTagProp=function(tagName,propName){return!!this.getJetTagProp(tagName,propName)};Components.prototype.getTagProp=function(tagName,propName){var ret;if(this.isUserTag(tagName)){ret=this._getTagProp(tagName,propName,false)}return ret?ret:null};Components.prototype.getJetTagProp=function(tagName,propName){var ret;if(this.isJetCoreTag(tagName)){ret=this._getTagProp(tagName,propName,true)}return ret?ret:null};Components.prototype.getAnyTagProp=function(tagName,propName){return this._getTagProp(tagName,propName,true)||this._getTagProp(tagName,propName,false)};Components.prototype._getTagProp=function(tagName,propName,isOJC){var tag,props,list;tagName=_removeChevrons(tagName);if(isOJC){tag=this._jetTagLookup[tagName]}else{tag=this._tagLookup[tagName]||this._VCompLookup[tagName]};props=tag?tag[PROP_PROPS]:null;if(props){propName=propName.charAt(0)===":"?propName.substring(1):propName;if(this._curFileType!=="tsx"){propName=_propToCamelCase(propName)}}return props?props[propName]:null};Components.prototype.getTagPropType=function(tagName,propName){var prop,ret;if(prop=this.getTagProp(tagName,propName)){ret=prop?prop.type:undefined}return ret};Components.prototype.getAnyTagEvent=function(tag,event){return this._getTagEvent(tag,event,true)||this._getTagEvent(tag,event,false)};Components.prototype._getTagEvent=function(tagName,eventName,isOJC){var tagObj,events,event;if(!eventName.startsWith("on")){return null}tagName=_removeChevrons(tagName);if(isOJC){tagObj=this._jetTagLookup[tagName]}else{tagObj=this._tagLookup[tagName]||this._VCompLookup[tagName]}if(!tagObj){return null}if(!(events=tagObj[PROP_EVENTS])){return null}if(eventName.includes("-")){eventName=eventName.substring(3);eventName=_propToCamelCase(eventName)}else{eventName=eventName.substring(2)}event=events[eventName];return event?event:null};Components.prototype.getComponentPropMetadata=function(tagName,propName){var comp,sofar,props;tagName=_removeChevrons(tagName);if(!(comp=this._meta[tagName])||!(props=comp.properties)){return null}let subprops=propName.split(DOT);if(this._curFileType===FT_HTML){subprops.forEach((subprop,i,ar)=>{ar[i]=_propToCamelCase(subprop)})}if(subprops.length===1){return props[propName]||null}sofar=comp;let nextprop,i;for(i=0;i<subprops.length;i++){nextprop=subprops[i];if(sofar.hasOwnProperty(PROPERTIES)){sofar=sofar.properties[nextprop]||null;if(!sofar){break}}else{sofar=null;break}}return sofar};Components.prototype.getComponentMetadata=function(tag){return this._meta[tag]||null};Components.prototype.getAllCustomMetadata=function(){var name,comp,obj;var ret={};var i=2;var lookup=this._tagLookup;while(i){for(name in lookup){ret[name]=obj={};comp=lookup[name];obj.folder=comp.folder;obj.json=this.getComponentMetadata(name);if(i===1){obj.VCType=this._VTypes[name]}}i--;lookup=this._VCompLookup}return ret};Components.prototype.getJetTag=function(tag){var o;return(o=this._jetTagLookup[tag])?o:null};Components.prototype.getMaintenanceTags=function(){return this._maintenance};Components.prototype.isTagEvent=function(tagName,eventName){return!!this.getTagEventName(tagName,eventName)};Components.prototype.getTagEventName=function(tagName,eventName){var propName,tagObj,events,impls;tagObj=this._lookupTag(_removeChevrons(tagName));if(!tagObj||!eventName.startsWith("on")){return null}if(eventName.includes("-")){eventName=eventName.substring(3);eventName=_propToCamelCase(eventName)}else{eventName=eventName.substring(2)}if(tagObj.events&&tagObj.events[eventName]){return{type:"event",name:eventName}}if((impls=tagObj.implements)&&(impls.includes(DYNAMIC_FORM_ELEM)||impls.includes(DYNAMIC_TABLE_ELEM)||impls.includes(VB_FRAGMENT_ELEM))){return{type:"dynamic",name:eventName}}if(eventName.endsWith(CHANGED)&&tagObj.props){propName=eventName.replace(CHANGED,"");if(tagObj.props[propName]){return{type:"property",name:propName}};}return null};Components.prototype.isTagStyle=function(tag,style){var tagObj,ret=false;if(tagObj=this._lookupTag(_removeChevrons(tag))){let styles;if(styles=tagObj.styleClasses){ret=!!styles[style]}}return ret};Components.prototype.isJetStyle=function(style){var tag,ret=false;if(tag=this._styleLookup[style]){ret=!!this._jetTagLookup[tag]}return ret};Components.prototype.isStyle=function(style){return!!this._styleLookup[style]};Components.prototype.getStyleMetadata=function(style){var tag,styles,sc,ret=null;if(tag=this._styleLookup[style]){if(styles=this._tagLookup[tag].styleClasses){if(sc=styles[style]){ret={tag:tag,meta:sc}}}}return ret};Components.prototype.getStyleSelector=function(style){var sm=this.getStyleMetadata(style);return sm&&sm.meta?sm.meta.styleSelector:null};Components.prototype.hasTagSlotName=function(tagName,slotName){var o=this._lookupTag(_removeChevrons(tagName));return!!(o&&o.slots&&o.slots[slotName])};Components.prototype.getPreferredSlotContent=function(tag,slotName,impls){var o,slot,prefContent=null,comps=null,content;if(this._utils.hasAnyProps(impls)){if(o=this._lookupTag(_removeChevrons(tag))){if(o.slots){slotName=slotName?slotName:"";if(slot=o.slots[slotName]){if((prefContent=slot.preferredContent)&&prefContent.length){prefContent.forEach(impl=>{if(content=impls[impl]){if(!comps){comps=[]}comps.push(...content)}})}else{prefContent=null}}}}}return prefContent||comps?{interfaces:prefContent,components:comps}:null};Components.prototype.getTagSlotMetadata=function(tag,slot){var o,ret;if(o=this._lookupTag(_removeChevrons(tag))){if(o.slots){slot=slot?slot:"";if(slot=o.slots[slot]){ret=slot}}}return ret};Components.prototype.getPackPaths=function(){return Object.keys(this._packs)};Components.prototype.getPackMetadata=function(packName){return this._packs[packName]||null};Components.prototype.getAllPackMetadata=function(){return this._packs||null};Components.prototype.getResourcePaths=function(){return Object.keys(this._resources)};Components.prototype.getAllResourceMetadata=function(){return this._resources||null};Components.prototype.getResourceMetadata=function(path){return this._resources[path]||null};Components.prototype.getOjcMetadataByPath=function(path){return this._ojcPathLookup[path]||null};Components.prototype.hasTagDynamicSlot=function(tag){var o,ret=false;if(o=this._lookupTag(_removeChevrons(tag))){ret=o.hasOwnProperty(PROP_DYNAMIC_SLOTS)}return ret};Components.prototype.hasTagAttrValues=function(tagName,attrName){var prop,ret=false;if((prop=this.getTagProp(tagName,attrName))||(prop=this.getJetTagProp(tagName,attrName))){ret=!!prop.enumValues}return ret};Components.prototype.isTagAttrValue=function(tagName,attrName,value){var prop,ret;if((prop=this.getTagProp(tagName,attrName))||(prop=this.getJetTagProp(tagName,attrName))){if(prop&&prop.enumValues){ret=prop.enumValues.indexOf(value)>=0}}return!!ret};Components.prototype.isTagAttrEnumDeprecated=function(tag,attr,val){var prop,stats,status,ret=null;if(prop=this.getAnyTagProp(tag,attr)){if(stats=prop.status){for(status of stats){if((!status.type||status.type===DEPRECATED)&&status.target===PROPERTY_VALUE){if(status.value&&status.value.includes(val)){ret={type:DEPRECATED};if(status.hasOwnProperty("target")){ret.target=status.target}if(status.hasOwnProperty("description")){ret.description=status.description}if(status.hasOwnProperty("since")){ret.since=status.since}if(status.hasOwnProperty("value")){ret.value=status.value}break}}}}}return ret};Components.prototype.isTagSupportedInTheme=function(tag,theme){var o,unsup,ret=true;if(o=this._lookupTag(tag)){if(unsup=o[PROP_UNSUP_THEME]){ret=!unsup.includes(theme)}}return ret};Components.prototype.isAttrSupportedInTheme=function(tag,attr,theme){var prop,unsup,ret=true;if(prop=this.getAnyTagProp(tag,attr)){if(unsup=prop[PROP_UNSUP_THEME]){ret=!unsup.includes(theme)}}return ret};Components.prototype.isTagPackPrivate=function(tag){var o,ret=false;if(o=this._lookupTag(_removeChevrons(tag))){ret=o[PROP_SUBCOMPONENT_TYPE]===PACK_PRIVATE}return ret};Components.prototype.getSubcomponentType=function(tag){var o,ret;if(o=this._lookupTag(_removeChevrons(tag))){ret=o[PROP_SUBCOMPONENT_TYPE]}return ret||null};Components.prototype.getRequiredProps=function(tagName){var tag,props,prop,propName,obj,ret=null;tagName=_removeChevrons(tagName);if(this._reqAttrs){let r=this._reqAttrs[tagName];if(r){return typeof r==="boolean"?null:r}}tag=this._lookupTag(tagName);if(tag&&tag.props){if(!this._reqAttrs){this._reqAttrs={}}if(!this._reqAttrs[tagName]){this._reqAttrs[tagName]=true}props=tag.props;for(propName in props){prop=props[propName];if(prop.required){if(!obj){obj=[]}obj.push(propName)}}}if(obj&&obj.length){let i,j,p;for(i=0;i<obj.length;i++){if(p=obj[i]){p+=".";for(j=i+1;j<obj.length;j++){if(obj[j].startsWith(p)){obj.splice(i,1);i--;break}}}}this._reqAttrs[tagName]=obj;ret=obj}return ret};Components.prototype.getRequiredAttrs=function(tagName){return this.getRequiredProps(tagName)};Components.prototype.getInterfaces=function(tag){var o,ret;if(o=this._lookupTag(_removeChevrons(tag))){ret=o.implements}return ret?ret:null};Components.prototype.getCount=function(){return this._count};Components.prototype.isTagStatus=function(tag,statType){return!!this._getTagStatus(tag,statType)};Components.prototype.getTagStatus=function(tag,statType){var ret=null,omitted=statType===undefined;var comp,arStat,stat,stType,i;if(comp=this._lookupTag(_removeChevrons(tag))){if(arStat=comp.status){for(i=0;i<arStat.length;i++){stat=arStat[i];stType=stat.type||DEPRECATED;if(omitted||stType===statType){if(!ret){ret=[]}ret.push(stat)}}}}return ret};Components.prototype.getPropStatus=function(tagName,propName,statType){let comp,arStat,ret;if(comp=this._lookupTag(_removeChevrons(tagName))){if(comp.props&&(arStat=comp.props[propName]?.status)){let stat,stType,i,omitted=statType===undefined;for(i=0;i<arStat.length;i++){stat=arStat[i];stType=stat.type||DEPRECATED;if(omitted||stType===statType){if(!ret){ret=[]}ret.push(stat)}}}}return ret?ret:null};Components.prototype.isRuleIgnored=function(compName,ruleName){var ret,ar;if(ar=this._ignored[compName]){ret=ar.includes(ruleName)}return!!ret};Components.prototype.isOk=function(){return this._isOk};Components.prototype.setCurFileType=function(ft){this._curFileType=ft};Components.prototype._init=function(base,urls,filePaths,$jetCore){if(this._isAMD){this._processJetCorePack();return}if(base){base=base.trim();if(base.charAt(base.length-1)!=="/"){base=base+"/"}}else{base=""}this._processFilePaths(filePaths);this._processUrls(base,urls);this._processJetCorePack();this._createStyleLookup();this._processJetCore($jetCore)};Components.prototype._processFilePaths=function(filePaths){var obj,compEntry,fpath,i,j;if(!filePaths){return}this._console("\nPre-processing user-declared web component metadata...");for(i=0;i<filePaths.length;i++){compEntry=filePaths[i];var dirStack=this._nd.glob.sync(compEntry);for(j=0;j<dirStack.length;j++){fpath=dirStack[j];if(this._runOpts.isDryRun||this._runOpts.isDebug){let msg="-".repeat(70)+"\n"+(this._runOpts.isDryRun?"* ":"")+"processing component path '"+fpath+"' ...";if(this._runOpts.isDryRun){console.log(msg)}else{this._debug(msg)}}if(fpath.toLowerCase().endsWith(".zip")){obj=this._compSvcs._extractComponentJsonFromZip(fpath);if(obj.obj){this.processComponentJson(obj.obj,fpath)}else if(obj.msg){this._error("Failed to parse component.json : "+obj.msg+" - "+fpath)}else if(obj.error){this._error("Failed to unzip '"+fpath+"'")}continue}if(this._isComponentJsonPath(fpath)){if(obj=this._readComponentJson(fpath)){if(obj.type&&obj.type==="pack"){continue}this.processComponentJson(obj,this._nd.path.dirname(fpath))}continue}this._recurse(fpath)}}if(this._isDebug){this._debug("-".repeat(70))}};Components.prototype._recurse=function(fpath){var dirs,inFile,inFilePath,obj,i;try{dirs=this._nd.fs.readdirSync(fpath);if(this._isDebug){this._debug(`  processing ${fpath}  ${dirs.length} component dirs ...`)}for(i=0;i<dirs.length;i++){inFile=dirs[i];if(inFile===COMPONENT_JSON){inFilePath=this._nd.path.join(fpath,COMPONENT_JSON);if(this._isDebug){this._debug("  processing "+inFilePath+"...")}obj=this._readComponentJson(inFilePath);if(obj){if(!obj.type||obj.type==="composite"){this.processComponentJson(obj,fpath)}else if(obj.type==="resource"){this._resources[obj.pack+"/"+obj.name]=obj}else if(obj.type==="pack"){this._packs[obj.name]=obj}}else{return}}var curPath=this._nd.path.join(fpath,inFile);if(this._fsUtils.getFileType(curPath)==="d"){this._recurse(curPath)}}}catch(e){this._error("Component check failed - "+e);this._isOk=false}};Components.prototype._processUrls=function(base,urls){var url,i;if(!urls){return}for(i=0;i<urls.length;i++){url=urls[i];if(this._runOpts.isDryRun||this._runOpts.isDebug){let msg;msg="-".repeat(70)+"\nprocessing URL '"+url+"'";if(this._runOpts.isDryRun){console.log(msg);continue}else{this._debug(msg)}}if(_isRelativeUrl(url)){url=base+url;if(_isRelativeUrl(url)){this._error("component URL incomplete - '"+url+"'");continue}}this._processUrl(url)}};Components.prototype._processUrl=function(url){var resp,obj,rc,tempFile,tmp;try{resp=this._compSvcs.loadUrl(url);if(resp.eCode==="ETIMEDOUT"){this._error("config.componentUrls - request timed-out for '"+url+"'");this._isOk=false;return}try{if(resp.type==="json"){if(resp.body){obj=JSON.parse(resp.body);if(!this.processComponentJson(obj,url)){this._isOk=false}}else{this._error("Server responded with "+resp.statusCode+" URL: '"+url+"'")}}else if(resp.type=="zip"){rc=this._compSvcs.writeZipBufferToFile(resp.body);if(typeof rc==="boolean"&&rc){tempFile=this._compSvcs.getLastZipFilePath();obj=this._compSvcs.extractComponentJsonFromZip(tempFile);if(obj.obj){this.processComponentJson(obj.obj,url)}else if(obj.msg){this._error("Failed to parse component.json : "+obj.msg+" - "+url)}else if(obj.error){this._error("Failed to unzip '"+url+"'")}this._compSvcs.deleteZipFile(tempFile)}else{this._error("Failed to create local temp zip file from URL '"+url+"' : rc.message");this._isOk=false}}else{tmp=typeof resp.type==="string"?resp.type:"?";this._error("Server responded with unexpected data ('"+tmp+"') : '"+url+"'");this._isOk=false}}catch(e){this._error("Invalid JSON - URL '"+url+"'  : "+e);this._isOk=false}}catch(e1){this._error("URL access failed "+(e1.message.includes("ENOTFOUND")?"(NOT FOUND)":"")+" - URL '"+url+"'");this._isOk=false}};Components.prototype._processJetCorePack=function(){var comps,comp;if(comps=this._ojcPack.getComponents()){for(comp in comps){this.processComponentJson(comps[comp],"oj-c")}}};Components.prototype.processComponentJson=function(obj,fromLocation,vcomp){var comp,props,events,event,eventName,compName,metaObj;var isOJC;compName=obj.pack?obj.pack+"-"+obj.name:obj.name;isOJC=obj.pack===OJ_C;if(!this._isAMD){if(this._runOpts.isDryRun){console.log("  Would have processed '"+fromLocation+"'");return}if(obj.type&&obj.type==="pack"){return this._processJetPack(obj,fromLocation)}if(!isOJC&&!vcomp){if(!this._compSvcs.validateComponentJson(obj,fromLocation)){this._isOk=false;return false}}if(isOJC){this._ojcPathLookup[obj.main]=obj}}if(this._lookupTag(compName)){this._jafMsg("jaf-sys-dup-component",`Ignoring duplicate component '${compName}' at '${fromLocation}'`,"W");return true}this._meta[compName]=obj;(isOJC?this._jetTagLookup:vcomp?this._VCompLookup:this._tagLookup)[compName]=comp={};comp[PROP_FOLDER]=fromLocation;comp[PROP_VERSION]=obj.version;if(obj.extension&&obj.extension.audit&&obj.extension.audit.ignore){let ar;if((ar=obj.extension.audit.ignore)&&ar.length){this._ignored[compName]=[...ar]}}if(obj.hasOwnProperty(PROP_SLOTS)){comp[PROP_SLOTS]=obj[PROP_SLOTS]}if(obj.hasOwnProperty(PROP_DYNAMIC_SLOTS)){comp[PROP_DYNAMIC_SLOTS]=obj[PROP_DYNAMIC_SLOTS]}if(obj.properties){comp[PROP_PROPS]=props={};this._extractProps(props,null,obj.properties,obj.name)}if(obj.events){comp[PROP_EVENTS]=events={};for(event in obj.events){events[event]=obj.events[event];metaObj=obj.events}}if(obj.implements){comp[PROP_IMPLEMENTS]=obj.implements;this._metaLib.processImplements(compName,obj.implements)}if(obj.status){let status,i;metaObj=obj.status;for(i=0;i<metaObj.length;i++){status=metaObj[i];if(status.type===MAINTENANCE){if(!this._maintenance){this._maintenance=new Set}this._maintenance.add(compName)}else if(status.type===SUPERSEDES){if(!this._supercedes){this._supersedes=new Set}this._supersedes.add(compName)}else if(status.type===ANTIPATTERN){if(!this._antiPattern){this._antiPattern=new Set}this._antiPattern.add(compName)}}}if(obj.extension&&obj.extension.theme&&obj.extension.theme.unsupportedThemes){comp[PROP_UNSUP_THEME]=obj.extension.theme.unsupportedThemes}if(obj.hasOwnProperty(PROP_SUBCOMPONENT_TYPE)){comp[PROP_SUBCOMPONENT_TYPE]=obj[PROP_SUBCOMPONENT_TYPE]}if(obj.hasOwnProperty(PROP_DEPENDENCIES)){comp[PROP_DEPENDENCIES]=obj[PROP_DEPENDENCIES]}if(obj.type){comp[PROP_TYPE]=obj.type}if(obj.pack){comp[PROP_PACK]=obj.pack}if(obj.hasOwnProperty("required")){comp[PROP_REQUIRED]=obj.required}if(obj.status){comp[PROP_STATUS]=obj.status}if(obj.styleClasses){comp[PROP_STYLECLASSES]=this._extractStyles(obj.styleClasses)}this._count++;return true};Components.prototype._extractProps=function(propObj,propSoFar,properties,name,rdonly){var prop,thisProp,soFar,obj;for(prop in properties){soFar=(propSoFar?propSoFar+DOT:"")+prop;propObj[soFar]=obj={};thisProp=properties[prop];if(thisProp.hasOwnProperty("enumValues")){if(Array.isArray(thisProp.enumValues)){obj.enumValues=thisProp.enumValues}else{this._error(`Web component '${name}' property '${soFar}' has invalid 'enumValues' in component.json`)}}if(thisProp.hasOwnProperty("status")){obj.status=thisProp.status}if(thisProp.hasOwnProperty("type")){obj.type=thisProp.type}if(thisProp.required){obj.required=true}if(thisProp.extension&&thisProp.extension.theme&&thisProp.extension.theme.unsupportedThemes){obj[PROP_UNSUP_THEME]=thisProp.extension.theme.unsupportedThemes}if(thisProp.hasOwnProperty("translatable")){obj.translatable=true}if(typeof thisProp.readOnly==="boolean"){obj.readOnly=thisProp.readOnly}else{if(rdonly){obj.readOnly=true}}if(thisProp.hasOwnProperty("writeback")){obj.writeback=thisProp.writeback}if(thisProp.hasOwnProperty("properties")){obj.properties=true;this._extractProps(propObj,soFar,thisProp.properties,name,obj.readOnly)}}};Components.prototype._extractStyles=function(styleClasses){var so,si,obj,ret={},i,j;if(!Array.isArray(styleClasses)){return ret}for(i=0;i<styleClasses.length;i++){so=styleClasses[i];if(so.kind==="class"){ret[so.name]=this._extractStyleClass(so)}else if(so.kind==="set"&&so.styleItems&&Array.isArray(so.styleItems)){ret[so.name]=obj={kind:"set"};if(so.status){obj.status=so.status}obj.styleClasses={};for(j=0;j<so.styleItems.length;j++){si=so.styleItems[j];obj.styleClasses[si.name]=this._extractStyleClass(si)}}else if(so.kind==="template"){}}return ret};Components.prototype._extractStyleClass=function(so){var obj={};if(so.styleSelector){obj.styleSelector=so.styleSelector}if(so.status){obj.status=so.status}return obj};Components.prototype._processJetPack=function(obj,fromLocation){var deps,dep,urlKey,depUrl,msg,i;if(this._runOpts.isDryRun||this._runOpts.isDebug){msg="processing JET Pack "+obj.name+" (version: "+obj.version+") : '"+fromLocation+"'";if(this._runOpts.isDryRun){console.log("* "+msg);return}else{this._debug(msg)}}if(!fromLocation.includes("http")){this._error("JET packs loaded via config 'components' property (file based) are currently not supported");return false}i=fromLocation.indexOf(obj.name);if(i>=0){urlKey=fromLocation.substring(0,i)}else{this._error("Cannot handle Jet Pack URL format to load dependencies : "+fromLocation)}deps=obj.dependencies;if(deps){for(dep in deps){depUrl=urlKey+dep+"/versions/"+obj.dependencies[dep]+"/content/component.json";if(this._isDebug){this._debug(`  processing dependency ${dep}  ${obj.dependencies[dep]}`)}this._processUrls("",[depUrl])}}return false};Components.prototype._processJetCore=function(jetCorePath){var files,file,obj,i;if(!jetCorePath){return}this._console("-".repeat(70)+"\nPerforming schema analysis on JET Core components (dt) using '"+this._compSvcs.getSchemaName()+"'...");try{files=this._nd.fs.readdirSync(jetCorePath);this._console(`   processing ${files.length} $jetCore components...`);for(i=0;i<files.length;i++){file=files[i];if(file.endsWith(".json")){file=this._nd.path.join(jetCorePath,file);try{obj=this._readComponentJson(file);if(obj){this._compSvcs.validateComponentJson(obj,file)}}catch(e){}}}}catch(e1){this._error("!!! $JetCore Component check failed - "+e1)}this._console("   processing "+(files?files.length+" ":"")+"$jetCore components completed");this._console("-".repeat(70))};Components.prototype._initVComponents=function(){let precompileCache,tscript;const preComp=this._tsUtils.getPreCompiler();const preCompUtils=this._tsUtils.getUtils();const auditBase=this._fsUtils.toJAFPath(this._oConfig.getBase());const projectPathInfo=preCompUtils.getKeyPathInfo(auditBase);if((tscript=this._oConfig.getTypescript())&&tscript.compile&&projectPathInfo.tsSource){this._console("Pre-processing VComponents...");if(!(precompileCache=preComp.getPrecompileCache(auditBase,projectPathInfo.tsSource,projectPathInfo.componentRootFolder))){return}if(!this._fsUtils.pathExistsSync(precompileCache)){this._debug(`VComponents: precompileCache not created - ${precompileCache}`)}else{this._getVComponentJson(precompileCache)}}};Components.prototype._getVComponentJson=function(jsonDir){var contents;if(contents=this._fsUtils.readDirSync(jsonDir)){let json;this._VFilesInspected=[];this._VTypes={};contents.forEach(file=>{if(file.isFile){json=this._fsUtils.readJsonSync(this._nd.path.join(jsonDir,file.name),false,false);if(typeof json==="string"){this._error(`Compiled metadata for x - ${json}`)}else{if(this._isDebug){this._debug(`Post compilation VComponent found : ${json.name}`)}this.processComponentJson(json,this._getVCompFolder(json.name),true)}}});this._VFilesInspected=null}};Components.prototype._getVCompFolder=function(name){var files,file,folder,ret=null,x,_self=this;const preComp=this._tsUtils.getPreCompiler();const srcFiles=preComp.getVFiles();if(srcFiles){for(file of srcFiles){if(this._VFilesInspected.includes(file)){continue}let src,VType;function _fail(errMsg){_self._warn(`Unexpected read error of '${file}'`)}if(!(src=this._fsUtils.readFileSync(file,_fail))){continue}if(!(VType=this._isVCompSrc(src,name))){continue}this._VFilesInspected.push(file);this._VTypes[name]=VType;ret=this._nd.path.dirname(file);break}}return ret};Components.prototype._isVCompSrc=function(src,name){var ret,start=0,utils=this._utils;function _extractCompName(data,x,closeDelim){let x2,comp,match=false;if((x=utils.eatWhitespace(data,x))>=0){if(data.charAt(x)==="("){if((x=utils.eatWhitespace(data,x+1))>=0){if((x2=data.indexOf(closeDelim,x))>=0){comp=data.substring(x,x2).trim();comp=comp.substring(1,comp.length-1);match=comp===name}}}}return match}while(start<src.length){let i;if((i=src.indexOf(CUSTOM_ELEMENT,start))>=0){start=i+=CUSTOM_ELEMENT.length;if(ret=_extractCompName(src,i,")")){return"class"}continue}else if((i=src.indexOf(REGISTER_CUSTOM_ELEMENT,start))>=0){start=i+=REGISTER_CUSTOM_ELEMENT.length;if(ret=_extractCompName(src,i,",")){return"func"}continue}break}return null};Components.prototype._createStyleLookup=function(){var tag,o,scl,st;for(tag in this._tagLookup){o=this._tagLookup[tag];if(scl=o.styleClasses){for(st in scl){this._styleLookup[st]=tag}}}};Components.prototype._readComponentJson=function(inFile){var obj=null;if(this._isDebug){this._debug(`  loading '${inFile}'`)}obj=this._nd.jsonLoader.load(inFile,this._nd,this._error,false,this._utils);if(!obj){this._isOk=false}return obj};Components.prototype._isComponentJsonPath=function(filePath){return filePath.toLowerCase().endsWith(COMPONENT_JSON)};Components.prototype.dumpComponentNames=function(){var names,keys;this._dumpComponentNames(this._tagLookup,"--------- Declared Web Components ---------","No valid user (non-VComponent) components declared!","-------- End Declared Web Components ---------");this._dumpComponentNames(this._VCompLookup,"--------- Discovered VComponents ---------","No VComponents found!","-------- End Discovered VComponents ---------");this._dumpComponentNames(this._jetTagLookup,"--------- Declared JET OJ-C Pack Web Components ---------","No valid user JET Core Pack components declared!","-------- End Declared OJ-C Pack Web Components ---------")};Components.prototype._dumpComponentNames=function(lookup,start,none,end){var keys,meta,impls,isOJC=start.includes("OJ-C");const INFO="[info]";keys=Object.keys(lookup);if(!keys.length){this._console(`${INFO}  ${none}\n`,"I");return}this._console(`${INFO} ${start}`,"I");if(isOJC&&this._isVerbose){this._console(`${INFO}   ${keys.length} JET CorePack components loaded`,"I")}else{keys.forEach(key=>{meta=lookup[key];this._console(`${INFO}   ${key}  (${meta.version})`,"I");impls=meta.implements&&meta.implements.length?meta.implements.join(", "):"none declared";this._console(`${INFO}      Impls: ${impls}`)})}this._console(`${INFO} ${end}\n`,"I")};function _isTagStatusType(statType){return type===SUPERSEDES||type===MAINTENANCE||type===DEPRECATED||type===ANTIPATTERN};function _propToKebabCase(str){return str.replace(/([a-z0-9])([A-Z])/g,"$1-$2").replace(/([A-Z])([A-Z])(?=[a-z])/g,"$1-$2").toLowerCase()};function _propToCamelCase(str){var parts,i;function _camelCase(str){return str.replace(/(?:^\w|[A-Z]|\b\w)/g,function(word,index){return index==0?word.toLowerCase():word.toUpperCase()}).replace(/-|\s+/g,"")};parts=str.split(DOT);for(i=0;i<parts.length;i++){parts[i]=_camelCase(parts[i])}return parts.join(DOT)};function _isRelativeUrl(url){url=url.toLowerCase();return!(url.indexOf("http://")===0||url.indexOf("https://")===0)};function _removeChevrons(tagName){if(tagName){let len=tagName.length-1;let start=tagName.charAt(0)==="<"?1:0;let end=tagName.charAt(len)===">"?len:++len;tagName=tagName.substring(start,end)}return tagName};module.exports=Components;