/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const clone=require("./clone");const ONMSG="onMsg";var RulePack=function(packSummary,rulePacks,shadPacks,rsi,appCtx){this._rulePacks=rulePacks;this._shadPacks=shadPacks;this._summary=packSummary;this._rsi=rsi;this._appCtx=appCtx;this._ruleCtx=null;this._extension=null;this._count=-1;this._activeCount=-1};RulePack.prototype.getPackInfo=function(){var rpinfo=this._summary[this._rsi];return{title:rpinfo.title,path:rpinfo.path,version:rpinfo.version,prefix:rpinfo.prefix,status:rpinfo.status,packData:rpinfo.packData}};RulePack.prototype.getPrefix=function(){var s=this._summary[this._rsi].prefix;return s.slice(0)};RulePack.prototype.getRuleOptions=function(ruleName,prefix,internal){var rsi,rp,opts;if(!this._ruleCtx){this._appCtx.assert("getRuleOptions - Missing rulepack ctx");if(!ruleName)return null}ruleName=ruleName||this._ruleCtx.ruleName;if(prefix){rsi=this._getRsiByPrefix(prefix);if(rsi<0){return null}}else{rsi=this._rsi}rp=this._rulePacks[rsi];opts=rp.rulesJson.rules[ruleName];return opts?internal?opts:clone.cloneOptions(opts):null};RulePack.prototype.getRuleOption=function(property,ruleName,prefix){var rsi,rp,opts;ruleName=ruleName||this._ruleCtx.ruleName;if(prefix){rsi=this._getRsiByPrefix(prefix);if(rsi<0){return null}}else{rsi=this._rsi}rp=this._rulePacks[rsi];opts=rp.rulesJson.rules[ruleName];return opts?clone.cloneProperty(opts[property]):null};RulePack.prototype.getRuleCustomOptions=function(ruleName,prefix,internal){var opts;if(opts=this.getRuleOptions(ruleName,prefix,internal)){opts=opts.customOpts}return opts||{}};RulePack.prototype.getRuleCustomOption=function(property,ruleName,prefix){var rsi,rp,opts;ruleName=ruleName||this._ruleCtx.ruleName;if(prefix){rsi=this._getRsiByPrefix(prefix);if(rsi<0){return null}}else{rsi=this._rsi}rp=this._rulePacks[rsi];opts=rp.rulesJson.rules[ruleName].customOpts;return opts?clone.cloneProperty(opts[property]):null};RulePack.prototype.setRuleOptions=function(name,opts){var o,prop,ret=false;if(this._ruleCtx._rsi!==this._rsi){return false}name=name||this._ruleCtx.ruleName;if(!name){return false}if(opts&&typeof opts==="object"&&!Array.isArray(opts)){o=this.getRuleOptions(name);if(o){for(prop in opts){if(prop.charAt(0)==="$"||prop==="name"){continue}if(prop==="enabled"){if(opts.enabled){if(o.enabled){continue}this.enableRule(name)}else{if(o.enabled){this.disableRule(name)}}}o[prop]=opts[prop];ret=true}}}return ret};RulePack.prototype.isRuleEnabled=function(name,prefix){var o=this.getRuleOptions(name,prefix,true);return o?o.enabled:false};RulePack.prototype.isRuleDisabled=function(name,prefix){var o=this.getRuleOptions(name,prefix,true);return o?!o.enabled:false};RulePack.prototype.disableRule=function(name){var ret=true;if(this._ruleCtx._rsi!==this._rsi){return false}name=name||this._ruleCtx.ruleName;if(!name){return false}var o=this.getRuleOptions(name,null,true);if(o){if(o.enabled){o.enabled=false;if(this._activeCount>=0){this._activeCount--}}}else{ret=false}return ret};RulePack.prototype.enableRule=function(name){if(this._ruleCtx._rsi!==this._rsi){return false}var ret=true;var o=this.getRuleOptions(name,null,true);if(o){if(!o.enabled){o.enabled=true;this._activeCount++}}else{ret=false}return ret};RulePack.prototype.getRuleCount=function(){if(this._ruleCount>=0){return this._rulecount}var rules,n,r;rules=this._rulePacks[this._rsi].rulesJson.rules;n=0;for(r in rules){n++}this._ruleCount=n;return n};RulePack.prototype.getEnabledRuleCount=function(){if(this._activeCount>=0){return this._activeCount}var opts,r,n;opts=this._rulePacks[this._rsi].rulesJson.rules;n=0;for(r in opts){if(opts[r].enabled){n++}}this._activeCount=n;return n};RulePack.prototype.getRuleList=function(){var rules=this._rulePacks[this._rsi].rulesJson.rules;var a,r;a=[];for(r in rules){a.push(r)}return a};RulePack.prototype.getEnabledRuleList=function(){var rules=this._rulePacks[this._rsi].rulesJson.rules;var a,r;a=[];for(r in rules){if(rules[r].enabled){a.push(r)}}return a};RulePack.prototype.getRule=function(name){var r;if(this._ruleCtx._rsi===this._rsi){if(name){r=this._shadPacks[this._rsi];if(r){r=r[name]}}}return r};RulePack.prototype.sendMsg=function(name,...args){var rc;if(!Array.isArray(name)&&typeof name==="string"){this._pushRuleName();if(this._ruleCtx._rsi===this._rsi&&name!==this._ruleCtx.ruleName){rc=this._sendMsg([name],args,true)}this._popRuleName()}return rc};RulePack.prototype.broadcastMsg=function(names,...data){var rc;if(this._ruleCtx._rsi!==this._rsi||names&&!Array.isArray(names)){return false}var a;if(!names){a=this.getEnabledRuleList()}else if(Array.isArray(names)){a=names}else{return false}this._pushRuleName();rc=this._sendMsg(a,data);this._popRuleName();return rc};RulePack.prototype.setExtension=function(data){this._extension=data};RulePack.prototype.getExtension=function(){return this._extension};RulePack.prototype._setCBCtx=function(ctx){this._ruleCtx=ctx};RulePack.prototype._getRsiByPrefix=function(prefix){var rsi,l;l=this._summary.length;for(rsi=0;rsi<l;rsi++){if(this._summary[rsi].prefix===prefix){break}}return rsi>=l?-1:rsi};RulePack.prototype._sendMsg=function(a,args,isSendMsg){var n=0,i,rc;let sender=clone.cloneOptions(this._summary[this._rsi]);sender.ruleName=this._ruleCtx.ruleName;sender.regType=this._ruleCtx.type;for(i=0;i<a.length;i++){let rn=a[i];if(rn===this._ruleCtx.ruleName){continue}let r=this.getRule(rn);if(r&&r[ONMSG]){try{this._ruleCtx.ruleName=rn;rc=r[ONMSG](sender,args);n++}catch(e){this._appCtx.error("rule '"+rn+"' onMsg() : "+e)}}}return isSendMsg?rc:n};RulePack.prototype._pushRuleName=function(){if(!this._nameStack){this._nameStack=[]}this._nameStack.push(this._ruleCtx.ruleName)};RulePack.prototype._popRuleName=function(){if(this._nameStack&&this._nameStack.length){this._ruleCtx.ruleName=this._nameStack.pop()}};module.exports=RulePack;