/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
var walker=require("./scopewalker");const TS_ANY="TSAnyKeyword";const TS_TYPEREF="TSTypeReference";const TS_ARRAY="TSArrayType";const STRING="string";const NUMBER="number";const BOOLEAN="boolean";const NULL="null";const OBJECT="Object";const FUNCTION="function";const ANY="any";const REG_EXP="RegExp";const UNKNOWN="unknown";const PROGRAM="Program";const GLOBAL_SCOPE="_@global";const ANON="$anon";const DOCUMENT_METHODS={createElement:"Element",createTextNode:"Element",getElementById:"Element",getElementsByClassName:"HTMLCollection",getElementsByName:"HTMLCollection",getElementsByTagName:"HTMLCollection",getElementsByTagNameNS:"HTMLCollecion",hasFocus:"boolean",querySelector:"Element",querySelectorAll:"NodeList"};const DOCUMENT_MEMBERS={activeElement:"Element",anchors:"HTMLCollection",body:"Element",childElementCount:"number",dir:"string",documentElement:"Element",documentURI:"string",docType:"DTD",forms:"HTMLCollection",getElementById:"Element",head:"Element",hidden:"boolean",links:"HTMLCollection",scrollingElement:"Element",visibilityState:"string"};const INDENT=3;var _level=-INDENT;function _trace(t,n){function _rj(s,w){s=""+s;if(s.length<w){s=" ".repeat(w-s.length)+s}return s}_level+=t==="E"?INDENT:0;if(t==="E")console.log(`${_rj(n.loc.start.line,4)}] ${" ".repeat(_level)}  ${n.type}`);else console.log(`${" ".repeat(4)}  ${" ".repeat(_level)}  ${n.type}`);_level-=t==="L"?INDENT:0};class Scope{constructor(msgCtx,config,file){this._msgCtx=msgCtx;this._config=config;this._file=file;this.reset()}reset(){this._fStack=[];this._bStack=[];this._imports=[];this._funcStack=[];this._idxStack=0;this._parents=[];this._blockStack=[];this._idxBlkStack=0;this._blkParents=[];this._nextAnonId=0;this._varKind;this._level=-INDENT}build(ast){this.reset();try{walker.traverse(ast,{enter:this._enter.bind(this),leave:this._leave.bind(this)})}catch(e){let stk=e.stack;let x=stk.indexOf("\n");stk=x>=0?stk.substring(x+1):stk;stk=`${"-".repeat(10)}\n${stk}\n${"-".repeat(10)}`;this._msgCtx.jafMsg("jaf-ts-walk",`TS walk exception: ${e.message} File: ${this._file}\n\n${stk}`)}return{funcs:this._fStack,blocks:this._bStack}}_buildFuncIndexesToBlocks(){var i,j;for(i=0;i<this._fStack.length;i++){for(j=0;j<this._bStack.length;j++){if(this._bStack[j].func==i){this._fStack[i].blocks.push(j)}}}}getAccessor(){return new _scope(this._fStack,this._bStack)}_enter(node){var type;if(this._msgCtx.isDebug){_trace("E",node)}type=node.type;if(this._isNewScope(node)){this._addNewFunc(node)}else if(type==="VariableDeclarator"||type==="ClassProperty"){this._varDecl(node)}else if(type==="VariableDeclaration"){this._varKind=node.kind}else if(type==="BlockStatement"){this._addNewBlock(node)}else if(type==="ClassDeclaration"){this._inClass=true;this._className=node.id.name}else if(type==="ImportDeclaration"){this._addImport(node)}}_leave(node){if(this._msgCtx.isDebug){_trace("L",node)}if(this._isNewScope(node)){if(this._parents.length){this._parents.pop()}this._funcStack.pop()}else if(node.type==="BlockStatement"){if(this._blkParents.length){this._blkParents.pop()}this._blockStack.pop()}else if(node.type==="ClassDeclaration"){this._inClass=false;this._className=null}}_addNewFunc(node){var type,func,curParent,x;type=node.type;if(type===PROGRAM){func=GLOBAL_SCOPE}else if(node.kind==="method"||node.kind==="get"||node.kind==="set"||node.kind==="constructor"){func=node.key.name}else if(node.id){func=node.id.name}else if(type==="ClassBody"){func=this._className}else{this._getNextAnon()}if(this._parents.length){curParent=this._fStack[this._parents[this._parents.length-1]]}x=this._fStack.push({func:func,accessor:node.kind==="get"?"get":node.kind==="set"?"set":null,node:node,vars:{},args:{},blocks:[],children:[],parent:this._parents.length?this._parents[this._parents.length-1]:-1});x--;this._parents.push(x);if(curParent){curParent.children.push(x)}this._funcStack.push(x);this._addFuncArgs(node)}_addNewBlock(node){var func,curParent,x;var func=this._fStack[this._getCurFunc()];let n=this._fStack[this._getCurFunc()].node;if((n.kind==="method"||n.kind==="constructor")&&this._isMethodRange(n,node)||n.kind!=="method"&&n.kind!=="constructor"&&n.body&&node.range===n.body.range){return}if(this._blkParents.length){curParent=this._bStack[this._blkParents[this._blkParents.length-1]]}x=this._bStack.push({func:this._getCurFunc(),node:node,lets:{},children:[],parent:this._blkParents.length?this._blkParents[this._blkParents.length-1]:-1});x--;this._blkParents.push(x);if(curParent){curParent.children.push(x)}this._blockStack.push(x);func.blocks.push(x)}_addImport(node){var src,local,o;src=node.source.value;if(!src.startsWith("ojs/")){return}o={src:src};if(node.specifiers.length){node.specifiers.forEach(s=>{if(!local)local=[];local.push(s.local.name)});if(local){o.local=local}}this._imports.push(o)}_getCurFunc(){return this._funcStack[this._funcStack.length-1]}_getCurBlock(){return this._blockStack[this._blockStack.length-1]}_addFuncArgs(node){var props,left,n,vt,varKeys,curScope;if(node.params){curScope=this._fStack[this._getCurFunc()];node.params.forEach(function(n){if(n.type==="Identifier"){vt=this._getVarType(n);curScope.args[n.name]={type:vt}}else if(n.type==="AssignmentPattern"){if(n?.left?.type==="ObjectPattern"){left=n.left;vt=this._getTypeAnnotationType(n.left);if(varKeys=this._deconstructObject(n.left.properties)){varKeys.forEach(key=>{curScope.args[key]=vt?vt:"?"})}}else if(n?.left.type==="Identifier"){vt=this._getTypeAnnotationType(n.left);curScope.args[n.left.name]=vt?vt:"?"}else{this._msgCtx.assert(`scopes nt  n.type= ${n.type} n.left.type=${n.left.type} n.right.type=${n.right.type}\n${this._file}`)}}else if(n.type==="ObjectPattern"){vt=this._getTypeAnnotationType(n);if(varKeys=this._deconstructObject(n.properties)){varKeys.forEach(key=>{curScope.args[key]=vt?vt:"?"})}}else if(n.type==="RestElement"){}else{this._msgCtx.assert(`scopes nt  n.type= ${n.type} ${this._file}`)}},this)}}_deconstructObject(props){var ret;if(props){ret=[];props.forEach(prop=>{if(prop?.key?.type==="Identifier"){ret.push(prop.key.name)}});return ret}}_getTypeAnnotationType(node){var vt;if(node.typeAnnotation){if(node.typeAnnotation.type==="TSTypeReference"){vt=propAnnotation.typeName.name}else if(node.typeAnnotation?.typeAnnotation.type==="TSTypeReference"){vt=node.typeAnnotation.typeAnnotation.typeName.name}}return vt}_isNewScope(node){var type=node.type;return type==="FunctionDeclaration"||type==="MethodDefinition"||type==="FunctionExpression"&&!this._inClass||type==="ClassBody"||type==="Program"}_varDecl(node){var curScope,vt,name;function _declVar(vt,self){curScope=self._fStack[self._getCurFunc()];if(node.id){name=node.id.name}else{name=node.key.name}curScope.vars[name]={type:vt,node:node}};vt=this._getVarType(node);if(this._varKind==="let"||this._varKind==="const"){if(this._blockStack.length===0){this._varKind="var"}}if(this._varKind==="var"||node.type==="ClassProperty"){_declVar(vt,this)}else if(this._varKind==="let"||this._varKind==="const"){let b=this._getCurBlock();if(b>=0){let block=this._bStack[b];let br=block.node.range;let start=node.range;if(start[0]>=br[0]&&start[1]<=br[1]){block.lets[node.id.name]={type:vt,node:node}}}else{_declVar(vt,this)}}}_getVarType(node){var vt,ta,et,ty;if(node.type==="ClassProperty"){if(node.value){if(node.value.type==="ArrowFunctionExpression"){return"function"}else if(node.value.type==="CallExpression"){if(node.value.callee.object.name==="ko"){if(node.value.callee.property.name==="observable"){return"KO_Observable"}else if(node.value.callee.property.name==="computed"){return"KO_computed"}else{return"KO_Unknown"}}}}}ta=node.id&&node.id.typeAnnotation?node.id.typeAnnotation:node.typeAnnotation;if(!ta){ty=node.init?this._getInitType(node.init):ANY}else{vt=ta.typeAnnotation.type;if(vt===TS_TYPEREF){if(ta.typeAnnotation.typeName.name){ty=ta.typeAnnotation.typeName.name}else{if(ta.typeAnnotation.typeName.left){if(ta.typeAnnotation.typeName.left.name){ty=ta.typeAnnotation.typeName.left.name;if(ta.typeAnnotation.typeName.right&&ta.typeAnnotation.typeName.right.name){ty+="."+ta.typeAnnotation.typeName.right.name}}else if(ta.typeAnnotation.typeName.left.left.name){ty+="."+ta.typeAnnotation.typeName.left.left.name;if(ta.typeAnnotation.typeName.left.right.name){ty+="."+ta.typeAnnotation.typeName.left.right.name}if(ta.typeAnnotation.typeName.right.name){ty+="."+ta.typeAnnotation.typeName.right.name}}}}}else if(vt===TS_ARRAY){et=ta.typeAnnotation.elementType.type;if(et===TS_TYPEREF){ty=ta.typeAnnotation.elementType.typeName.name+"[]"}else{ty=et+"[]"}}else{ty=vt}}if(ty){ty=_transformType(ty)}if(!ty){console.log("[ASSERT]: scopes: ty not defined")}return ty}_getInitType(init){var vt,raw;if(init.type==="Literal"&&init.raw){raw=init.raw;if(raw.charAt(0)==="\""||raw.charAt(0)==="'"){vt=STRING}else if(raw==="true"||raw==="false"){vt=BOOLEAN}else if(!isNaN(raw)){vt=NUMBER}else if(raw==="null"){vt=NULL}else if(_isRegExpr(raw)){vt=REG_EXP}else{console.log("[ASSERT]: SCOPES - UNKNOWN VAR INIT LITERAL TYPE = "+raw);vt=UNKNOWN}}else if(init.type==="ObjectExpression"){vt=OBJECT}else if(init.type==="NewExpression"){if(init.callee&&init.callee.name){vt=init.callee.name}}else if(init.type==="CallExpression"){if(init.callee&&init.callee.object){let o=init.callee.object;if(o.type==="Identifier"&&o.name==="document"){o=init.callee.property;if(o=DOCUMENT_METHODS[o.name]){return o}else{return"unknown document function"}}if(o.type==="MemberExpression"){vt=this._unravelCallME(o)}if(init.callee&&init.callee.object&&init.callee.object.type==="FunctionExpression"){vt="function"}}}else if(init.type==="MemberExpression"){if(init.object.type==="TSAsExpression"){vt=UNKNOWN}}else if(init.type==="TSAsExpression"){if(init.typeAnnotation&&init.typeAnnotation.type==="TSTypeReference"){vt=init.typeAnnotation.typeName.name}else{vt=UNKNOWN}}else if(init.type==="TSTypeAssertion"){if(init.typeAnnotation){vt=init.typeAnnotation.type}}else if(init.type==="AwaitExpression"){vt=ANY}else{vt=init.type}if(!vt){vt=UNKNOWN}return vt}_isMethodRange(n,node){return n.value&&n.value.body&&n.value.body.range===node.range}_unravelCallME(o){var prop;if(o.object.type==="ThisExpression"){prop=o.property.name;return this._getClassPropType(o,prop)}}_getClassPropType(o,prop){var c,ret;c=this._getContainingClass(o);if(c&&c.vars){ret=c.vars[prop];if(ret){ret=ret.type}}return ret}_getContainingClass(node){var c=this._getCurFunc(node);if(c<0){return}do{c=this._fStack[c];if(c.node.type==="ClassBody"){break}c=c.parent}while(c>=0);return c}_dumpEnter(node){let funcName=node.id?node.id.name:"anon";console.log(`ENTER=${funcName} ${node.type}`)}_dumpLeave(node){let funcName=node.id?node.id.name:"anon";console.log(`LEAVE=${funcName} ${node.type}`)}dumpStacks(){this.dumpFuncStack();this.dumpBlockStack()}dumpFuncStack(){var st,v,o,s,i,title;console.log("\n-------- Function/Class Scope Map --------");st=this._fStack;for(i=0;i<st.length;i++){o=st[i];s=(o.children.length?"children="+_dumpArrayIndices(o.children):"")+"  blocks="+_dumpArrayIndices(o.blocks);console.log(`\n[${i}] "${o.func}" ${_dumpStackType(o)}  parent=${o.parent} ${s}`);title=false;if(_hasProps(o.args)){for(v in o.args){console.log((!title?"       Args: ":"             ")+v+": "+o.args[v].type);title=true}}else{console.log("       Args: none")}title=false;if(_hasProps(o.vars)){for(v in o.vars){console.log((!title?"       Vars: ":"             ")+v+": "+o.vars[v].type+" ("+(o.vars[v].node.type==="ClassProperty"?"class prop":"var")+")");title=true}}else{console.log("       Vars: none")}}}dumpBlockStack(){var st,v,o,ch,i,title;console.log("\n-------- Internal Block Scope Map --------");st=this._bStack;if(!st.length){console.log("\nNo blocks.");return""}for(i=0;i<st.length;i++){o=st[i];ch=o.children.length?"children="+_dumpArrayIndices(o.children):"";console.log(`\n[${i}] ${this._dumpBlkOwner(o)}="${this._fStack[o.func].func}"  parent=${o.parent} ${ch}`);title=false;if(_hasProps(o.lets)){for(v in o.lets){console.log((!title?"       Lets: ":"             ")+v+": "+o.lets[v].type);title=true}}else{console.log("       Lets: none")}}}_dumpBlkOwner(o){var f=this._fStack[o.func];return f.node.type==="FunctionDeclaration"?"func":"meth"}_getNextAnon(){return ANON+ ++this._nextAnonId}};function _hasProps(obj){var ret=false;for(var prop in obj){if(obj.hasOwnProperty(prop)){ret=true;break}}return ret};function _dumpArrayIndices(a){var ret="[";a.forEach(function(v,i){ret+=(i?", ":"")+v});return ret+"]"}function _dumpStackType(o){var s="";switch(o.node.type){case"ClassBody":s="class";break;case"MethodDefinition":s="method";if(o.accessor){if(o.accessor==="get"){s+=" getter"}else if(o.accessor==="set"){s+=" setter"}else{s+=" ?accessor"}}break;case"FunctionDeclaration":s="func";break}return s.length?"("+s+")":s};function _transformType(ty){const list={TSStringKeyword:"string",TSNumberKeyword:"number",TSBooleanKeyword:"boolean",TSNullKeyword:"null",TSObjectKeyword:"object",TSUnknownKeyword:"unknown",TSAnyKeyword:"any"};return list[ty]||ty};function _isRegExpr(raw){return raw.startsWith("/")&&(raw.endsWith("/")||raw.endsWith("/g")||raw.endsWith("/i")||raw.endsWith("/gi")||raw.endsWith("/ig"))};class _scope{constructor(fs,bs){this._fstk=fs;this._bstk=bs}getVarType(node){var name,func,block,v;if(!(name=node.name)){return null};block=this.getContainingBlock(node);if(block){v=block.lets[name];if(v){return v.type}while(block.parent>=0){block=this._bstk[block.parent];if(block){v=block.lets[name];if(v){return v.type}}}}func=this.getContainingFunc(node);do{if(func.vars&&func.vars[name]){v=func.vars[name].type}else if(func.args&&func.args[name]){v=func.args[name].type}if(v){break}if(func.parent>=0){func=this._fstk[func.parent]}else{func=null}}while(func);return v}getContainingFunc(node){var start,fnRange,fnIndex,func,fr,i;start=node.range[0];for(i=0;i<this._fstk.length;i++){func=this._fstk[i];fr=func.node.range;if(start>=fr[0]&&start<=fr[1]){if(fnRange){if(fr[0]>=fnRange[0]&&fr[1]<=fnRange[1]){fnRange=fr;fnIndex=i}}else{fnRange=fr;fnIndex=i}}}return typeof fnIndex==="number"?this._fstk[fnIndex]:null}getContainingBlock(node){var nrange,brange,range,bindex,blocks,block,i;if(!this._bstk.length)return;var blocks=this.getContainingFunc(node).blocks;nrange=node.range;for(i=0;i<blocks.length;i++){block=this._bstk[i];brange=block.node.range;if(nrange[0]>=brange[0]&&nrange[1]<=brange[1]){if(range){if(brange[0]>=range[0]&&brange[1]<=range[1]){range=nrange;bindex=i}}else{range=brange;bindex=i}}}return typeof bindex==="number"?this._bstk[bindex]:null}getContainingClass(node){}getGlobals(){return this._fstk[0]}getFuncStack(){return this._fstk}getBlockStack(){return this._bstk}};module.exports=Scope;