/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const OUTFMT=require("./outFormat");const UNDEF="undefined";function Api(nodeDeps,JafCore){this._core=JafCore;this._stats=JafCore.getStats();this._nd=nodeDeps};Api.prototype.startSync=function(apiContext){var core=this._core;core._ctxCB=apiContext;if(apiContext.config){let t=typeof apiContext.config;if(t==="string"){core._configPath=this._nd.path.join(core._curDir,apiContext.config)}else if(t==="object"){core._configPath=apiContext.config}else{core._error("Invalid config argument in init() : type is "+t);return 1}}if(apiContext.format&&apiContext.format!==OUTFMT.PROSE){apiContext.format=OUTFMT.PROSE}return core.start()};Api.prototype.start=function(apiContext,AmdMeta,AmdRulePacks){var t,_self,rc;this._core._isAsync=true;this._core._ctxCB=apiContext;_self=this;return new Promise(function(resolve,reject){let core=_self._core;setTimeout(()=>{try{if(apiContext.config){t=typeof apiContext.config;if(t==="string"){core._configPath=_self._nd.path.join(core._curDir,apiContext.config)}else if(t==="object"){core._configPath=apiContext.config}else{core._error("Invalid config argument in init() : type is "+t);reject(1)}}if(!core._isAMD){core._isAsync=false;core._isAsyncTemp=true;rc=_self.startSync(apiContext);core._isAsync=true;rc===0?resolve(rc):reject(core._messageStack)}else{if(apiContext.format&&apiContext.format!==OUTFMT.PROSE){apiContext.format=OUTFMT.PROSE}core._isAsync=false;core._isAsyncTemp=true;core.setAmdMeta(AmdMeta);core._AmdRulePacks=AmdRulePacks;if(AmdRulePacks&&!Array.isArray(AmdRulePacks)){core._error("init() : AMD rule packs must be specified as an array!");reject(1);return}rc=_self.startSync(apiContext);core._isAsync=true;rc===0?resolve(rc):reject(core._messageStack)}}catch(e){reject(core._messageStack)}},0)})};Api.prototype.auditSync=function(filespec){var core=this._core;core._isAsync=false;this._stats.clearAll();if(core._regListenerTypesSet||core._rules&&core._rules.getActiveRuleCount()===0){if(core._rules){core._emitApiRunSummary()}return}if(filespec){if(!Array.isArray(filespec)){filespec=[filespec]}core._fileSet.setFiles(filespec,core._config.getExclude(),core._getMsgCtx())}core._startLifeCycle();core._emitApiRunSummary()};Api.prototype.audit=function(filespec){var rc,_self,core=this._core;core._isAsync=true;this._stats.clearAll();if(filespec){if(!Array.isArray(filespec)){filespec=[filespec]}core._fileSet.setFiles(filespec,core._config.getExclude(),core._getMsgCtx())}_self=this;return new Promise((resolve,reject)=>{setTimeout(()=>{try{_self._core._isAsync=false;rc=_self._core._startLifeCycle();_self._core._isAsync=true;_self._core._emitApiRunSummary();rc?resolve(core._isAPI?rc:0):reject(1)}catch(e){let m=`[JAF-9010] Internal Error:\n${_shortStackMsg(e)}`;core._error(m);reject(m)}},0)})};Api.prototype.on=function(evName,fn,obj){if(this._core._listenerSetup()){this._core._events.setListener(evName,fn,obj)}};Api.prototype.removeListener=function(evName,fn){if(this._core._listenerSetup()){this._core._events.removeListener(evName,fn)}};Api.prototype.removeAllListeners=function(evName){if(this._core._listenerSetup()){this._core._events.removeAllListeners(evName)}};Api.prototype.plugins=function(ar){this._core._plugin.setPlugins(ar)};Api.prototype.getDescription=function(arg1,arg2,arg3){var issue,short,ruleName,sig=0,ret="";var core=this._core;var arg1Type=core._Utils.getType(arg1);var arg2Type=core._Utils.getType(arg2);if(arg1Type==="object"){issue=arg1;if(arg2==="boolean"||arg2Type===UNDEF){short=arg2;sig=1;ruleName=issue.rule;msgId=issue.msgId}}else if(arg1Type==="string"){if(arg2Type==="string"){msgId=arg1;ruleName=arg2;short=!!arg3;sig=2}}var loadedRule,rsi,msgId,fn;if(sig){rsi=core._ruleSets.getRsiFromMsgId(msgId);if(rsi<0){return""}loadedRule=core._ruleSets.getLoadedRule(rsi,ruleName);fn=short?loadedRule.getShortDescription.bind(loadedRule):loadedRule.getDescription.bind(loadedRule);ret=fn()}return ret};Api.prototype.getRulesetInfo=function(fmt,active){var ret,core=this._core;active=typeof active==="undefined"?true:active;if(fmt===OUTFMT.JSON)ret=core._rules.getRulesJson(active);else if(fmt===OUTFMT.PROSE||fmt===OUTFMT.LINE)ret=core._rules.getRulesProse(active);else ret=core._rules.getRulesSonar(active);return ret};Api.prototype.enableMsgId=function(msgid,state){var ret=false;var core=this._core;if(core._config.setMessages(msgid,state)){core._reporter.setMessageFilter(core._config._config.messages);ret=true}return ret};Api.prototype.getConfig=function(){return this._core._config.getConfig()};Api.prototype.getSevLib=function(){return this._core._severity.getSevLib()};Api.prototype.getInfo=function(){return this._core._getInfo()};Api.prototype.setMarker=function(mark){return this._core.setMarker(mark)};Api.prototype.getMarker=function(){return this._core.getMarker()};Api.prototype.setVsCodeExtHint=function(isVsCodeExt){this._core._VsCodeExtHint=isVsCodeExt};function _shortStackMsg(e){let x,x2=0,m=e.stack||e;if((x=m.indexOf("\n"))>0){if((x2=m.indexOf("\n",x+1))<0){x2=x}}if(x2){m=m.substring(0,x2)}return m};module.exports=Api;