/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const OUTFMT=require("../lib/outFormat");const MACROS=require("../lib/macros");const ARG_CONFIG="--config";const ARG_CONFIG_SHORT="-c";const ARG_BASE="--base";const ARG_BASE_SHORT="-b";const ARG_SEVERITY="--severity";const ARG_SEVERITY_SHORT="-s";const ARG_FORMAT="--format";const ARG_FORMAT_SHORT="-t";const ARG_FOLLOWLINKS="--followlinks";const ARG_FOLLOWLINKS_SHORT="-fl";const ARG_NOFOLLOWLINKS="--nofollowlinks";const ARG_NOFOLLOWLINKS_SHORT="-nfl";const ARG_SHOWRULES="--rules";const ARG_SHOWRULES_SHORT="-r";const ARG_SHOWRULESJSON="--rulesjson";const ARG_SHOWRULESJSON_SHORT="-rj";const ARG_SHOWRULESSONAR="--rulessonar";const ARG_SHOWRULESSONAR_SHORT="-rs";const ARG_SHOWRULES_INTERNAL="-rx";const ARG_OUTPATH="--outpath";const ARG_OUTPATH_SHORT="-o";const ARG_NO_OUT="--noout";const ARG_NO_OUT_SHORT="-no";const ARG_NOCOLOR="--nocolor";const ARG_NOCOLOR_SHORT="-nc";const ARG_NODEBUG="--nodebug";const ARG_NODEBUG_SHORT="-nd";const ARG_NOVERBOSE="--noverbose";const ARG_NOVERBOSE_SHORT="-nv";const ARG_NOEXTRA="--noextra";const ARG_NOEXTRA_SHORT="-ne";const ARG_GROUPS="--groups";const ARG_GROUPS_SHORT="-g";const ARG_GROUPS_EQ="--groups=";const ARG_GROUPS_EQ_SHORT="-g=";const ARG_MSGID="--msgid";const ARG_MSGID_SHORT="-id";const ARG_WATCH="--watch";const ARG_WATCH_SHORT="-w";const ARG_VERSION="--version";const ARG_VERSION_SHORT="-v";const ARG_JETLIST="--jetlist";const ARG_JETLIST_SHORT="-jl";const ARG_DEFLIST="--default";const ARG_DEFLIST_ALT="--deflist";const ARG_DEFLIST_SHORT="-def";const ARG_GROUPLIST="--grouplist";const ARG_GROUPLIST_SHORT="-gl";const ARG_XGROUPLIST="--xgrouplist";const ARG_XGROUPLIST_SHORT="-xgl";const ARG_DISLIST="--dislist";const ARG_DISLIST_SHORT="-dl";const ARG_DEPLIST="--deplist";const ARG_DEPLIST_SHORT="-dpl";const ARG_JETVER="--jetver";const ARG_JETVER_SHORT="-jv";const ARG_MAINT="--maintenance";const ARG_MAINT_SHORT="-mnt";const ARG_NAMESPACE_LIST="--nslist";const ARG_NAMESPACE_LIST_SHORT="-nsl";const ARG_PROFILES_LIST="--profiles";const ARG_PROFILES_LIST_SHORT="-prof";const ARG_AMDLIST="--amdlist";const ARG_AMDLIST_SHORT="-amd";const ARG_RLOLIST="--loadorder";const ARG_RLOLIST_SHORT="-rlo";const ARG_BETALIST="--betalist";const ARG_BETALIST_SHORT="-bl";const ARG_METAHIST="--metahist";const ARG_METAHIST_SHORT="-mh";const ARG_RC="--retcode";const ARG_RC_EQ="--retcode=";const ARG_RC_SHORT="-rc";const ARG_RC_EQ_SHORT="-rc=";const ARG_DRYRUN="--dryrun";const ARG_DRYRUN_SHORT="-dr";const ARG_DAC="--daconfig";const ARG_DAC_SHORT="-dac";const ARG_REG="--reg";const ARG_REG_SHORT="-reg";const ARG_HELP="--help";const ARG_HELP_SHORT="-h";const ARG_HELP_SHORT_S="-hs";const ARG_EXTRA="--extra";const ARG_EXTRA_SHORT="-e";const ARG_DEBUG="--debug";const ARG_DEBUG_SHORT="-d";const ARG_SCAFFOLD="--init";const ARG_SCAFFOLD_SHORT="-i";const ARG_SCAFFOLD_RULE="--initrule";const ARG_SCAFFOLD_RULE_SHORT="-ir";const ARG_MIGRATOR="--migrator";const ARG_MIGRATOR_SHORT="-mig";const ARG_UNIT_TEST="-ut";const ARG_OJET="--ojet";const ARG_OJET_SHORT="-ojet";const ARG_EXPERIMENTAL="--x";const ARG_EXPERIMENTAL_SHORT="-x";const MIGRATOR_LOG="migrator.log";const BAD_CONFIG_ARG="Invalid --config option";module.exports.checkArgs=function(nodeDeps,rtf,showHelp,showVersion,appCtx){var argLen,argOrig,arg,dontRun,temp,x,bArgsOk=true,bWantHelp=false,debugTitle,rc;rtf.jetauditdir=nodeDeps.process.argv[1];rtf.jetauditdir=nodeDeps.path.dirname(rtf.jetauditdir);_checkBaseOptions(rtf,appCtx.colors);if(!(rc=_checkMigrator(nodeDeps,rtf,appCtx))){return rc}if(rtf.debugSet){_dumpCmdLine()}if(rtf.migrator){return rc}argLen=process.argv.length;for(var i=2;i<argLen;i++){argOrig=process.argv[i];arg=argOrig.toLowerCase().trim();if(arg.length===0){continue}if(arg.charAt(0)!=="-"){if(!rtf.srcStack){rtf.srcStack=[]}arg=process.argv[i];arg=_handleQuotes(arg);arg=nodeDeps.path.normalize(arg);arg=nodeDeps.path.resolve(arg);rtf.srcStack.push(arg);if(rtf.debugMode||rtf.verboseMode){if(!debugTitle){appCtx.info("Command line files specified:");debugTitle=true}appCtx.info("  "+arg)}continue}if(arg.endsWith("?")){temp=arg.replace(/[\-\?]/g,"");rtf.manCheckL=temp;rtf.isManual=true;rtf.isManPage=true;break}if(_isBaseOption(arg)){continue}else if(arg===ARG_MSGID||arg===ARG_MSGID_SHORT){rtf.msgIdMode=rtf.msgIdModeSet=true}else if(arg===ARG_VERSION||arg===ARG_VERSION_SHORT){showVersion();dontRun=true}else if(arg===ARG_HELP||arg===ARG_HELP_SHORT||arg===ARG_HELP_SHORT_S){if(i+1<argLen){temp=process.argv[i+1];if(temp.charAt(0)==="-"){showHelp();dontRun=true;if(!_isBaseOption(temp))appCtx.error(`Unexpected '${temp}'`);break}i++;if(arg===ARG_HELP||arg===ARG_HELP_SHORT){rtf.manCheckL=temp}else{rtf.manCheckS=temp}rtf.isManual=true;if(rtf.st_configSet){break}}else{showHelp();dontRun=true;break}}else if(arg===ARG_JETLIST||arg===ARG_JETLIST_SHORT){rtf.jetverList=true;break}else if(arg.startsWith(ARG_DEFLIST)||arg.startsWith(ARG_DEFLIST_SHORT)||arg.startsWith(ARG_DEFLIST_ALT)){rtf.defList=true;break}else if(arg===ARG_NAMESPACE_LIST||arg===ARG_NAMESPACE_LIST_SHORT){rtf.cmdNSList=true;break}else if(arg===ARG_PROFILES_LIST||arg===ARG_PROFILES_LIST_SHORT){rtf.profList=true;rtf.cmdArg=checkNextArg(i,argLen,appCtx.error,false);break}else if(arg===ARG_DISLIST||arg===ARG_DISLIST_SHORT){rtf.disList=true;rtf.cmdArg=checkNextArg(i,argLen,appCtx.error,true);break}else if(arg===ARG_DEPLIST||arg===ARG_DEPLIST_SHORT){rtf.depList=true;rtf.cmdArg=checkNextArg(i,argLen,appCtx.error,true);break}else if(arg===ARG_AMDLIST||arg===ARG_AMDLIST_SHORT){rtf.amdList=true;rtf.cmdArg=checkNextArg(i,argLen,appCtx.error,true);break}else if(arg===ARG_RLOLIST||arg===ARG_RLOLIST_SHORT){rtf.rloList=true;rtf.cmdArg=checkNextArg(i,argLen,appCtx.error,true);break}else if(arg===ARG_BETALIST||arg===ARG_BETALIST_SHORT){rtf.betaList=true;rtf.cmdArg=checkNextArg(i,argLen,appCtx.error,true);break}else if(arg===ARG_GROUPLIST||arg===ARG_GROUPLIST_SHORT){rtf.groupList=true;rtf.cmdArg=checkNextArg(i,argLen,appCtx.error,true);break}else if(arg===ARG_XGROUPLIST||arg===ARG_XGROUPLIST_SHORT){rtf.xgroupList=true;rtf.cmdArg=checkNextArg(i,argLen,appCtx.error,true)}else if(arg===ARG_MAINT||arg===ARG_MAINT_SHORT){rtf.maintenance=true;break}else if(arg===ARG_METAHIST||arg===ARG_METAHIST_SHORT){rtf.cmdMetaHist=true;break}else if(arg===ARG_CONFIG||arg===ARG_CONFIG_SHORT){i++;if(i<argLen){arg=process.argv[i];rtf.configPath=nodeDeps.path.normalize(arg);rtf.configPath=nodeDeps.path.resolve(rtf.configPath);rtf.st_configSet=true;if(rtf.isManual||rtf.xgroupList){break}}else{appCtx.error(BAD_CONFIG_ARG);bArgsOk=false;bWantHelp=true}}else if(arg===ARG_BASE||arg===ARG_BASE_SHORT){i++;if(i<argLen){rtf.base=process.argv[i];if(rtf.base===MACROS.cwd||appCtx.utils.getFileType(rtf.base)==="d"){rtf.st_baseSet=true}else{appCtx.error(`'--base' ${rtf.base} is not a directory or the '$jafcwd' macro!!`);bArgsOk=false;bWantHelp=true}}else{appCtx.error("Invalid --base option");bArgsOk=false;bWantHelp=true}}else if(arg===ARG_SEVERITY||arg===ARG_SEVERITY_SHORT){i++;if(i<argLen){rtf.severitySet=true;rtf.cliSev=process.argv[i]}else{appCtx.error("Invalid --severity option");bArgsOk=false;bWantHelp=true}}else if(arg.startsWith(ARG_JETVER)||arg.startsWith(ARG_JETVER_SHORT)){let o=_checkArgValue(arg,i,appCtx,null,"JET version semver");if(!o.rc){return false}i=o.index;argOrig=o.value;if(arg=nodeDeps.jetver.validate(argOrig)){appCtx.error(arg);bArgsOk=false;break}arg=nodeDeps.jetver.getBestVersion(argOrig);if(!arg){appCtx.error(`${o.cmd}: '${argOrig}' is not a valid JET version`);bArgsOk=false;break}rtf.jetverSet=arg;if((rtf.verboseMode||rtf.debugMode)&&arg!==argOrig){appCtx.info(`[Info]: JET version '${argOrig}' was promoted to '${arg}'`)}}else if(arg===ARG_FORMAT||arg===ARG_FORMAT_SHORT){i++;if(i<argLen){argOrig=process.argv[i];arg=argOrig.toLowerCase();if(arg!==OUTFMT.JSON&&arg!==OUTFMT.PROSE&&arg!==OUTFMT.LINE){appCtx.error(`Invalid  --format(-t) option '${argOrig}'`);bArgsOk=false;bWantHelp=true}else{rtf.outFormat=arg;rtf.st_formatSet=true}}else{appCtx.error("Invalid --format option");bArgsOk=false;bWantHelp=true}}else if(arg===ARG_OUTPATH||arg===ARG_OUTPATH_SHORT){i++;if(rtf.st_outPathSet){appCtx.error("--outPath and --noout are mutually exclusive");bArgsOk=false;bWantHelp=true}else{if(i<argLen){arg=process.argv[i];arg=nodeDeps.path.normalize(arg);rtf.outPath=nodeDeps.path.resolve(arg);rtf.st_outPathSet=true}else{appCtx.error("Invalid --outPath option");bArgsOk=false;bWantHelp=true}}}else if(arg===ARG_NO_OUT||arg===ARG_NO_OUT_SHORT){if(rtf.st_outPathSet){appCtx.error("--outPath and --noout are mutually exclusive");bArgsOk=false;bWantHelp=true}else{rtf.outPath="$noout";rtf.st_outPathSet=true}}else if(arg===ARG_FOLLOWLINKS||arg===ARG_FOLLOWLINKS_SHORT){rtf.followLinks=rtf.followLinksSet=true}else if(arg===ARG_NOFOLLOWLINKS||arg===ARG_NOFOLLOWLINKS_SHORT){rtf.followLinks=false;rtf.followLinksSet=true}else if(arg.startsWith(ARG_GROUPS_EQ)||arg.startsWith(ARG_GROUPS_EQ_SHORT)){x=arg.indexOf("=");if(temp=_convertToArray(argOrig.substring(x+1))){rtf.groupsSet=temp}else{appCtx.error(`Invalid 'groups' declaration '${argOrig}`);bArgsOk=false;bWantHelp=true}}else if(arg===ARG_GROUPS||arg===ARG_GROUPS_SHORT){rtf.groupsSet=_checkGroups(process.argv,i+1);if(!rtf.groupsSet.groups||rtf.groupsSet.groups.length===0){appCtx.error(!rtf.groupsSet.groups?`groups missing after flag ${argOrig}`:`Invalid ${argOrig} specification`);bArgsOk=false;bWantHelp=true}i=rtf.groupsSet.next;rtf.groupsSet=rtf.groupsSet.groups}else if(arg.startsWith(ARG_RC_EQ)||arg.startsWith(ARG_RC_EQ_SHORT)||arg===ARG_RC||arg===ARG_RC_SHORT){arg=argOrig;if((x=arg.indexOf("="))>0){temp=argOrig.substring(0,x);arg=argOrig.substring(x+1)}else{temp=arg;i++;if(i<argLen){arg=process.argv[i]}else{appCtx.error(`missing arguments after '${argOrig}'`);bArgsOk=false;bWantHelp=true}}if(bArgsOk){temp=_processRetCode(temp,arg);if(temp||typeof temp==="number"){rtf.retCode=temp;rtf.st_retCodeSet=true}else{appCtx.error(`'${argOrig}' : ${arg.length?"'${arg}' is invalid":"missing argument?"}`);bArgsOk=false;bWantHelp=true}}}else if(arg===ARG_SHOWRULES||arg===ARG_SHOWRULES_SHORT){rtf.dumpRulesSet=true}else if(arg===ARG_SHOWRULESJSON||arg===ARG_SHOWRULESJSON_SHORT){rtf.dumpRulesJsonSet=true}else if(arg===ARG_SHOWRULESSONAR||arg===ARG_SHOWRULESSONAR_SHORT){rtf.dumpRulesSonarSet=true}else if(arg===ARG_SHOWRULES_INTERNAL){rtf.dumpRulesInternalSet=true}else if(arg===ARG_DRYRUN||arg===ARG_DRYRUN_SHORT){rtf.dryRunSet=rtf.dacSet=rtf.verboseMode=rtf.verboseSet=rtf.dumpRulesSet=true}else if(arg===ARG_DAC||arg===ARG_DAC_SHORT){rtf.dacSet=true}else if(arg===ARG_REG||arg===ARG_REG_SHORT){rtf.regListenerTypesSet=true}else if(arg===ARG_OJET||arg===ARG_OJET_SHORT){rtf.isOJETCLI=true}else if(arg.startsWith(ARG_EXPERIMENTAL)||arg.startsWith(ARG_EXPERIMENTAL_SHORT)){rtf.experimentalSet=true;if((x=arg.indexOf("="))>0){if((arg=argOrig.substring(x+1))==="tsx"){rtf.experimental=arg}}}else if(arg===ARG_WATCH||arg===ARG_WATCH_SHORT){if(rtf.experimentalSet){rtf.watchSet=true}}else if(arg===ARG_SCAFFOLD||arg===ARG_SCAFFOLD_SHORT){rtf.scaffoldSet=true}else if(arg===ARG_SCAFFOLD_RULE||arg===ARG_SCAFFOLD_RULE_SHORT){i++;if(i<argLen){rtf.scaffoldRuleSet=process.argv[i]}else{appCtx.error("Invalid --initrule argument: rule name missing ");bArgsOk=false;bWantHelp=true}}else if(arg==="-z"){}else{console.log("");appCtx.error(`Invalid command flag '${argOrig}'  (Use ojaf -h to get help)`);bArgsOk=false;dontRun=true}}return dontRun?"end":bArgsOk};module.exports.displayCmdLineOptionsSet=function(rtf,appCtx){var s="\n** Command line options:\n";if(rtf.dryRunSet){s+="  - Dry run  ON\n"}if(rtf.dacSet){s+="  - Display active config  ON\n"}if(rtf.verboseMode){s+="  - Verbose mode ON\n"}if(rtf.debugMode){s+="  - Debug mode ON\n"}if(rtf.watchSet){s+="  - watch mode ON\n"}if(rtf.groupsSet){s+=`  - Groups set to ${rtf.groupsSet}\n`}if(rtf.st_retCodeSet){s+=`  - retCode set to ${rtf.retCode}\n`}if(rtf.colorSet){s+=`  - Color mode ${rtf.colorMode}? "ON" : "OFF"}\n`}if(rtf.msgIdModeSet){s+=`  - Show msg ID's(${rtf.msgIdModeSet}? "ON" : "OFF"}\n`}if(rtf.st_formatSet){s+=`  - Output in ${rtf.outFormat.toUpperCase()} format\n`}if(rtf.st_configSet){s+=`  - Config set to ${rtf.configPath}\n`}if(rtf.severitySet){s+=`  - Severity set to '${rtf.severity}'\n`}if(rtf.st_outPathSet){s+=`  - Outpath set to ${rtf.outPath==="$noout"?"'none'":rtf.outPath}\n`}if(rtf.st_baseSet){s+=`  - Base set to ${rtf.base}\n`}if(rtf.jetverSet){s+=`  - JET version set to ${rtf.jetverSet}\n`}if(rtf.followLinksSet){s+=`  - following stylesheet links is ${rtf.followLinks?"ON":"OFF"}\n`}if(rtf.dumpRulesSet||rtf.dumpRulesJsonSet||rtf.dumRulesSonarSet){s+="  - Dump Rules ON\n"}appCtx.console(s+"\n")};module.exports.isCmdLineOptionsSet=function(rtf){return rtf.verboseMode||rtf.debugMode||rtf.colorSet||rtf.dumpRulesSet||rtf.dumpRulesJsonSet||rtf.dumpRulesSonarSet||rtf.dumpRulesInternalSet||rtf.msgIdModeSet||rtf.severitySet||rtf.watchSet||rtf.jetverSet||rtf.followLinksSet||rtf.dryRunSet||rtf.jetverList||rtf.cmdNSList||rtf.groupList||rtf.xgroupList||rtf.disList||rtf.cmdMetaHist||rtf.amdList||rtf.rloList||rtf.betaList||rtf.profList||rtf.maintenance||rtf.st_baseSet||rtf.st_formatSet||rtf.st_configSet||rtf.st_outPathSet||rtf.st_retCodeSet};function _checkBaseOptions(rtf,clr){var i,arg,argLen=process.argv.length;for(i=2;i<argLen;i++){arg=process.argv[i];if(arg.length===0||arg.charAt(0)!=="-"){continue}arg=arg.toLowerCase();if(arg===ARG_EXTRA||arg===ARG_EXTRA_SHORT){rtf.verboseMode=rtf.verboseSet=true}else if(arg===ARG_NOEXTRA||arg===ARG_NOEXTRA_SHORT||arg===ARG_NOVERBOSE||arg===ARG_NOVERBOSE_SHORT){rtf.verboseMode=false;rtf.verboseSetVeto=true}else if(arg===ARG_DEBUG||arg===ARG_DEBUG_SHORT){rtf.debugMode=rtf.debugSet=true;rtf.debugMode=rtf.debugSet=rtf.verboseMode=true}else if(arg===ARG_NODEBUG||arg===ARG_NODEBUG_SHORT){rtf.debugMode=false;rtf.debugSetVeto=true}else if(arg===ARG_NOCOLOR||arg===ARG_NOCOLOR_SHORT){rtf.colorMode=false;rtf.colorSet=true;clr.enable(false)}else if(arg===ARG_UNIT_TEST){rtf.unitTest=true}}};function _isBaseOption(arg){return arg===ARG_EXTRA||arg===ARG_EXTRA_SHORT||arg===ARG_NOEXTRA||arg===ARG_NOEXTRA_SHORT||arg===ARG_NOVERBOSE||arg===ARG_NOVERBOSE_SHORT||arg===ARG_DEBUG||arg===ARG_DEBUG_SHORT||arg===ARG_NODEBUG||arg===ARG_NODEBUG_SHORT||arg===ARG_NOCOLOR||arg===ARG_NOCOLOR_SHORT||arg===ARG_UNIT_TEST};function _checkGroups(args,i){var arg,a,x,last,bound,groups;x=i;for(;;i++){if(i>=args.length||args[i].charAt(0)==="-"||last){break}arg=args[i].trim();if(x===i){bound=arg.startsWith("[")||arg.startsWith("(")}last=bound&&(arg.endsWith("]")||arg.endsWith(")"));arg=arg.replace(/[\[\(\)\]]/g,"").trim();if(!arg.length){break}arg=arg.replace(/,/g," ");arg=arg.replace(/ +(?= )/g,"").trim();if(!groups){groups=[]}a=arg.split(" ");groups=groups.concat(a)}return{next:bound?i:x,groups:groups}};function _checkMigrator(nodeDeps,rtf,appCtx){var i,arg,origArg,argLen=process.argv.length;for(i=2;i<argLen;i++){origArg=process.argv[i];if(origArg.length===0||origArg.charAt(0)!=="-"){continue}arg=origArg.toLowerCase();if(rtf.migrator=arg===ARG_MIGRATOR||arg===ARG_MIGRATOR_SHORT){break}}if(!rtf.migrator){return true}for(i=2;i<argLen;i++){origArg=process.argv[i];if(origArg.length===0||origArg.charAt(0)!=="-"){continue}arg=origArg.toLowerCase();if(arg===ARG_MIGRATOR||arg===ARG_MIGRATOR_SHORT){continue}else if(arg===ARG_DRYRUN||arg===ARG_DRYRUN_SHORT){rtf.dryRunSet=true}else if(arg===ARG_VERSION||arg===ARG_VERSION_SHORT){rtf.help=true}else if(arg.startsWith(ARG_OUTPATH)||arg.startsWith(ARG_OUTPATH_SHORT)){let o=_checkArgValue(arg,i,appCtx,null,"path");if(!o.rc){return false}i=o.index;rtf.outPath=_checkMigratorOutPath(o.value,nodeDeps,appCtx);if(!rtf.outPath){return false}}else if(arg.startsWith(ARG_JETVER)||arg.startsWith(ARG_JETVER_SHORT)){let o=_checkArgValue(arg,i,appCtx,null,"JET version semver argument");if(!o.rc){return false}i=o.index;origArg=o.value;if(arg=nodeDeps.jetver.validate(origArg)){appCtx.error(`${o.cmd}: ${arg}`);return false}arg=nodeDeps.jetver.getBestVersion(origArg);if(!arg){appCtx.error(`${o.cmd}: '${origArg}' is not a valid JET version`);return false}rtf.jetverSet=arg;if((rtf.verboseMode||rtf.debugMode)&&arg!==origArg){appCtx.info(`[Info]: JET version '${origArg}' was promoted to '${arg}'`)}}else if(arg.startsWith(ARG_CONFIG)||arg.startsWith(ARG_CONFIG_SHORT)){let o=_checkArgValue(arg,i,appCtx,null,"path");if(!o.rc){return false}i=o.index;arg=o.value;rtf.configPath=nodeDeps.path.resolve(nodeDeps.path.normalize(arg));let ft=appCtx.fsUtils.getFileTypeSync(rtf.configPath);if(ft==="f"){rtf.st_configSet=true}else if(ft==="d"){appCtx.error(`${o.cmd} : path is a directory (should be a file) - ${rtf.configPath}`);return false}else{appCtx.error(`${o.cmd} : config file not found - ${rtf.configPath}`);return false}}else if(_isBaseOption(arg)){continue}else if(rtf.migrator){appCtx.error(`Unexpected or unknown arg '${origArg}'`);return false}}if(!rtf.outPath){let path=nodeDeps.path;rtf.outPath=path.resolve(path.normalize(path.join(".",MIGRATOR_LOG)))}if(!rtf.configPath){rtf.configPath=null}return true};function _checkMigratorOutPath(arg,nodeDeps,appCtx){var path=nodeDeps.path;if(arg==="."||arg===".."||arg.endsWith("/")||arg.endsWith("\\")){arg=path.join(arg,MIGRATOR_LOG)}else if(!arg){arg=MIGRATOR_LOG}arg=path.resolve(path.normalize(arg));if(appCtx.fsUtils.getFileType(arg)==="d"){appCtx.error(`--outPath : is a dir, expected a filename -  '${arg}'`);arg=null}return arg};function _checkArgValue(arg,i,appCtx,argType,what){var cmd,x;var retObj={value:null,origarg:arg,index:i,rc:true};if((x=arg.indexOf("="))>=0){cmd=retObj.cmd=arg.substring(0,x);arg=arg.substring(x+1)}else{cmd=retObj.cmd=arg;arg=++i<process.argv.length?process.argv[i]:null;retObj.index=i;if(arg&&arg.startsWith("-")){appCtx.error(`${cmd}: missing ${what} argument`);retObj.rc=false;return retObj}}if(!arg){appCtx.error(`Invalid ${cmd} option`);retObj.rc=false;return retObj}if(argType){let at=argType.charAt(0);if(at==="f"||at==="d"){let pt=appCtx.fsUtils.getFileType(arg);if(argType==="fe"||argType==="de"){if(pt==="f"||pt==="d"){if(at==="f"&&pt==="d"){appCtx.error(`${cmd} : expected a file (not a directory) '${arg}'`);retObj.rc=false}else if(at==="d"&&pt==="f"){appCtx.error(`${cmd} : expected a directory (not a file)) '${arg}'`);retObj.rc=false}}else{appCtx.error(`${cmd} : ${at==="d"?"directory":"file"} does not exist '${arg}'`);retObj.rc=false}}}}retObj.value=arg;return retObj};function _processRetCode(arg,val){var temp,ret;if(val==="auto"||val==="errors"){ret=val}else{temp=parseInt(val);if(!isNaN(temp)){ret=temp}else{if(temp=_convertToArray(val)){ret=temp}}}return ret};function checkNextArg(i,argLen,error,argType){var temp,lcTemp;if(i+1<argLen){temp=process.argv[i+1];lcTemp=temp.toLowerCase();if(temp.charAt(0)==="-"){if(!_isBaseOption(temp)&&lcTemp!==ARG_CONFIG&&lcTemp!==ARG_CONFIG_SHORT){error(`Unexpected '${temp}' - expected nothing, or a ${argType?"built-in pack prefix":"profile name"}`)}temp=undefined}}return temp};function _convertToArray(s){var a,n,i;if(s.charAt(0)==="["){s=s.substring(1);if(!s.length){return null}}if(s.charAt(s.length-1)==="]"){s=s.substring(0,s.length-1)}s=s.trim();if(!s.length){return null}s=s.replace(/\,/g," ");s=s.replace(/\s\s+/g," ").trim();a=s.split(" ");n=0;for(i=0;i<a.length;i++){if(a[i].length){n++}else{a=a.splice(i,1);i--}}return n?a:null};function _handleQuotes(s){return s.replace(/[\"\']/g,"")};function _dumpCmdLine(){var s="";for(var i=0;i<process.argv.length;i++){s+=`[${i}]:  |${process.argv[i]}|\n`}console.log(s)};