/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const ELLIPSIS="...";const JAF_OPTS=["inservice","enabled","group","severity","filetype","status","theme","jetver","amd","runonce","$hook","$required","$internal","$sevLocked","customOpts","issueTag"];var MAX_OPT_LEN=0;const INDENT="   ";const INDENT2="     ";const INDENT3="        ";const proseIndent=4;const optsIndent=10;const SPACER=" ".repeat(proseIndent);const SPACER2=" ".repeat(proseIndent+3);const SPACER3=" ".repeat(proseIndent+5);const SPACER4=" ".repeat(SPACER3.length+optsIndent);const NL="\n";var clr;var utils;var fsUtils;var out;var severity;var jsonRules;var haveProseRules=false;function getXml(){return out+"</rules>"};function getProse(){return out};function getJson(){return out};function ruleToXml(ruleName,rule,options,msgIds){var ruleName,val,opt,xml,id,i;xml=INDENT+"<rule>\n";xml+=INDENT2+"<key>"+ruleName+"</key>\n";xml+=INDENT2+"<name>"+_limitLength(_escapeChevrons(rule.getShortDescription()),utils)+"</name>\n";xml+=INDENT2+"<description>\n";xml+=INDENT3+"<![CDATA["+_escapeCData(rule.getDescription())+"]]>\n";xml+=INDENT2+"</description>\n";xml+=INDENT2+"<messages>\n";for(id of msgIds){xml+=INDENT3+"<msgid>"+id+"</msgid>\n"}xml+=INDENT2+"</messages>\n";for(opt in options){val=options[opt];if(opt==="severity"){xml+=INDENT2+"<severity>"+val.toUpperCase()+"</severity>\n"}else if(opt==="status"){val=val.toUpperCase();val=val==="PRODUCTION"?"READY":val;xml+=INDENT2+"<status>"+val+"</status>\n"}else if(opt==="group"){if(typeof val==="string"){xml+=INDENT2+"<tag>"+val+"</tag>\n"}else{for(i=0;i<val.length;i++){xml+=INDENT2+"<tag>"+val[i]+"</tag>\n"}}}}out+=xml+INDENT+"</rule>\n"};function setupRulesToXml(appCtx){utils=appCtx.utils;fsUtils=appCtx.fsUtils;clr=appCtx.colors;out="<rules>\n"};function setupRulesToProse(nd,severity,appCtx){utils=appCtx.utils;fsUtils=appCtx.fsUtils;clr=appCtx.colors;out=`\n------------ Rules Currently Active (rule severity: ${severity}) ---------------\n`;for(let opt of JAF_OPTS){MAX_OPT_LEN=opt.length>MAX_OPT_LEN?opt.length:MAX_OPT_LEN}};function setupRulesToJson(obj,sev,appCtx){out=obj||{};severity=sev;out.rulesets=[];utils=appCtx.utils;fsUtils=appCtx.fsUtils;clr=appCtx.colors};function packToProse(rules,path,rsi){if(!rules){out+=SPACER2+"* No enabled rules available for this severity."+NL+NL}else{out+="["+(rsi+1)+"] "+rules.title+NL;out+=SPACER+"version : "+rules.version+NL;out+=SPACER+"prefix  : "+rules.prefix+NL;out+=SPACER+"path    : "+path+NL}haveProseRules=false};function ruleToProse(ruleName,rule,opts,msgIds){var opts,opt,n,s,i;out+=!haveProseRules?SPACER+"Rules:"+NL:"";out+=SPACER2+clr.BRIGHTYELLOW("* "+ruleName+" :")+NL;out+=SPACER3+clr.BRIGHTCYAN("messages: ");out+=msgIds.join(", ")+NL;out+=SPACER3+clr.BRIGHTCYAN("options : ");n=0;for(opt in opts){if(_isJafOption(opt)){try{s=JSON.stringify(opts[opt])}catch(e){s=""}out+=(!n?"":SPACER4)+clr.BRIGHTGREEN(opt)+" : "+_optSpace(opt)+clr.BRIGHTCYAN(s)+NL}n++}for(opt in opts){if(!_isJafOption(opt)){try{s=JSON.stringify(opts[opt])}catch(e){s=""}out+=(!n?"":SPACER4)+clr.BRIGHTGREEN(opt)+" : "+_optSpace(opt)+clr.BRIGHTCYAN(s)+NL}}let lines=utils.lineWrap(rule.getShortDescription());out+=SPACER3+clr.BRIGHTCYAN("short")+"   : "+clr.BRIGHTCYAN(lines[0])+NL;for(i=1;i<lines.length;i++){out+=SPACER4+clr.BRIGHTCYAN(lines[i])+NL}lines=utils.lineWrap(rule.getDescription());out+=SPACER3+clr.BRIGHTCYAN("long")+"    : "+clr.BRIGHTWHITE(lines[0])+NL;for(i=1;i<lines.length;i++){out+=SPACER4+clr.BRIGHTWHITE(lines[i])+NL}out+=NL;haveProseRules=true};function getJson(){out.meta={"severity":severity};return out};function packToJson(rulePack){var ruleset;ruleset={};out.rulesets.push(ruleset);ruleset.title=rulePack.rulesJson.title;ruleset.path=rulePack.path;ruleset.prefix=rulePack.rulesJson.prefix;ruleset.version=rulePack.rulesJson.version;ruleset.rules=jsonRules={}};function ruleToJson(ruleName,rule,opts,msgIds,active){jsonRules[ruleName]=opts;if(active||rule){opts.messages=msgIds;opts.shortDescription=rule.getShortDescription();opts.description=rule.getDescription()}else{opts.shortDescription=opts.description=""}};function _isJafOption(opt){return JAF_OPTS.includes(opt)};function _optSpace(opt){var len=MAX_OPT_LEN-opt.length;return" ".repeat(len>=0?len:0)};function _limitLength(s,utils){if(s.length>200){for(let i=196;i>0;i--){if(utils.isWhitespace(s.charAt(i))){return s.substring(0,i+1)+ELLIPSIS}}s=ELLIPSIS}return s};function _escapeChevrons(s){let ret=s.replace(/\</g,"&lt;");ret=ret.replace(/\>/g,"&gt;");return ret.replace(/&nbsp;/g," ")};function _escapeCData(s){var i,bChange;while(true){bChange=false;i=s.indexOf("<oj-");if(i>=0){s=s.substr(0,i)+"&lt;"+s.substr(i+1);bChange=true;i=s.indexOf(">",i+1);if(i>=0){s=s.substr(0,i)+"&gt;"+s.substr(i+1)}i=s.indexOf("</oj-",i);if(i>=0){s=s.substr(0,i)+"&lt;"+s.substr(i+1);bChange=true;i=s.indexOf(">",i+1);if(i>=0){s=s.substr(0,i)+"&gt;"+s.substr(i+1)}}}i=s.indexOf("<!DOCTYPE");if(i>=0){s=s.substr(0,i)+"&lt;"+s.substr(i+1);i=s.indexOf(">",i+1);if(i>=0){s=s.substr(0,i)+"&gt;"+s.substr(i+1);bChange=true}}if(!bChange){break}}return s.replace(/&nbsp;/g," ")};module.exports={getXml:getXml,getProse:getProse,getJson:getJson,ruleToXml:ruleToXml,ruleToProse:ruleToProse,packToProse:packToProse,packToJson:packToJson,ruleToJson:ruleToJson,setupRulesToXml:setupRulesToXml,setupRulesToProse:setupRulesToProse,setupRulesToJson:setupRulesToJson};