/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const TSCONFIG="tsconfig.json";const PROFILE_DIR="profiles";const MERGEABLE_BY_DEFAULT={components:true,componentUrls:true,exclude:true,files:true,groups:true,message:true,nameSpaces:true,options:true,ruleMods:true,ruleNames:true,rulePacks:true,sevMap:true,typescript:true};const MERGEABLE_BY_OPTION={};const EXOPT_IGNORE="ignore";const EXOPT_MERGE="merge";const MSG={OBJ:"Config '%s' is not an object - %p",ARRAY:"Config '%s' is not an array - %p",STR:"Config '%s' is not a string - %p",STR_OR_AR_STR:"Config '%s' is not a string or an array of strings - %p",AR_OBJ:"Config '%s' is not an array of objects - %p",AR_STR:"Config '%s' is not an array of strings - %p",AR_STR_OBJ:"Config '%s' is not an array of strings or objects - %p",BOOL:"Config '%s' is not a boolean - %p",EXT_OPT:"Config 'extendOptions.%s' cannot be 'merge' - %p",EXT_OPT_VAL:"Config 'extendOptions.%s' not 'ignore' or 'merge' - %p",UNKNOWN:"Unknown config prop - '%s' - %p"};const REPL_PROP="%s";const REPL_PATH="%p";const DUMMY_FP="$_$";class Extends{constructor(configEx,configInst,cfg,path,nd,msgCtx,utils,fsUtils,isAMD){this._path=path;this._cfg=cfg;this._fp=cfg.base;this._nd=nd;this._msgCtx=msgCtx;this._utils=utils;this._fsUtils=fsUtils;this._cwd=nd.process.cwd();this._cfgEx=configEx;this._cfgInst=configInst;this._isAMD=isAMD;this._stack=[];this._extendOpts=null;this._profResult=null;this._error=msgCtx.error;this._info=msgCtx.info;this._isDebug=msgCtx.isDebug;this._isVerbose=msgCtx.isVerbose;this._mergeHandlers={components:this._mergePropComponents.bind(this),componentUrls:this._mergePropCompUrls.bind(this),exclude:this._mergePropExclude.bind(this),files:this._mergePropFiles.bind(this),groups:this._mergePropGroups.bind(this),messages:this._mergePropMessages,nameSpaces:this._mergePropNameSpaces.bind(this),options:this._mergePropOptions.bind(this),ruleMods:this._mergePropRuleMods.bind(this),ruleNames:this._mergePropRuleNames.bind(this),rulePacks:this._mergePropRulePacks,sevMap:this._mergePropSevMap.bind(this),typescript:this._mergePropTypescript.bind(this)}}extend(){if(!this._isDebug){this._isDebug=this._cfg.options&&this._cfg.options.debug}if(!this._isVerbose){this._isVerbose=this._cfg.options&&this._cfg.options.verbose}if(this._isDebug||this._isVerbose){this._msgCtx.info("[Info]: Merging configurations...","I",true)}if(!this._createStack()){return null}if(this._isDebug){this._dumpStack()}if(!this._isError){this._checkMergePropTypes();if(this._isError){return null}}if(!this._checkStackEnableDisableConflicts()||!this._checkUnsupportedProfileProps()||!this._checkProfileExtend()||!this._checkExtendOptionsProfile()||this._isError){return null}if(!this._stack.length){return this._cfg}return this._mergeStack()}_createStack(fp){var cfg,json,fp,first,stkEntry,profile;if(first=!fp){cfg=this._cfg;fp=this._isAMD?DUMMY_FP:this._path?this._path:this._fp}if(!fp){return true}if(this._utils.isObject(fp)){if(!(fp=this._resolveProfilePath(fp))){return false}if(fp.profile){profile=fp.profile}fp=fp.path}else if(!first&&typeof fp==="string"&&this._isAMD){this._error("Config cannot extend a non-profile config in AMD mode");return false}if(first){json=cfg}else if(this._isAMD){if(profile){if(json=this._nd.AmdProfLoader(profile)){json=this._parseJson(json)}if(!json){return false}}else{this._error("Config extends must contain a 'profile' propery in AMD mode");return false}fp=null}else{fp=this._getAbsolutePath(fp);if(!this._fsUtils.fileExists(fp)){let err=profile?`Configuration profile '${profile}' not found`:`Configuration file not found : ${fp}`;this._error(err);return false}if(this._isCircular(fp)){this._error(`Circular configuration 'extends' detected : ${fp}`);return false}try{if(!(json=this._readParseConfig(fp))){return false}}catch(e){this._error(`Error reading 'extends' config : ${fp}`);return false}}if(fp===DUMMY_FP){fp=null}stkEntry={path:fp,cfg:json};if(profile){stkEntry.profile=profile}this._stack.push(stkEntry);if(profile){if(!this._profResult){this._profResult={profiles:[profile]};if(json.ruleMods){if(json.ruleMods.enable){this._profResult.enable=json.ruleMods.enable}else{this._profResult.enable=[]}if(json.ruleMods.disable){this._profResult.disable=json.ruleMods.disable}else{this._profResult.disable=[]}}}else{this._profResult.profiles.push(profile)}}if(json.extends){if(!this._createStack(json.extends)){return false}}return true}_readParseConfig(fp){var json;json=this._nd.fs.readFileSync(fp,"utf8");json=this._nd.decomment(json);if(!(json=this._preprocessRawJson(json,fp))){return null}return this._parseJson(json,fp)}_parseJson(json,fp){var o;o=this._utils.parseJson(json,false);if(o.msg){let pos=`[${o.line}, ${o.col}]`;fp=fp?" : "+fp:"";this._error(`Config 'extends' error at ${pos} : ${o.msg}${fp}`);return null}return o.obj}_preprocessRawJson(txt,fp){var json=this._cfgInst.processIncludes(txt,fp);if(this._cfgInst.isOk()){json=this._cfgInst.processTokens(json);if(this._cfgInst.isOk()){}}return this._cfgInst.isOk()?json:null}_mergeStack(){if(!this._fixupPaths()){return null}for(let i=this._stack.length-1;i>0;i--){if(!this._mergePair(this._stack[i-1],this._stack[i])){return null}}if(this._isMergeProp("files")){if(this._stack[0].cfg.hasOwnProperty("files")){this._stack[0].cfg.files=_removeDupes(this._stack[0].cfg.files)}}if(this._isMergeProp("exclude")){if(this._stack[0].cfg.hasOwnProperty("exclude")){this._stack[0].cfg.exclude=_removeDupes(this._stack[0].cfg.exclude)}}if(this._stack[0].cfg.extends){delete this._stack[0].cfg.extends}return this._stack[0].cfg}_mergePair(parSE,chSE){var props,parent,child,merger,ret=true;parent=parSE.cfg;child=chSE.cfg;this._extendOpts=parSE.cfg.extendOptions||{};props=Object.keys(child);props.forEach(prop=>{if(prop.startsWith("_")||prop==="base"||prop==="extends"||prop==="tokens"||this._extendOpts[prop]===EXOPT_IGNORE){return}if(prop==="title"&&chSE.profile){return}if(!parent.hasOwnProperty(prop)){parent[prop]=child[prop];return}if(!this._isMergeProp(prop)){return}if(merger=this._mergeHandlers[prop]){if(!merger(parSE,chSE)){ret=false}}});if(!ret){return ret}if(!parSE.profile&&parSE.cfg.ruleNames){if(!this._checkRuleNamesProfileConflicts(parSE)){return false}}let type,what;if(chSE.profile){type="profile";what=chSE.profile}else{type="config";what=chSE.path}this._msgCtx.info(`[Info]: Inheriting ${type} '${what}'`,"I",true);return true}_checkMergePropTypes(){var cfg,se,prop,prop2,val;for(let i=0;i<this._stack.length;i++){se=this._stack[i];cfg=se.cfg;if(!this._cfgEx.checkPropNames(cfg,se.path)){this._isError=true}if(cfg.extendOptions){if(this._utils.isObject(cfg.extendOptions)){this._extendOpts=cfg.extendOptions;for(prop in this._extendOpts){val=this._extendOpts[prop];if(val===EXOPT_MERGE&&!MERGEABLE_BY_OPTION[prop]){this._emitErrorMsg(MSG.EXT_OPT,prop,se.path);return}else if(val!==EXOPT_MERGE&&val!==EXOPT_IGNORE){this._emitErrorMsg(MSG.EXT_OPT_VAL,prop,se.path);return}}}else{this._emitErrorMsg(MSG.OBJ,"extendOptions",se.path);return}}else{this._extendOpts={}}for(prop in cfg){if(!this._isMergeProp(prop)){continue}val=cfg[prop];if(prop==="components"||prop==="componentUrls"){if(typeof val!=="string"&&!Array.isArray(val)||!this._utils.isArrayContentsType(val,"string")){this._emitErrorMsg(MSG.STR_OR_AR_STR,prop,se.path)}}else if(prop==="files"){if(!Array.isArray(val)){this._emitErrorMsg(prop,prop,se.path)}if(!this._utils.isArrayContentsType(val,["string","object"])){this._emitErrorMsg(MSG.AR_STR_OBJ,prop,se.path)}}else if(prop==="exclude"){if(!Array.isArray(val)||!this._utils.isArrayContentsType(val,"string")){this._emitErrorMsg(MSG.STR_OR_AR_STR,prop,se.path)}}else if(prop==="groups"){if(!Array.isArray(val)){this._emitErrorMsg(MSG.STR,prop,se.path)}}else if(prop==="messages"){if(!this._utils.isObject(val)){this._emitErrorMsg(MSG.OBJ,prop,se.path)}if(se.messages.reject){if(!Array.isArray(se.messages.reject)){this._emitErrorMsg(MSG.OBJ,"messages.reject",se.path)}}if(se.messages.accept){if(!Array.isArray(se.messages.accept)){this._emitErrorMsg(MSG.OBJ,"messages.accept",se.path)}}}else if(prop==="nameSpaces"){if(!Array.isArray(val)){this._emitErrorMsg(MSG.AR_STR,prop,se.path)}}else if(prop==="options"){if(!this._utils.isObject(val)){this._emitErrorMsg(MSG.OBJ,prop,se.path)}}else if(prop==="ruleMods"){if(!this._utils.isObject(val)){this._emitErrorMsg(MSG.OBJ,prop,se.path);continue}for(prop2 in val){if(prop2==="enable"||prop2==="disable"){if(!Array.isArray(val[prop2])){this._emitErrorMsg(MSG.AR_OBJ,prop2==="enable"?"ruleMods.enable":"ruleMods.disable",se.path)}}else{if(!this._utils.isObject(val[prop2])){this._emitErrorMsg(MSG.AR_OBJ,prop+"."+prop2,se.path)}}}}else if(prop==="ruleNames"){if(!Array.isArray(val)||!this._utils.isArrayContentsType(val,"string")){this._emitErrorMsg(MSG.AR_STR,prop,se.path)}}else if(prop==="rulePacks"){if(!Array.isArray(val)||!this._utils.isArrayContentsType(val,"object")){this._emitErrorMsg(MSG.AR_OBJ,prop,se.path)}}else if(prop==="sevMap"){if(!this._utils.isObject(val)){this._emitErrorMsg(MSG.OBJ,prop,se.path)}if(val.sevMsg&&!this._utils.isObject(val.sevMsg)){this._emitErrorMsg(MSG.OBJ,prop+".sevMsg",se.path)}if(val.sevSet&&!this._utils.isObject(val.sevSet)){this._emitErrorMsg(MSG.OBJ,prop+".sevSet",se.path)}}else if(prop==="tokens"){if(!this._utils.isObject(val)){this._emitErrorMsg(MSG.OBJ,prop,se.path)}}else if(prop==="typescript"){if(!this._utils.isObject(val)){this._emitErrorMsg(MSG.OBJ,prop,se.path)}for(prop2 in val){if(prop2==="tsconfig"&&typeof val[prop2]!=="string"){this._emitErrorMsg(MSG.STR,"typescript.tsconfig",se.path)}if(prop2==="compile"&&typeof val[prop2]!=="boolean"){this._emitErrorMsg(MSG.BOOL,"typescript.compile",se.path)}}}else{this._error(`JAF ERROR: unhandled 'extends' property '${prop}' - ${se.path}`);this._isError=true}}}}_checkStackEnableDisableConflicts(){var config,i,b=true;for(i=this._stack.length-1;i>=0;i--){config=this._stack[i];if(!this._cfgEx.processRuleMods(config.cfg,config.profile?`profile '${config.profile}'`:config.path)){b=false}}if(!b){this._isError=true}return b}_checkRuleNamesProfileConflicts(parSE){var enable,rules,rule,i,profiles,isSet,b=true;if(!(this._profResult&&this._profResult.enable)){return true}rules=parSE.cfg.ruleNames;enable=this._profResult.enable;isSet=this._profResult.profiles.length>1;profiles=(isSet?"set [":"'")+this._profResult.profiles.join(", ")+(isSet?"]":"'");for(i=0;i<enable.length;i++){rule=enable[i];if(!rules.includes(rule)){this._msgCtx.error(`Config 'ruleNames' cannot disable rule '${rule}' enabled in profile ${profiles} - ${parSE.path}`);b=false}}if(!b){this._isError=true}return b}_checkUnsupportedProfileProps(){var se,config,i,b=true;var _self=this;function _emitUnsupProfileError(prof,prop){_self._msgCtx.error(`Property '${prop}' is not supported in profile ('${prof}')`);_self._isError=true;b=false}for(i=this._stack.length-1;i>=0;i--){se=this._stack[i];if(se.profile){config=se.cfg;if(config.ruleNames){_emitUnsupProfileError(se.profile,"ruleNames")}if(config.groups){_emitUnsupProfileError(se.profile,"groups")}}}return b}_checkProfileExtend(){var i;var stk=this._stack;for(i=0;i<stk.length;i++){if(!stk[i].profile){continue}for(i=i+1;i<stk.length;i++){if(!stk[i].profile){this._msgCtx.error(`Profile '${stk[i-1].profile}' cannot extend from a non-profile config - ${stk[i].path}`);return false}}break}return true}_checkExtendOptionsProfile(){if(this._profResult){let stk=this._stack;let opts;for(let i=0;i<stk.length;i++){if(opts=stk[i].cfg.extendOptions){if(opts.ruleMods==="ignore"){let isSet=this._profResult.profiles.length>1;let profiles=(isSet?"set [":"'")+this._profResult.profiles.join(", ")+(isSet?"]":"'");this._msgCtx.error(`Config cannot use 'extendsOptions.ruleMods' to ignore inherited 'ruleMods' from profile ${profiles} - ${stk[i].path}`);return false}}}}return true}_resolveProfilePath(o){var prof,ret;if(!(prof=o.profile)){this._error(`JAF ERROR: 'extends' declared as an object but property 'profile' is missing.`);this._isError=true;return null}ret={profile:o.profile};if(!this._isAMD){ret.path=this._nd.path.join(__dirname,"../"+PROFILE_DIR,prof)+".json"};return ret}_fixupPaths(){var se,ret=true;for(let i=this._stack.length-1;i>=0;i--){se=this._stack[i];if(!(this._cleanBase(se)&&this._fixupConfig(se))){ret=false;break}}return ret}_cleanBase(se){if(this._isAMD){return true}var src,ft;var nd=this._nd;src=se.cfg.base;if(src==="$jafcwd"){src=this._cwd}else{if(!src){src=this._nd.path.dirname(se.path)}src=nd.path.normalize(src);if(!nd.path.isAbsolute(src)){src=nd.path.join(nd.path.dirname(se.path),src)}ft=this._fsUtils.getFileType(src);if(ft!=="d"){this._msgCtx.error(`Config file 'base' is not a directory - '${src}' in ${se.path}`);return false}}se.cfg.base=src;this._info(`[Info]: Using config base '${src}' in ${se.path}`,"I");return true}_fixupConfig(se){var nd,cfg,src,dir,ft,i;nd=this._nd;cfg=se.cfg;if(cfg.files){if(!this._cfgEx.validateFileList(cfg.files)){this._bErrors=true;return}if(src=se.cfg.files){for(i=0;i<src.length;i++){if(!src[i].startsWith("http")){src[i]=nd.path.normalize(src[i]);src[i]=nd.path.resolve(cfg.base,src[i])}}}}if(cfg.exclude){if(!this._cfgEx.validateFileList(cfg.exclude)){this._bErrors=true;return}if(src=cfg.exclude){for(i=0;i<src.length;i++){src[i]=nd.path.normalize(src[i]);src[i]=nd.path.resolve(cfg.base,src[i])}}}src=cfg.components;if(src){for(i=0;i<src.length;i++){dir=nd.path.normalize(src[i]);dir=nd.path.resolve(cfg.base,dir);cfg.components[i]=dir}}src=cfg.outPath;if(src&&src!=="$noout"){src=nd.path.normalize(src);src=nd.path.resolve(cfg.base,src);cfg.outPath=src}src=cfg.rulePacks;if(src){for(i=0;i<src.length;i++){dir=src[i].path;dir=nd.path.normalize(dir);src[i].path=nd.path.resolve(cfg.base,dir);if(src[i].path.endsWith(".zip")){continue}ft=this._fsUtils.getFileType(src[i].path);if(ft!=="d"){this._error("'rulePacks (entry "+(i+1)+"): path' is not a directory - \""+src[i].path+"\"");this._bErrors=true}}}if(cfg.typescript&&cfg.typescript.tsconfig){src=cfg.typescript.tsconfig;if(src&&typeof src==="string"){if(!nd.path.isAbsolute(src)){dir=nd.path.normalize(src);dir=nd.path.resolve(cfg.base,dir)}else{dir=src}if(!dir.endsWith(TSCONFIG)){dir=nd.path.join(dir,TSCONFIG)}cfg.typescript.tsconfig=dir}}if(this._bErrors){this._error(`Errors found in inherited config '${se.path}'`)}return!this._bErrors}_getAbsolutePath(fp){if(this._nd.path.isAbsolute(fp)){return fp}let prevFp,prevBase,p;prevFp=this._stack[this._stack.length-1].path;prevFp=this._nd.path.dirname(prevFp);prevBase=this._stack[this._stack.length-1].cfg.base;if(prevBase){if(!this._nd.path.isAbsolute(prevBase)){p=this._nd.path.join(prevFp,prevBase,fp)}else{p=this._nd.path.join(prevBase,fp)}}else{p=this._nd.path.join(prevFp,fp)}if(!this._nd.path.isAbsolute(p)){p=this._nd.path.join(this._dir,p)}return p}_isCircular(fp){var ret;for(let i=0;i<this._stack.length;i++){if(this._stack[i].path===fp){ret=true;break}}return ret}_isMergeProp(p){return MERGEABLE_BY_DEFAULT[p]||this._extendOpts[p]===EXOPT_MERGE}_mergePropFiles(parSE,chSE){return this._mergePropFilesExclude(parSE,chSE,"files")}_mergePropExclude(parSE,chSE){return this._mergePropFilesExclude(parSE,chSE,"exclude")}_mergePropFilesExclude(parSE,chSE,prop){var parent,child,ch,i;var parent=parSE.cfg[prop];var child=chSE.cfg[prop];for(i=0;i<child.length;i++){ch=child[i];if(!parent.includes(ch)){parent.push(ch)}}return true}_mergePropOptions(parSE,chSE){return this._mergeObjects(parSE,chSE,"options")}_mergePropGroups(parSE,chSE){return this._mergeArrays(parSE,chSE,"groups")}_mergePropTokens(parSE,chSE){return this._mergeObjects(parSE,chSE,"tokens")}_mergePropNameSpaces(parSE,chSE){return this._mergeArrays(parSE,chSE,"nameSpaces")}_mergePropRuleMods(parSE,chSE){var pname,pack,parPack,rule,rval;var parent=parSE.cfg.ruleMods;var child=chSE.cfg.ruleMods;if(!this._mergeRuleModsEnableDisable(parSE,chSE)){return false}for(pname in child){if(pname==="enable"||pname==="disable"){continue}pack=child[pname];if(!parent[pname]){parent[pname]=pack;continue}this._mergeRuleModsPackObjects(parent[pname],pack)}parPack=parent[pname];for(rule in rval){if(!parPack[rule]){parPack[rule]=rval[rule]}}return true}_mergeRuleModsEnableDisable(parSE,chSE){var parent,child,val,x;var parEnable,parDisable,chEnable,chDisable;var parent=parSE.cfg.ruleMods;var child=chSE.cfg.ruleMods;parEnable=parent.enable;parDisable=parent.disable;chEnable=child.enable;chDisable=child.disable;var self=this;function _profVetoEnable(val){var ret=false;if(self._profResult&&self._profResult.disable){ret=self._profResult.disable.includes(val)}return ret}function _profVetoDisable(val){var ret=false;if(self._profResult&&self._profResult.enable){ret=self._profResult.enable.includes(val)}return ret}if(parEnable&&chDisable){for(val of parEnable){if(!(parSE.profile&&chSE.profile)){if(_profVetoEnable(val)){this._emitProfileVetoError(val,parSE.path,false);return false}}if((x=chDisable.indexOf(val))>=0){chDisable.splice(x,1)}}}if(parDisable&&chEnable){for(val of parDisable){if(!(parSE.profile&&chSE.profile)){if(_profVetoDisable(val)){this._emitProfileVetoError(val,parSE.path,true);return false}}if((x=chEnable.indexOf(val))>=0){chEnable.splice(x,1)}}}if(chEnable){if(!parEnable){parent.enable=parEnable=[]}for(val of chEnable){if(!parEnable.includes(val)){parEnable.push(val)}}}if(chDisable){if(!parDisable){parent.disable=parDisable=[]}for(val of chDisable){if(!parDisable.includes(val)){parDisable.push(val)}}}if(parSE.profile&&chSE.profile){if(!this._profResult){this._profResult={}}this._profResult.enable=parEnable;this._profResult.disable=parDisable;if(this._isDebug){console.log(`Profile merge: ${parSE.profile}  <- ${chSE.profile}`)}}else{if(this._isDebug){console.log(`Merge: '${parSE.path}'  <- '${chSE.profile?chSE.profile:chSE.path}'`)}}if(this._isDebug){console.log(`${parSE.path} <- ${chSE.path}`);console.log(`Enable  = ${parEnable.join(",\n  ")}`);console.log(`Disable = ${parDisable.join(",\n  ")}\n`)}return true}_emitProfileVetoError(rule,cfgPath,disable){var profiles,temp,op1,op2;temp=[...this._profResult.profiles];temp.forEach((rule,i)=>{temp[i]="'"+rule+"'"});temp=temp.join(", ");if(disable){op1="disable";op2="enabled"}else{op1="enable";op2="disabled"}profiles="profile"+`${this._profResult.profiles.length>1?" set [":""} ${temp}${this._profResult.profiles.length>1?"]":""}`;cfgPath=cfgPath?`in ${cfgPath} `:"";this._error(`Config 'ruleMods' conflict: cannot ${op1} rule '${rule}' ${cfgPath}- ${op2} by ${profiles}`)}_mergePropRuleNames(parSE,chSE){return this._mergeArrays(parSE,chSE,"ruleNames")}_mergePropRulePacks(parSE,chSE){var parent=parSE.cfg.rulePacks;var child=chSE.cfg.rulePacks;for(let i=0;i<child.length;i++){let ch=child[i];let b=false;for(let j=0;j<parent.length;j++){let par=parent[j];if(ch.path===par.path){b=true;break}}if(!b){parent.push(ch)}}return true}_mergePropMessages(parSE,chSE){var parent=parSE.cfg.messages;var child=chSE.cfg.messages;var parReject=parent.reject;var chReject=child.reject;if(!parReject&&chReject){parent.reject=chReject}else if(parReject&&chReject){parent.reject=_removeDupes(parReject.concat(chReject))}var parAccept=parent.accept;var chAccept=child.accept;if(!parAccept&&chAccept){parent.accept=chAccept}else if(parAccept&&chAccept){parent.accept=_removeDupes(parAccept.concat(chAccept))}return true}_mergePropComponents(parSE,chSE){return this._mergeArrays(parSE,chSE,"components")}_mergePropCompUrls(parSE,chSE){return this._mergeArrays(parSE,chSE,"componentUrls")}_mergePropTypescript(parSE,chSE){return this._mergeObjects(parSE,chSE,"typescript")}_mergePropSevMap(parSE,chSE){var parent=parSE.cfg.sevMap;var child=chSE.cfg.sevMap;var parSevMsg,chSevMsg;var parSevSet,chSevSet;if(parent){parSevMsg=parent.sevMsg;parSevSet=parent.sevSet}if(child){chSevMsg=child.sevMsg;chSevSet=child.sevSet}if(parSevMsg&&chSevMsg){let prop;for(prop in chSevMsg){if(!parSevMsg[prop]){parSevMsg[prop]=chSevMsg[prop]}}}else if(!parSevMsg&&chSevMsg){parent.sevMsg=chSevMsg}if(parSevSet&&chSevSet){let prop;for(prop in chSevSet){if(!parSevSet[prop]){parSevSet[prop]=chSevSet[prop]}}}else if(!parSevSet&&chSevSet){parent.sevSet=chSevSet}if(parent.sevSet&&parent.sevMsg){let sev,msg,oldsev,val;for(val in parent.sevSet){sev=parent.sevSet[val];for(msg in parent.sevMsg){oldsev=parent.sevMsg[msg];if(val===oldsev){parent.sevMsg[msg]=sev}}}}return true}_mergeObjects(parSE,chSE,prop){var parent,child;parent=parSE.cfg[prop];child=chSE.cfg[prop];for(let prop in child){if(!parent.hasOwnProperty(prop)){parent[prop]=child[prop]}}return true}_mergeRuleModsPackObjects(to,from){var rule;for(rule in from){if(!to[rule]){to[rule]=from[rule]}}}_mergeArrays(parSE,chSE,prop){var parent,child,isPS,isCS,isPA,isCA,val;parent=parSE.cfg[prop];child=chSE.cfg[prop];isPS=typeof parent==="string";isCS=typeof child==="string";if(isPS&&isCS&&parent===child){return}isPA=Array.isArray(parent);isCA=Array.isArray(child);parent=isPA?parent:[parent];child=isCA?child:[child];for(let i=0;i<child.length;i++){val=child[i];if(!parent.includes(val)){parent.push(val)}}return true}_emitErrorMsg(s,prop,path){var s=s||MSG.UNKNOWN;if(prop){s=s.replace(REPL_PROP,prop)}this._error(s.replace(REPL_PATH,path));this._isError=true}_parseError(msg){this._parseError=msg}_dumpStack(){var type,msg;this._msgCtx.info("[Info]: -- Config 'extends' stack --","I",true);for(let i=0;i<this._stack.length;i++){type=this._stack[i].profile;type=type?type:"config  ";msg=!this._isAMD?`${type}  ${this._stack[i].path}`:`${type}`;this._msgCtx.info(`[Info]:   ${msg}`,"I",true)}}}function _removeDupes(ar){return Array.isArray(ar)?ar.filter((val,x)=>ar.indexOf(val)===x):ar};module.exports=Extends;