/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const INDENT="   ";const LEFT="\u2502  ";const RIGHT="  \u2502";var clr;function show(manPage,syn,color){var page,lines,ret;if(page=_MANPAGES[manPage]){clr=color;_showTitle(manPage,syn);lines=_processSynopsis(page);lines.forEach(line=>{console.log(line)});lines=_processDescription(page);lines.forEach(line=>{console.log(line)});lines=_processOptions(page);lines.forEach(line=>{console.log(line)});console.log("\n");ret=true}else{console.log(`Internal Error:  manpage --${manPage} not found\n`);ret=false}return ret};function _processSynopsis(page){var i;var maxlen=0;var lines=page.synopsis;lines.forEach(line=>{maxlen=maxlen<line.length?line.length:maxlen});maxlen+=INDENT.length;for(i=0;i<lines.length;i++){lines[i]=_boxLine(lines[i],maxlen)}lines.splice(0,0,_boxStart(maxlen));lines.push(_boxEnd(maxlen));lines.forEach((line,i)=>{lines[i]=clr.BRIGHTGREEN(line)});lines=_indent(lines);lines.splice(0,0,clr.BRIGHTYELLOW("\xA7 Synopsis:"));return lines};function _processDescription(page){var lines=page.description;lines.splice(0,0,"\n"+clr.BRIGHTYELLOW("Description:"));return _indent(lines,true)};function _processOptions(page){var lines=page.options;lines.splice(0,0,"\n"+clr.BRIGHTYELLOW("Options:"));return lines=_indent(lines,true)};function _showTitle(manpage,syn){console.log("\n"+INDENT+clr.BLACKONRED(`***     Manual Page for --${manpage}  :  Short form  -${syn}     ***`)+"\n")}function _indent(lines,notFirst){lines.forEach((line,i)=>{if(!notFirst||i)lines[i]=INDENT+line});return lines};function _boxStart(max){return"\u250C\u2500\u2500"+"\u2500".repeat(max)+"\u2500\u2500\u2510"};function _boxEnd(max){return"\u2514\u2500\u2500"+"\u2500".repeat(max)+"\u2500\u2500\u2518"};function _boxLine(line,max){return LEFT+line+" ".repeat(max-line.length)+RIGHT};const _MANPAGES={"amdlist":{synopsis:["--amdlist","--amdlist  <packprefix>   Displays the rules available/unavailable in AMD mode for the specified pack prefix.","","-amd","-amd  <packprefix>        Displays the rules available/unavailable in AMD mode for the specified pack prefix."],description:["Displays the JET built-in rules that are available/unavailable in AMD mode by default in JET builtin rulepacks.","No audit is performed"],options:["--amdlist                   \u25CF Displays the rules available/unavailable in AMD mode for all JET built-in rulepacks.\n","--amdlist  <pack prefix>    \u25CF Displays the rules available/unavailable in AMD mode for the specified pack prefix,","                              e.g.  --amdlist   jet","                              Note: the pack prefix may be of any case."]},"base":{synopsis:["--base  <filepath>","-b      <filepath>"],description:["Specifies the base filepath upon which relative files paths ae resolved (e.g. the --config command, or other"," relative paths in the configuration).\n"],options:["<filepath>    \u25CF  The base filepath.  If the base path is itself relative, it is considered to be relative to","                 the current working directory. This command overrides the 'base' property in the configuration","                 file.","","* Note that the filepath may be specified with forward slashes even on the Windows platform."]},"betalist":{synopsis:["--betalist","--betalist  <pack prefix>","","-bl","-bl           <pack prefix>"],description:["Displays the JET built-in rules that are available, but not in production status."],options:["<pack prefix>    \u25CF   Specify a pack prefix (case independent) to restrict the output to the","                     rules in the pack.  e.g.   ojaf  --gl  jet"]},"config":{synopsis:["--config  <path to configuration file>","","-c  <path to configuration file>"],description:["specifies the configuration file to use for the audit."],options:["<path to configuration file>    \u25CF  Full or relative path to the configuration file.\n","                                   If path is relative, it is considered to be relative to the current","                                   working directory, or to the path specified by --base (or -b).","                                   The path may use forward slashes on the Windows platform, to avoid","                                   escaping the backslashes."]},"dac":{synopsis:["--dac"],description:["Displays the active configuration.  This is the configuration that would be used in an audit after","resolving any inheritance via the 'extends' configuration property.  No audit is performed.\n","The configuration used is either that specified on the command line (using the --config or -c command),","or the 'jafconfig.json' or oraclejetconfig.json' found in the current woriking directory"],options:[" - None -"]},"debug":{synopsis:["--debug","-d"],description:["Enables debug mode (very verbose).  Useful for diagnosing problems."],options:[" - None -"]},"deflist":{synopsis:["--deflist","-def"],description:["Displays the configuration default property values."],options:[" - None -"]},"dislist":{synopsis:["--dislist","--dislist  <pack prefix>","","-dl","-dl <pack Prefix>"],description:["Displays the JET built-in rules disabled by default."],options:["<pack prefix>  \u25CF  Displays the rules disabled by default for the specified built-in JET pack prefix","                  e.g.  --dislist jet,  or  --dislist  jetwco","                  Note: the pack prefix may be of any case. If the pack prefix is omitted, the disabled","                  default rules are displayed for all JET built-in rulepacks."]},"deplist":{synopsis:["--deplist","--deplist  <pack prefix>","","-dpl","-dpl  <pack prefix>"],description:["Displays the JET built-in rules deprecated by default."],options:["<pack prefix>  \u25CF  Displays the rules deprecated by default for the specified built-in JET pack prefix","                  e.g.  --deplist jet,  or  --deplist  jetwco","                  Note: the pack prefix may be of any case. If the pack prefix is omitted, the deprecated","                  default rules are displayed for all JET built-in rulepacks."]},"dryrun":{synopsis:["--dryrun","-dr"],description:["Performs a full start-up and analysis of the configuration file, but does not actually fire any rules on the fileset","generated by the configuration 'files' and 'exclude' options. Useful for verifying that the configuration file contains","no errors, and to display the files that would have been audited - this is particularly useful with complex files and","exclude options, without having to inspect the full output.\n","The command should be followed either by a --config (or -c) and the configuration file path, or ojaf will use the","'oraclejetconfig.json' or the 'jafconfig.json' if found in the current working directory, else a default","configuration is dynamically generated."],options:[" - None -"]},"extra":{synopsis:["--extra","-e"],description:["Enables verbose mode.  Extra informational details are shown in the output.  Useful when creating an audit","with a complex configuration."],options:[" - None -"]},"followlinks":{synopsis:["--followlinks","-fl"],description:["Enables the following of HTML stylesheet <link> elements and audit of the linked-to stylesheets.  This overrides the","value of configuration property 'followlinks' if it is specified as false."],options:[" - None -"]},"format":{synopsis:["--format  <format>",""],description:["Specifies the format of the ojaf output."],options:["<format>    \u25CF  The following formats are available:\n","                  prose   -  the standaard default text report style output","                  line    -  a flattened-out text style single line output.  Useful in a VS Code","                             terminal window.","                  json    - JSON output\n","               Example:\n ","                  --format  line"]},"grouplist":{synopsis:["--grouplist","--grouplist  <pack prefix>","","-gl","-gl  <pack prefix>"],description:["Displays the rulenames classified by group."],options:["<pack prefix>    \u25CF   Specify a pack prefix (case independent) to retrict the output to the","                     groups provided by the pack.  e.g.   ojaf  --gl  jet"]},"groups":{synopsis:["--groups \"<groupname\" [, \"<groupname>\" [, \"<groupname>\" . . .] ]","--groups=\"<groupname>, <groupname>, < . . .\"","","-g \"<groupname\" [, \"<groupname>\" [, \"<groupname>\" . . .] ]","-g=\"<groupname>, <groupname>, < . . .\""],description:["Specifies the group(s), which are rule name sets, that are to be applied to the audit.  This","command overrides the configuration file property 'groups' if specified."],options:["<groupname>  \u25CF  A group name:\n","   all             All groups are applied","   jet-aria        Accessibility rules","   jet-bp          Best practices rules","   jet-cca         Web component metadata","   jet-css         CSS rules","   jet-csp         Rules checking for Content Security Policy violations","   jet-deleted     Rules checking deleted status","   jet-deprecated  Rules checking deprecated status","   jet-html        HTML rules","   jet-json        JSON rules","   jet-js          JavaScript rules","   jet-md          Markdown rules","   jet-override    Rules that chack forr CSS overrides","   jet-perf        Performance rules","   jet-redwood-bp  Best practices rules for Redwood","   jet-ts          JET .ts related rules","   jet-tsx         JET .tsx related rules","   html5           Rules related to HTML 5\n","For JETWC Extended Audits:","   jetwc-structure\t   Audits that check that the overall disk layout is as expected by","                        the Oracle JET tooling and the requirements of Component reliable","                        referencing. This group should be enabled for most component sets","   jetwc-dependencies   Audits that verify the various dependency relationships between components","                        both within and across packs. This group should be enabled for all","                        component sets","   jetwc-pre-release\t   A set of audits to be run before you cut a production release","   jetwc-api            Rules that verify the consistency and correctness of your component APIs.","                        This group should be enabled for all component sets","   jetwc-vb             A set of rules that specifically check for things that effect the Visual","                        Builder usage experience of your components.","   jetwc-nls            Rules relating to NLS support","   jetwc-deprecations   Rules that check for known deprecated usages.","   jetwc-theming        Rules to enable if you are trying to create theme-able components\n","The following audit groups are defined in the builtinJetWcOracleRules (JETWCO) rule-set:\n","   jetwco-pre-release   A set of audits to be run before you cut a production release","   jetwco-api           Rules that verify the consistency and correctness of your component APIs.","   jetwco-doc           Enforcement of Oracle doc standards"]},"help":{synopsis:["--help                   Display the help command list","--help  <message-id>     Display a rule message ID help","--help  <rule-name>      Display help for a rule","--help  <command>        Display the manual page for a command","","-h","--h  <message-id>        Display a rule message ID help","--h  <rule-name>         Display help for a rule","--h  <command>           Display the manual page for a command"],description:["The --help (or -h) command displays general command help, specific help for a rule message ID, or for rule name,","or a manual page for a help command.","","\u25CF With no options specified, --help generates a list of the CLI commands available.\n","\u25CF With a message ID specified, the help/description for the associated rule is displayed.\n","\u25CF With a rulename specified, the  help/description for the rule is displayed.\n","\u25CF With a help command, the manual page for the command is displayed."],options:["<message-id>   \u25CF Specify the full message ID,  e.g.  --help  jet-1234  (the prefix may be of any case)\n","               \u25CF Specify the message number without a prefix.  The prefix defaults to 'JET-'', e.g.  --help 2170\n","               \u25CF Note: if the message number starts with one or more preceding zeros, they may be omitted","                 e.g.  --help  430\n","<rule name>    \u25CF the full rule name,  e.g.  --help  oj-html-stylesel\n","<command>      \u25CF a help command from the list of commands displayed by --help,  e.g.  --help  jetlist","                 Note: the manpage for a command can also be displayed by suffixing the command with a '?'","                       e.g.   --retcode?  or -ir?"]},"init":{synopsis:["--init","-i"],description:["Scaffolds a (skeleton) jaf configuration file in the directory in which it was run.\n","The command should be run in the top level project directory.  The command uses the","'oraclejetonfig.json' file (used by ojet), if present, to generate an 'oraclejafconfig.json'","file, or a default 'jafconfig.json' if not."],options:[" - None -"]},"initrule":{synopsis:["--initrule  <rulename>","","-ir  <rulename>"],description:["Creates a scaffolded (skeleton) rule file in the current working directory to use as basis for developing a new rule."],options:["<rulename>    \u25CF The name of the rule without the file extension,  e.g.  --initrule  my-new-rule"]},"jetlist":{synopsis:["--jetlist","-jl"],description:["Displays the JET versions supported by the version of ojaf being used."],options:[" - None -"]},"jetver":{synopsis:["--jetver  <semver>","","-jv  <semver>"],description:["Specifies the JET version to audit against.  This overrides the 'jetVer' property in the configuration","file."],options:["<semver>   \u25CF  A full or partial semantic version, e.g. major[.minor[.patch]].","              Two formats are supported: as two consecutive arguments, or as a single argument using '='","              e.g.  --jetver 12","                    --jetver 12.1","                    --jetver 12.0.0\n","                    --jetver=12","                    --jetver=12.1","                    --jetver=12.0.0\n","                    -jv 12","                    -jv 12.1","                    -jv 12.0.0\n","                    -jv=12","                    -jv=12.1","                    -jv=12.0.0\n","              When a partial semver is supplied, ojaf will match it to the highest JET version that it","              supports. Generally speaking, only the major or major.minor values are required.","              The list of the supported JET versions supported by the current ojaf version can be displayed","              by using   ojaf  -jl"]},"loadorder":{synopsis:["--loadorder","--loadorder  <pack prefix>","","-rlo","-rlo  <pack prefix>"],description:["Displays the load order of built-in JET rules.","This mainly for use by JET rulepack developers."],options:["<pack prefix>   \u25CF  A rule pack prefix (case independent)  e.g.","                       ojaf  -rlo  jet","                       ojaf  -rlo  jetwc"]},"maintenance":{synopsis:["--maintenance","-mnt"],description:["Displays the components that are in 'maintenance' mode, and the components that supersede them.\n","This command always displays the maintenance state for JET legacy components without any other options.","If ojaf can locate the JET Core Pack, this will also be included. If the core pack is not directly","available to ojaf, then a configuration file should be specified (via -c) to declare the location of the","core pack.  Similarly, external components will also be checked if the configuration file specifies their","location using the 'components' property."],options:[" - None -"]},"metahist":{synopsis:["--metahist","-mh"],description:["Displays the JET metadata history known to the version of ojaf being used.","This history includes deleted components, renamed classes, deleted classes, and","methods and members."],options:[" - None -"]},"migrator":{synopsis:["--migrator","-mig"],description:["Invokes the JET legacy component to Core Pack component migration tool."],options:["Additional optional CLI args available:\n","  --Long--  --Short-- ----------- Description------------------\n","  --jetver    (-jv)   - the JET version as a full or partial semver","  --config    (-c)    - the full or relative path to a configuration JSON file","  --outpath   (-o)    - the full or relative path to the output file","  --dryrun    (-dr)   - perform a dry run, no migration performed","  --nocolor   (-nc)   - suppress color in CLI mode","  --extra     (-e)    - verbose mode","  --debug     (-d)    - debug mode\n","The jetver, config, and outpath commands take an additional argument.  This can be","supplied as:","1)  an argument following the command line flag, e.g. --jetver 15.0.0   or","2)  as a single argument,  e.g.  --jetver=15.0.0","","* Note that filepaths for config and outpath may be specified with forward slashes","  on all platforms (including Windows)."]},"msgid":{synopsis:["--msgid","-id"],description:["Causes the message ID to be appended to the displayed audit issue when in 'prose' mode (see --format).\n","This commad overrides the configuration property  options.msgid\n","Note: this command is ignored if the configuration property 'proseFormat' defines a custom format.)"],options:[" - None -"]},"nslist":{synopsis:["--nslist","-nsl"],description:["Displays the JET namespaces known to the version of ojaf being used."],options:[" - None -"]},"nocolor":{synopsis:["--nocolor","-nc"],description:["Turns off CLI display in color.  By default ojaf assumes color mode and a dark mode shell window. This","command overrides the configuration file property options.color","ojaf color support can be turned off globally by setting environment variable 'JAF_COLOR' to false."],options:[" - None -"]},"nodebug":{synopsis:["--nodebug","-nd"],description:["Disables debug mode set in the configuration 'options' property."],options:[" - None -"]},"noextra":{synopsis:["--noextra","-ne"],description:["Disables verbose mode set in the configuration 'options' property.  This is a synonym for --noverbose."],options:[" - None -"]},"nofollowlinks":{synopsis:["--nofollowlinks","-nfl"],description:["Suppresses the following of HTML stylesheet <link> elements.  This overrides the value of configuration property","'followlinks' if specified as true (or its default true value if omitted). "],options:[" - None -"]},"noout":{synopsis:["--noout","-no"],description:["Suppresses output to the file specified in the configuration file by property 'outPath', and causes the audit","output to be directed to the console. This command is mutually exclusive with '--outPath'."],options:[" - None -"]},"noverbose":{synopsis:["--noverbose","-nv"],description:["Disables verbose mode set in the configuration 'options' property.  This is a synonym for --noextra"],options:[" - None -"]},"outPath":{synopsis:["--outPath  <filepath>","","-o <filepath>"],description:["Specifies the file path to which the audit output will be written.  This command is mutually exclusive with --noout."],options:["<filepath>    \u25CF  If the file path is relative, it is resolved relative to the current directory.","* Note that the filepath may be specified with forward slashes even on the Windows platform."]},"profiles":{synopsis:["--profiles","--profiles  <profile name>","","-prof","-prof  <profile name>"],description:["Displays a list of the available inheritable/extendable configuration profiles.","Can also display a profile if the command is followed by a profile name."],options:["<profile name>   \u25CF  The name of a profile from the list pf profiles, e.g.  --profiles redwood-strict"]},"reg":{synopsis:["--reg"],description:["Displays rule listener types.","This is primarily a resource for JAF development"],options:[" - None -"]},"retcode":{synopsis:["--retcode  auto","--retcode=auto","--retcode  <number>","--retcode=<number>","--retcode  errors","--retcode  <severities>","--retcode=<severities>","","-rc  auto","-rc=auto","-rc  <number>","-rc=<number>","-rc  errors","-rc  <severities>","-rc=<severities>"],description:["Overrides the ojaf CLI return code."],options:["auto         \u25CF  Specifiy 'auto' for the default behavior (i.e. returns the number of issues found).  e.g.\n","                --retcode=auto  or   -rc=auto  or --retcode auto    or   -rc auto\n","errors       \u25CF  Specify 'errors' if the return code should be 0, except in the case of abnormal termination","                where -1 will still be returned as in the default mode.\n","<number>     \u25CF  A number that will be used as the return code.  e.g.\n","                --retcode=0  or   -rc=0  or --retcode 0    or   -rc 0\n","<severities> \u25CF  Specify one or more severities.  The return code will formed from the sum of the issues found","                for those severities, The severities can be separated with commas and/or blanks as needed","                depending upon whether quotes are used or not.  e.g.\n","                --retcode \"critical,blocker\"     or    -retcode=critical,blocker\n","                -rc \"critical blocker\"           or   -rc=critical,blocker"]},"rules":{synopsis:["--rules","-r"],description:["Displays descriptions of the rules in the JET built-in rulepack in prose format.","Refer also to --rulesejson and --rulessonar for other formats"],options:[" - None -"]},"rulesjson":{synopsis:["--rulesjson","-rj"],description:["Displays descriptions of the rules in the JET built-in rulepack in JSON format.","Refer also to --rules and --rulessonar for other formats."],options:[" - None -"]},"rulessonar":{synopsis:["--rulessonar","-rs"],description:["Displays descriptions of the rules in the JET built-in rulepack in XML format.","Refer also to --rules and --rulesjson for other formats."],options:[" - None -"]},"severity":{synopsis:["--severity  <severity>","--severity  \"<severity>\"","--severity  \"<operator><severity>\"","","-s  <severity>","-s  \"<severity>\"","-s  \"<operator><severity>\""],description:["This commands restricts the audit output to those audit issues matching the <severity> option."],options:["<severity>            \u25CF the available severities in descending order of severity are:","                          blocker","                          critical","                          major","                          minor","                          info,      e.g.  --severity  blocker     or,","                                           --severity  \"blocker\"\n","<operator><severity>  \u25CF The severity may be preceded by a logical operator of the form:","                         >","                         >=","                         <","                         <=\n","                       Examples:","                         --severity  \">critical\"       same as blocker","                         --severity  \">=critical\"      selects critical and blocker","                         --severity  \"<=minor\"         selects minor and info\n","                       When using an operator, the wole expression must be surrounded by quotes."]},"version":{synopsis:["--version","-v"],description:["Displays the version of ojaf being used."],options:[" - None -"]},"xgrouplist":{synopsis:["--xgrouplist","--xgrouplist  <pack prefix>","","-xgl","-xgl  <pack prefix>"],description:["Displays the rulenames classified by group in an external (that is non-JET) rulepack."],options:["<pack prefix>    \u25CF  Specify a pack prefix (case independent) to restrict the output to the","                    groups provided by the pack. Note that a configuration should also be","                    specified (via the --config or -c) command, so that ojaf can find the","                    rulePack.  e.g.   ojaf  --gl  <prefix>  -c <some config name>"]}};module.exports.show=show;