/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
var PREFIX;var RP_PREFIX;const RULES_JSON="rules.json";const MSGID_JSON="msgid.json";const JS=".js";const RE_WS=/^\s*$/;const RE_MARKUP=/<[^>]*>/g;const RE_MULTI_BLANKS=/\s{2,}/g;const EMPTY="";const LINELEN=100;const LIST_INDENT=2;var _path;var _rDir;var _rpDir;var _isMsgId;var _prefix;var _msgNum;var _rawArg;var _sev;var _multiIDs=[];function showBuiltinMsgHelp(nd,arg,wantManPage,appCtx){var rc;_init(nd,appCtx);rc=_initArg(arg,wantManPage,appCtx);return rc>0?_processBuiltin(nd,appCtx):rc===0};function showExternalMsgHelp(rules,manCheckL,manCheckS,nd,appCtx){var check,temp,isShort,o,x,ret=false;_init(nd,appCtx);check=manCheckL||manCheckS;if(check){temp=check.toLowerCase();x=temp.indexOf("-");check=x>=0?temp.substring(0,x):"";check=check.toUpperCase()+temp.substring(x);isShort=!!manCheckS;if(rules.getRSIByRuleName(temp)>=0){o=rules.getRuleDescriptionEx(null,temp,isShort)}else{o=rules.getRuleDescriptionEx(check,null,isShort)}if(o&&o.descrip){_display(o,appCtx.colors)}else{appCtx.error(`Unable to locate '${temp}' via the configuration file.`)}ret=true}return ret};function _processBuiltin(nd,appCtx){var meta;_rDir=_path.join(__dirname,"../rules");_rpDir=_path.join(__dirname,"../rulepacks");if(!(meta=_loadRuleMetadata(nd,appCtx))){return true}return _isMsgId?_processMsgId(meta,nd,appCtx):_processRuleName(meta,nd,appCtx)};function _processMsgId(meta,nd,appCtx){var mjson=meta.mjson;var rname,r,x;for(r in mjson){if(_msgNum===mjson[r]){rname=r;break}}if(!rname){appCtx.error(`No rule found for message ID ${_prefix}-${_msgNum}.`);return true}x=rname.indexOf("_");if(x>=0){rname=rname.substring(0,x)}return _displayIt(rname,_prefix,meta,nd,appCtx)};function _processRuleName(meta,nd,appCtx){var rname,rjson,r;rname=_rawArg.toLowerCase();rjson=meta.rjson.rules;for(r in rjson){if(r===rname){return _displayIt(rname,_prefix,meta,nd,appCtx)}}appCtx.error(`Rule ${rname} is not a known JET rule.`);return!rname.startsWith("oj-")};function _displayIt(rname,prefix,meta,nd,appCtx){var rule,r,mjson,rjson,prefix;mjson=meta.mjson;for(r in mjson){if(r.startsWith(rname)){_multiIDs.push(mjson[r])}}rjson=meta.rjson;for(r in rjson.rules){if(r===rname){_sev=rjson.rules[r].severity;break}}_sev=_sev||"unknown";if(rule=_loadRule(rname,meta,nd,appCtx)){let o={descrip:rule.getDescription(),rule:rname,prefix:prefix,sev:_sev,idList:_multiIDs};_display(o,appCtx.colors);return true}return false};function _loadRule(rname,meta,nd,appCtx){var rule,ruleJS,fp;try{fp=nd.path.join(meta.rdir,rname+JS);ruleJS=nd.ruleLoader(fp);if(ruleJS.prototype||!ruleJS.getName){try{rule=new ruleJS}catch(e){appCtx.error(`Failed to instantiate rule ${rname}`)}}else{rule=ruleJS}return rule}catch(e){appCtx.error(`Failed to load rule ${rname}`)}};function _loadRuleMetadata(nd,appCtx){var meta,fp;fp=RP_PREFIX.includes(_prefix)?nd.path.join(_rpDir,_prefix):nd.path.join(_rDir,_prefix);meta=_loadRulesJson(fp,nd,appCtx);return meta};function _loadRulesJson(dir,nd,appCtx){var rjson,mjson,fp;fp=nd.path.join(dir,RULES_JSON);if(appCtx.fsUtils.fileExists(fp)){rjson=nd.jsonLoader.load(fp,nd,m=>{appCtx.error(m)},true,appCtx.utils)}else{appCtx.error(`Internal error: rule manifest for ${_prefix} not found`);return false}fp=nd.path.join(dir,MSGID_JSON);if(appCtx.fsUtils.fileExists(fp)){mjson=nd.jsonLoader.load(fp,nd,m=>{appCtx.error(m)},true,appCtx.utils)}else{if(!RP_PREFIX.includes(_prefix)){appCtx.error(`Internal error: rule message ID manifest for ${_prefix} not found`);return false}}if(rjson){return{rjson:rjson,mjson:mjson,rdir:dir}}};function _init(nd){_path=nd.path;PREFIX=nd.builtinpacks.getPrefixes();RP_PREFIX=nd.builtinpacks.getRulepackFolderPrefixes()};function _initArg(arg,wantManPage,appCtx){var x,mp;_rawArg=arg;arg=arg.toLowerCase();if(mp=_isManPage(arg)){_displayManPage(mp.full,mp.short,appCtx.colors);return 0}if(wantManPage){appCtx.error(`manPage for command ${arg} not found`);return 0}x=arg.indexOf("-");if(x<0){if(!isNaN(parseInt(arg))){arg="jet-"+arg;x=3}else{appCtx.error("Expected a message ID or rulename or manpage to follow --help");return 0}}_prefix=arg.substring(0,x);_msgNum=arg.substring(x+1);x=parseInt(_msgNum);_isMsgId=!isNaN(x);if(_isMsgId){if(_msgNum.length<4){_msgNum="0".repeat(4-_msgNum.length)+_msgNum}}else{_msgNum=null;if(arg.startsWith("oj-")){_prefix="jet"}}if(PREFIX.includes(_prefix)){return 1}return-1};function _isManPage(manPage){var syn;switch(manPage){case"amdlist":case"amd":manPage="amdlist";syn="amd";break;case"base":case"b":manPage="base";syn="b";break;case"betalist":case"bl":manPage="betalist";syn="bl";break;case"config":case"c":manPage="config";syn="c";break;case"dac":syn="dac";break;case"debug":case"d":manPage="debug";syn="d";break;case"deflist":case"def":manPage="deflist";syn="def";break;case"dislist":case"dl":manPage="dislist";syn="dl";break;case"deplist":case"dpl":manPage="deplist";syn="dpl";break;case"dryrun":case"dr":manPage="dryrun";syn="dr";break;case"extra":case"e":manPage="extra";syn="e";break;case"followlinks":case"fl":manPage="followlinks";syn="fl";break;case"format":case"t":manPage="format";syn="t";break;case"groups":case"g":manPage="groups";syn="g";break;case"grouplist":case"gl":manPage="grouplist";syn="gl";break;case"help":case"h":manPage="help";syn="h";break;case"init":case"i":manPage="init";syn="i";break;case"initrule":case"ir":manPage="initrule";syn="ir";break;case"jetlist":case"jl":manPage="jetlist";syn="jl";break;case"jetver":case"jv":manPage="jetver";syn="jv";break;case"loadorder":case"rlo":manPage="loadorder";syn="rlo";break;case"maintenence":case"mnt":manPage="maintenance";syn="mnt";break;case"metahist":case"mh":manPage="metahist";syn="mh";break;case"migrator":case"mig":manPage="migrator";syn="mig";break;case"msgid":case"id":manPage="msgid";syn="id";break;case"nslist":case"nsl":manPage="nslist";syn="nsl";break;case"nocolor":case"nc":manPage="nocolor";syn="nc";break;case"nodebug":case"nd":manPage="nodebug";syn="nd";break;case"noextra":case"ne":manPage="noextra";syn="ne";break;case"nofollowlinks":case"nfl":manPage="nofollowlinks";syn="nfl";break;case"noout":case"no":manPage="noout";syn="no";break;case"noverbose":case"nv":manPage="noverbose";syn="nv";break;case"outpath":case"o":manPage="outPath";syn="o";break;case"profiles":case"prof":manPage="profiles";syn="prof";break;case"reg":syn="reg";break;case"retcode":case"rc":manPage="retcode";syn="rc";break;case"rules":case"r":manPage="rules";syn="r";break;case"rulesjson":case"rj":manPage="rulesjson";syn="rj";break;case"rulessonar":case"rs":manPage="rulessonar";syn="rs";break;case"severity":case"s":manPage="severity";syn="s";break;case"version":case"v":manPage="version";syn="v";break;case"xgrouplist":case"xgl":manPage="xgrouplist";syn="xgl";break}return syn?{full:manPage,short:syn}:syn};var first;function _display(o,clr){var lines,line,s,s1,s2,s3;var liEnd,x;var list,temp,indent;var idList=o.idList.filter((c,index)=>{return o.idList.indexOf(c)===index});var multiSev=idList.length>1;s=clr.BRIGHTGREEN("Rule: ");s1=clr.BRIGHTGREEN("Severity: ");s2=clr.BRIGHTGREEN("Message ID");s3=clr.BRIGHTYELLOW("\xB9");line="\n"+s+clr.BRIGHTYELLOW(o.rule)+"  "+s1+clr.BRIGHTYELLOW(o.sev)+(multiSev?s3:EMPTY)+"  "+s2+(multiSev?"'s":EMPTY)+": "+o.prefix+"-"+idList.join(", ");console.log(line);s=_removeMarkup(o.descrip,clr);s=_removeColorMarkup(s,clr);indent=0;lines=s.split("\n");for(let i=0;i<lines.length;i++){line=lines[i];if((x=line.indexOf("-"))>=3&&!isNaN(parseInt(line.charAt(x+1)))){line=clr.BRIGHTYELLOW(line)}if((x=line.indexOf("JAF#"))>=0&&!isNaN(parseInt(line.charAt(x+4)))){line=line.substring(0,x+3)+"-"+line.substring(x+4)}if(line.charAt(0)==="\x12"){list=true;temp=line.indexOf("/",1);indent=parseInt(line.substring(1,temp));line=line.substring(temp+1).trim();first=true}liEnd=false;if(list&&(x=line.indexOf("\x13"))>=0){line=line.substring(0,x);liEnd=true}_displayLine(line,list,indent,clr);if(liEnd){list=false;indent=0}}if(multiSev){s="\n"+s3+clr.BRIGHTYELLOW(" Possibility of more than 1 severity since there are "+idList.length+" message ID's");console.log(s)}console.log("")};function _displayLine(s,list,indent,clr){var line,c,x;var start=0;var end=LINELEN;while(end<s.length){x=_NL(s,start,end);if(x>=0){line=s.substring(start,x).trim();if(list){if(line.indexOf("\x13")>=0){indent=0}}line=_fixup(line);console.log((list?" ".repeat((first?0:indent)+LIST_INDENT):"")+clr.CYAN(line));first=false;start=x+1;end=start+LINELEN;continue}c=s.charAt(end);if(RE_WS.test(c)){line=s.substring(start,end).trim();line=_fixup(line);console.log((list?" ".repeat((first?0:indent)+LIST_INDENT):"")+clr.CYAN(line));first=false;start=end;end+=LINELEN;continue}else{end--}}if(start<end){line=s.substring(start,end).trim();line=_fixup(line);console.log((list?" ".repeat((first?0:indent)+LIST_INDENT):"")+clr.CYAN(line));first=false}};function _removeMarkup(s,clr){s=s.replace(/<oj\-/g,"@@01").replace(/<\/oj\-/g,"@@02").replace(/<link>/g,"@@20").replace(/<script>/g,"@@21").replace(/<html>/g,"@@22").replace(/<\/link>/g,"@@30").replace(/<\/script>/g,"@@31").replace(/<\/html>/g,"@@32").replace(/<br>/g,"@@03").replace(/<p>/g,"@@03@@03").replace(/<b>/g,"@@04").replace(/<em>/g,"@@04").replace(/<i>/g,"@@05").replace(/<\/b>/g,"@@06").replace(/<\/em>/g,"@@06").replace(/<\/i>/g,"@@06").replace(/<div/g,"@@7").replace(/<\/div>/g,"@@8").replace(/<template>/g,"@@9").replace(/<\/template>/g,"@@10").replace(/<ol/g,"@@11").replace(/<\/ol>/g,"@@12").replace(/<ul/g,"@@13").replace(/<\/ul>/g,"@@14").replace(/<li/g,"@@15").replace(/<\/li>/g,"@@16").replace(/&nbsp;/g,"\x11").replace(RE_MARKUP,EMPTY).replace(RE_MULTI_BLANKS," ").trimRight().replace(/@@01/g,"<oj-").replace(/@@02/g,"</oj-").replace(/@@03/g,"\n").replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/@@9/g,"<template>").replace(/@@10/g,"</template>").replace(/@@7/g,"<div").replace(/@@8/g,"</div>").replace(/@@11/g,"<ol").replace(/@@12/g,"</ol>").replace(/@@13/g,"<ul").replace(/@@14/g,"</ul>").replace(/@@15/g,"<li").replace(/@@16/g,"</li>").replace(/@@20/g,"<link>").replace(/@@21/g,"<script>").replace(/@@22/g,"<html>").replace(/@@30/g,"</link>").replace(/@@31/g,"</script>").replace(/@@32/g,"</html>");if(!clr.isColor()){s=s.replace(/@@4/g,EMPTY).replace(/@@5/g,EMPTY).replace(/@@6/g,EMPTY)}return _handleLists(s)};function _removeColorMarkup(s,clr){if(clr.isColor()){s=s.replace(/@@04/g,EMPTY).replace(/@@05/g,EMPTY).replace(/@@06/g,EMPTY)}return s.trim()};function _handleLists(s){var start,end,ordered,rep,x;x=0;while(true){ordered=false;if((start=s.indexOf("<ol>",x))>=0){ordered=true}else{start=s.indexOf("<ul>",x)}if(start>=0){end=ordered?s.indexOf("</ol>",start):s.indexOf("</ul>",start);if(end>=start){rep=_handleList(s,start,end,ordered);s=s.substring(0,start)+rep;x=s.length;s+=s.substring(end+4)}else{x=start+4}}else{break}}return s};function _handleList(s,start,end,ordered){var list,itemStart,itemEnd,count=0,sCount,rep="";list=s.substring(start+4,end).trim();itemEnd=0;while(true){if((itemStart=list.indexOf("<li>",itemEnd))>=0){itemEnd=list.indexOf("</li>",itemStart);sCount=(ordered?""+ ++count+")":"*")+" ";rep+="\n\n"+"\x12"+sCount.length+"/"+sCount+list.substring(itemStart+4,itemEnd).trimRight()+"\x13"}else{break}}return rep}function _displayManPage(manPage,syn,clr){let lib=require("./manpage");return lib.show(manPage,syn,clr)};function _fixup(s){return s.replace(/\x11/g," ")};function _NL(s,start,end){var ret=-1,x;if(start<end){if((x=s.indexOf("\n",start))>=0){if(x<end){ret=x}}}return ret};module.exports={showBuiltinMsgHelp,showExternalMsgHelp};