/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const COMPONENT_FINDER=require("./ComponentFinder");const TSXUTILS_PRECOMP=require("./TsxUtils");const OJET_CONFIG="oraclejetconfig.json";const JET_COMPONENTS="jet_components";const JET_COMPOSITES="jet-composites";var path;function Utils(ojetCfg,jafUtils,fsUtils,msgCtx,nd){this._ojetConfig=ojetCfg;this._jafUtils=jafUtils;this._fsUtils=fsUtils;this._msgCtx=msgCtx;this._nd=nd;path=nd.path};Utils.prototype.getKeyPathInfo=function(auditBase){const paths={componentRootFolder:null,exchangeCacheFolder:null,generalSourceRoot:"src",jsSource:null,tsSource:null,base:null};let jetConfig=this._ojetConfig;if(!jetConfig&&auditBase){const remoteConfig=path.join(auditBase,OJET_CONFIG);if(this._fsUtils.pathExistsSync(remoteConfig)){jetConfig=this._fsUtils.readJsonSync(remoteConfig)}}let jsDir="js";let tsDir="ts";paths.base=this.toJAFPath(path.resolve(auditBase));if(jetConfig){jsDir=jetConfig.paths.source.javascript||"js";tsDir=jetConfig.paths.source.typescript||"ts";paths.exchangeCacheFolder=jetConfig.paths.source.exchangeComponents||JET_COMPONENTS;paths.componentRootFolder=jetConfig.paths.source.components||JET_COMPOSITES;paths.generalSourceRoot=jetConfig.paths.source.common||"src"}paths.jsSource=this.toJAFPath(path.join(paths.generalSourceRoot,jsDir));paths.tsSource=this.toJAFPath(path.join(paths.generalSourceRoot,tsDir));return paths};Utils.prototype.getComponentFinder=function(){if(!this._compFinder){this._tsxUtils=new TSXUTILS_PRECOMP(this,this._jafUtils,this._fsUtils,this._msgCtx,this._nd);this._compFinder=new COMPONENT_FINDER(this._ojetConfig,this._jafUtils,this._fsUtils,this._tsxUtils,this._msgCtx,this._nd)}return this._compFinder};Utils.prototype.extractComponentInfoFromJSONFile=function(auditContext,componentFolder,fileName,isLocal,fromPrecompile){let componentInfo={};const mdFile=`${componentFolder}/${fileName}`;const compMetadata=auditContext.utils.fsUtils.readJsonSync(mdFile);if(!compMetadata){this._msgCtx.msg.error(`Invalid JSON in component metadata  ${mdFile}, component ignored`);return}componentInfo.name=compMetadata.name;componentInfo.pack=compMetadata.pack;if(fromPrecompile&&compMetadata.pack){if(compMetadata.name.startsWith(`${compMetadata.pack}-`)){componentInfo.name=compMetadata.name.substring(compMetadata.pack.length+1)}}componentInfo.fullName=componentInfo.pack?`${componentInfo.pack}-${componentInfo.name}`:componentInfo.name;componentInfo.displayName=compMetadata.displayName;componentInfo.description=compMetadata.description;componentInfo.version=compMetadata.version;componentInfo.jetVersion=compMetadata.jetVersion;componentInfo.license=compMetadata.license;componentInfo.extension=compMetadata.extension;if(compMetadata.icon){componentInfo.icon=compMetadata.icon}componentInfo.type=compMetadata.type?compMetadata.type:"composite";componentInfo.subcomponentType=compMetadata.subcomponentType;componentInfo.local=isLocal;componentInfo.rootFolder=this.toJAFPath(componentFolder);componentInfo.requirePaths=new Set;switch(componentInfo.type){case"reference":if(compMetadata.extension&&compMetadata.extension.oracle&&compMetadata.extension.oracle.businessApprovals){componentInfo.ba=compMetadata.extension.oracle.businessApprovals}if(compMetadata.paths&&compMetadata.paths.name){componentInfo.requirePaths.add(compMetadata.paths.name)}else{const extractPathSegments=compMetadata.package.split("/");if(extractPathSegments.length>1){componentInfo.requirePaths.add(extractPathSegments[1])}else{componentInfo.requirePaths.add(extractPathSegments[0])}}break;case"composite":if(compMetadata.styleClasses){componentInfo.styleClasses=compMetadata.styleClasses}if(compMetadata.styleVariables){componentInfo.styleVariables=compMetadata.styleVariables}if(compMetadata.slots){componentInfo.slots=compMetadata.slots}if(compMetadata.properties){componentInfo.properties=compMetadata.properties}if(compMetadata.events){componentInfo.events=compMetadata.events}if(compMetadata.methods&&Object.keys(compMetadata.methods).length>0){componentInfo.methods=compMetadata.methods}componentInfo.viewModel={resolved:false};if(compMetadata&&compMetadata.extension&&compMetadata.extension.audit&&compMetadata.extension.audit.jetwc&&compMetadata.extension.audit.jetwc.hasOwnProperty("viewModel")){const overrideVM=compMetadata.extension.audit.jetwc.viewModel;if(overrideVM){componentInfo.viewModel={path:this.toJAFPath(path.resolve(".",componentInfo.rootFolder,overrideVM)),resolved:true,skip:false}}else{componentInfo.viewModel={skip:true}}}case"resource":componentInfo.requirePaths.add(".");if(compMetadata.pack){componentInfo.requirePaths.add(`${componentInfo.pack}/${componentInfo.name}`)}else{componentInfo.requirePaths.add(componentInfo.name)}if(compMetadata.dependencies){componentInfo.dependencies=[];Object.keys(compMetadata.dependencies).forEach(depname=>{componentInfo.dependencies.push({name:depname,range:compMetadata.dependencies[depname]})})}break}return componentInfo};Utils.prototype.toJAFPath=function(sourcePath){if(sourcePath){sourcePath=path.normalize(sourcePath);if(this._jafUtils.isWindows()){sourcePath=sourcePath.replace(/\\/g,"/")}}return sourcePath};Utils.prototype.toNativePath=function(sourcePath){if(sourcePath){sourcePath=path.normalize(sourcePath)}return sourcePath};module.exports=Utils;