/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const ExpParser=function(){this.parse=function(expr){var context={index:0,expr:expr};var nodes=_gobbleExpressions(context);if(nodes.length===1){return nodes[0]}return{type:COMPOUND,body:nodes}};function _gobbleExpressions(context,untilICode){const expr=context.expr;const length=expr.length;const nodes=[];while(context.index<length){_gobbleSpaces(context);const ch_i=expr.charCodeAt(context.index);if(ch_i===SEMCOL_CODE||ch_i===COMMA_CODE){context.index++}else{const node=_gobbleExpression(context);if(node){nodes.push(node)}else if(context.index<length){if(ch_i===untilICode){break}_throwError("Unexpected \""+expr.charAt(context.index)+"\"",context.index)}}}return nodes}function _gobbleSpaces(context){var expr=context.expr;var ch=expr.charCodeAt(context.index);while(ch===32||ch===9||ch===10||ch===13){ch=expr.charCodeAt(++context.index)}}function _gobbleExpression(context){const expr=context.expr;let test=_gobbleArrowFunctionExpression(context)||_gobbleBinaryExpression(context),consequent,alternate;_gobbleSpaces(context);if(expr.charCodeAt(context.index)===QUMARK_CODE){context.index++;consequent=_gobbleExpression(context);if(!consequent){_throwError("Expected expression",context.index)}_gobbleSpaces(context);if(expr.charCodeAt(context.index)===COLON_CODE){context.index++;alternate=_gobbleExpression(context);if(!alternate){_throwError("Expected expression",context.index)}test={type:CONDITIONAL_EXP,test:test,consequent:consequent,alternate:alternate}}else{_throwError("Expected :",context.index)}}_updateBinariesToArrows(test);return test}function _gobbleBinaryOp(context){var expr=context.expr;_gobbleSpaces(context);var to_check=expr.substr(context.index,_max_binop_len),tc_len=to_check.length;while(tc_len>0){if(_binary_ops[to_check]&&(!_isIdentifierStart(expr.charCodeAt(context.index))||context.index+to_check.length<expr.length&&!_isIdentifierPart(expr.charCodeAt(context.index+to_check.length)))){context.index+=tc_len;return to_check}to_check=to_check.substr(0,--tc_len)}return false}function _gobbleBinaryExpression(context){var node,biop,prec,stack,biop_info,left,right,i,cur_biop,cur_prec;left=_gobbleToken(context);biop=_gobbleBinaryOp(context);if(!biop){return left}biop_info={value:biop,prec:_binaryPrecedence(biop)};right=biop==="=>"?_gobbleArrowFunctionBody(context):_gobbleToken(context);if(!right){_throwError("Expected expression after "+biop,context.index)}stack=[left,biop_info,right];cur_biop=biop;cur_prec=biop_info.prec;while(biop=_gobbleBinaryOp(context)){prec=_binaryPrecedence(biop,cur_biop,cur_prec);if(prec===0){break}biop_info={value:biop,prec:prec};cur_biop=biop;cur_prec=prec;while(stack.length>2&&prec<=stack[stack.length-2].prec){right=stack.pop();biop=stack.pop().value;left=stack.pop();node=_createBinaryExpression(biop,left,right,context);stack.push(node)}node=_gobbleToken(context);if(!node){_throwError("Expected expression after "+cur_biop,context.index)}stack.push(biop_info,node)}i=stack.length-1;node=stack[i];while(i>1){node=_createBinaryExpression(stack[i-1].value,stack[i-2],node,context);i-=2}return node}function _gobbleToken(context){var expr=context.expr;var ch,to_check,tc_len;_gobbleSpaces(context);ch=expr.charCodeAt(context.index);if(_isDecimalDigit(ch)||ch===PERIOD_CODE){return _gobbleNumericLiteral(context)}else if(ch===SQUOTE_CODE||ch===DQUOTE_CODE||ch===OBRACK_CODE){return _gobbleVariable(context)}else if(ch===OBRACE_CODE){return _gobbleObjectLiteral(context)}else if(ch===BTICK_CODE){return _gobbleTemplateLiteral(context)}to_check=expr.substr(context.index,_max_unop_len);tc_len=to_check.length;while(tc_len>0){if(to_check in _unary_ops&&(!_isIdentifierStart(expr.charCodeAt(context.index))||context.index+to_check.length<expr.length&&!_isIdentifierPart(expr.charCodeAt(context.index+to_check.length)))){context.index+=tc_len;return{type:UNARY_EXP,operator:to_check,argument:_gobbleToken(context),prefix:true}}to_check=to_check.substr(0,--tc_len)}var start=context.index;var funcEnd=context.index+8;if(expr.substring(start,funcEnd)==="function"&&!_isIdentifierPart(expr.charCodeAt(funcEnd))){context.index=funcEnd;return _gobbleFunction(context)}if(_isIdentifierStart(ch)||ch===OPAREN_CODE){return _gobbleVariable(context)}return false}function _gobbleNumericLiteral(context){var expr=context.expr;var number="",ch,chCode;while(_isDecimalDigit(expr.charCodeAt(context.index))){number+=expr.charAt(context.index++)}if(expr.charCodeAt(context.index)===PERIOD_CODE){number+=expr.charAt(context.index++);while(_isDecimalDigit(expr.charCodeAt(context.index))){number+=expr.charAt(context.index++)}}ch=expr.charAt(context.index);if(ch==="e"||ch==="E"){number+=expr.charAt(context.index++);ch=expr.charAt(context.index);if(ch==="+"||ch==="-"){number+=expr.charAt(context.index++)}while(_isDecimalDigit(expr.charCodeAt(context.index))){number+=expr.charAt(context.index++)}if(!_isDecimalDigit(expr.charCodeAt(context.index-1))){_throwError("Expected exponent ("+number+expr.charAt(context.index)+")",context.index)}}chCode=expr.charCodeAt(context.index);if(_isIdentifierStart(chCode)){_throwError("Variable names cannot start with a number ("+number+expr.charAt(context.index)+")",context.index)}else if(chCode===PERIOD_CODE){_throwError("Unexpected period",context.index)}return{type:LITERAL,value:parseFloat(number),raw:number}}function _gobbleStringLiteral(context){var expr=context.expr;var str="",quote=expr.charAt(context.index++),closed=false,ch;var length=expr.length;while(context.index<length){ch=expr.charAt(context.index++);if(ch===quote){closed=true;break}else if(ch==="\\"){ch=expr.charAt(context.index++);switch(ch){case"n":str+="\n";break;case"r":str+="\r";break;case"t":str+="\t";break;case"b":str+="\b";break;case"f":str+="\f";break;case"v":str+="\x0B";break;default:str+=ch}}else{str+=ch}}if(!closed){_throwError("Unclosed quote after \""+str+"\"",context.index)}return{type:LITERAL,value:str,raw:quote+str+quote}}function _gobbleIdentifier(context,bMemberExpr){var expr=context.expr;var ch=expr.charCodeAt(context.index),start=context.index,identifier;if(_isIdentifierStart(ch)){context.index++}else{_throwError("Unexpected "+expr.charAt(context.index),context.index)}var length=expr.length;while(context.index<length){ch=expr.charCodeAt(context.index);if(_isIdentifierPart(ch)){context.index++}else{break}}identifier=expr.slice(start,context.index);if(identifier==="new"&&!bMemberExpr){_gobbleSpaces(context);var constructorNode=_gobbleVariable(context,CALL_EXP);if(constructorNode.type!==CALL_EXP){_throwError("Expression of type: "+constructorNode.type+" not supported for constructor expression")}return{type:NEW_EXP,callee:constructorNode.callee,arguments:constructorNode.arguments}}if(_literals.has(identifier)){return{type:LITERAL,value:_literals.get(identifier),raw:identifier}}return{type:IDENTIFIER,name:identifier}}function _gobbleArguments(context,termination,identifiersOnly){var expr=context.expr;var length=expr.length;var ch_i,args=[],node,closed=false;var separator_count=0;while(context.index<length){_gobbleSpaces(context);ch_i=expr.charCodeAt(context.index);if(ch_i===termination){closed=true;context.index++;if(termination===CPAREN_CODE&&separator_count&&separator_count>=args.length){_throwError("Unexpected token "+String.fromCharCode(termination),context.index)}break}else if(ch_i===COMMA_CODE){context.index++;separator_count++;if(separator_count!==args.length){if(termination===CPAREN_CODE){_throwError("Unexpected token ,",context.index)}else if(termination===CBRACK_CODE){for(var arg=args.length;arg<separator_count;arg++){args.push(null)}}}}else{if(identifiersOnly){node=_gobbleIdentifier(context)}else{node=_gobbleExpression(context)}if(!node||args.length>separator_count){_throwError("Expected comma",context.index)}args.push(node)}}if(!closed){_throwError("Expected "+String.fromCharCode(termination),context.index)}return args}function _gobbleVariable(context,stopAtType){var expr=context.expr;var ch_i,node;ch_i=expr.charCodeAt(context.index);if(ch_i===OPAREN_CODE){node=_gobbleGroup(context)}else if(ch_i===SQUOTE_CODE||ch_i===DQUOTE_CODE){node=_gobbleStringLiteral(context)}else if(ch_i===OBRACK_CODE){node=_gobbleArray(context)}else{node=_gobbleIdentifier(context)}_gobbleSpaces(context);ch_i=expr.charCodeAt(context.index);while(ch_i===PERIOD_CODE||ch_i===OBRACK_CODE||ch_i===OPAREN_CODE||_isOptionalChaining(context)){context.index++;if(ch_i===PERIOD_CODE){_gobbleSpaces(context);node={type:MEMBER_EXP,computed:false,object:node,property:_gobbleIdentifier(context,true)}}else if(ch_i===QUMARK_CODE){context.index++;_gobbleSpaces(context);node={type:MEMBER_EXP,computed:false,optional:true,object:node,property:_gobbleIdentifier(context,true)}}else if(ch_i===OBRACK_CODE){node={type:MEMBER_EXP,computed:true,object:node,property:_gobbleExpression(context)};_gobbleSpaces(context);ch_i=expr.charCodeAt(context.index);if(ch_i!==CBRACK_CODE){_throwError("Unclosed [",context.index)}context.index++}else if(ch_i===OPAREN_CODE){node={type:CALL_EXP,arguments:_gobbleArguments(context,CPAREN_CODE),callee:node}}if(stopAtType===node.type){return node}_gobbleSpaces(context);ch_i=expr.charCodeAt(context.index)}return node}function _gobbleGroup(context){context.index++;let nodes=_gobbleExpressions(context,CPAREN_CODE);if(context.expr.charCodeAt(context.index)===CPAREN_CODE){context.index++;if(nodes.length===1){return nodes[0]}else if(!nodes.length){return false}return{type:SEQUENCE_EXP,expressions:nodes}}_throwError("Unclosed (",context.index)}function _gobbleArray(context){context.index++;return{type:ARRAY_EXP,elements:_gobbleArguments(context,CBRACK_CODE)}}function _gobbleFunctionBody(context){_gobbleSpaces(context);const expr=context.expr;let ch_i=expr.charCodeAt(context.index);context.index++;_gobbleSpaces(context);let hasReturn=false;const start=context.index;if(expr.substring(start,start+6)==="return"){hasReturn=true;context.index+=6}_gobbleSpaces(context);const funcBody=_gobbleExpression(context);_gobbleSpaces(context);ch_i=expr.charCodeAt(context.index);if(ch_i===SEMCOL_CODE){context.index++;_gobbleSpaces(context)}ch_i=expr.charCodeAt(context.index);if(ch_i!==CBRACE_CODE){_throwError("Expected },",context.index)}context.index++;return{type:BLOCK_STATEMENT,expr:expr.substring(start,context.index-1),body:hasReturn?{type:RETURN_STATEMENT,argument:funcBody}:funcBody}}function _gobbleFunction(context){var expr=context.expr;_gobbleSpaces(context);var ch_i=expr.charCodeAt(context.index);if(ch_i!==OPAREN_CODE){_throwError("Expected (,",context.index)}context.index++;var args=_gobbleArguments(context,CPAREN_CODE,true);_gobbleSpaces(context);ch_i=expr.charCodeAt(context.index);if(ch_i!==OBRACE_CODE){_throwError("Expected {,",context.index)}return{type:FUNCTION_EXP,params:args,body:_gobbleFunctionBody(context)}}function _gobbleObjectLiteral(context){var expr=context.expr;context.index++;var props=[];var closed;var separator_count=0;var length=expr.length;while(context.index<length&&!closed){_gobbleSpaces(context);var ch_i=expr.charCodeAt(context.index);if(ch_i===CBRACE_CODE){closed=true;context.index++}else if(ch_i===COMMA_CODE){context.index++;separator_count++;if(separator_count!==props.length){_throwError("Unexpected token ,",context.index)}}else{var key=ch_i===SQUOTE_CODE||ch_i===DQUOTE_CODE?_gobbleStringLiteral(context):_gobbleIdentifier(context);_gobbleSpaces(context);ch_i=expr.charCodeAt(context.index);if(key.type===IDENTIFIER&&(ch_i===COMMA_CODE||ch_i===CBRACE_CODE)){props.push({type:PROPERTY,key:key,value:key,shorthand:true})}else if(ch_i===COLON_CODE){context.index++;var writer=context.writer;var keyValue=getKeyValue(key);if(keyValue==="_ko_property_writers"){context.writer=1}try{props.push({type:PROPERTY,key:key,value:_gobbleExpression(context),shorthand:false})}finally{context.writer=writer}}else{_throwError("Expected ':'. Found "+String.fromCharCode(ch_i),context.index)}}}if(!closed){_throwError("Expected "+String.fromCharCode(CBRACE_CODE),context.index)}return{type:OBJECT_EXP,properties:props}}function _gobbleTemplateLiteral(context){const expr=context.expr;let ch_i=expr.charCodeAt(context.index);if(ch_i===BTICK_CODE){const node={type:TEMPLATE_LITERAL,quasis:[],expressions:[]};let cooked="";let raw="";let closed=false;const length=expr.length;const pushQuasi=()=>node.quasis.push({type:TEMPLATE_ELEMENT,value:{raw,cooked},tail:closed});while(context.index<length){let ch=expr.charAt(++context.index);if(ch==="`"){context.index+=1;closed=true;pushQuasi();return node}else if(ch==="$"&&expr.charAt(context.index+1)==="{"){context.index+=2;pushQuasi();raw="";cooked="";try{node.expressions.push(..._gobbleExpressions(context,CBRACE_CODE))}finally{ch_i=expr.charCodeAt(context.index);if(ch_i!==CBRACE_CODE){_throwError("Unclosed ${ in template literal",expr)}}}else if(ch==="\\"){raw+=ch;ch=expr.charAt(++context.index);raw+=ch;switch(ch){case"n":cooked+="\n";break;case"r":cooked+="\r";break;case"t":cooked+="\t";break;case"b":cooked+="\b";break;case"f":cooked+="\f";break;case"v":cooked+="\x0B";break;default:cooked+=ch}}else{cooked+=ch;raw+=ch}}if(context.index===length){_throwError("Unclosed backtick ` in template literal",expr)}}return false}function _gobbleArrowFunctionExpression(context){const expr=context.expr;let ch=expr.charCodeAt(context.index);let node;if(ch===OPAREN_CODE){const backupIndex=context.index;context.index++;_gobbleSpaces(context);ch=expr.charCodeAt(context.index);if(ch===CPAREN_CODE){context.index++;const biop=_gobbleBinaryOp(context);if(biop==="=>"){const body=_gobbleArrowFunctionBody(context);if(!body){_throwError("Expected expression after "+biop)}node={type:ARROW_EXP,params:[],body}}}if(!node){context.index=backupIndex}}return node}function _gobbleArrowFunctionBody(context){const expr=context.expr;_gobbleSpaces(context);let returnNode;if(expr.charCodeAt(context.index)===OBRACE_CODE){returnNode=_gobbleFunctionBody(context)}else{const startDef=context.index;_gobbleSpaces(context);const funcBody=_gobbleExpression(context);_gobbleSpaces(context);context.index++;returnNode={type:BLOCK_STATEMENT,expr:expr.substring(startDef,context.index-1),body:{type:RETURN_STATEMENT,argument:funcBody}}}return returnNode}function _updateBinariesToArrows(node){if(node){Object.values(node).forEach(val=>{if(val&&typeof val==="object"){_updateBinariesToArrows(val)}});if(node.operator==="=>"){node.type=ARROW_EXP;node.params=node.left?[node.left]:null;node.body=node.right;if(node.params&&node.params[0].type===SEQUENCE_EXP){node.params=node.params[0].expressions}delete node.left;delete node.right;delete node.operator}}}var PERIOD_CODE=46,COMMA_CODE=44,SQUOTE_CODE=39,DQUOTE_CODE=34,OPAREN_CODE=40,CPAREN_CODE=41,OBRACK_CODE=91,CBRACK_CODE=93,QUMARK_CODE=63,SEMCOL_CODE=59,COLON_CODE=58,BTICK_CODE=96,OBRACE_CODE=123,CBRACE_CODE=125;function _getMaxKeyLen(obj){return Object.keys(obj).reduce(function(curr,key){return Math.max(curr,key.length)},0)}var t=true,_unary_ops={"-":t,"!":t,"~":t,"+":t,typeof:t},_binary_ops={"=":1,"||":2,"??":2,"&&":3,"|":4,"^":5,"&":6,"==":7,"!=":7,"===":7,"!==":7,"<":8,">":8,"<=":8,">=":8,instanceof:8,"<<":9,">>":9,">>>":9,"+":10,"-":10,"*":11,"/":11,"%":11,"**":12,"=>":0.1},_max_unop_len=_getMaxKeyLen(_unary_ops),_max_binop_len=_getMaxKeyLen(_binary_ops);var _literals=new Map;_literals.set("true",true);_literals.set("false",false);_literals.set("null",null);_literals.set("undefined",undefined);function _binaryPrecedence(op_val,prev_op_val,prev_op_prec){const basePrec=_binary_ops[op_val]||0;if(basePrec!==12||prev_op_val===undefined||op_val!==prev_op_val){return basePrec}return(prev_op_prec+13)*0.5}function _createBinaryExpression(operator,left,right,context){if(operator==="="&&!context.writer){_throwError("Unexpected operator '='",context.index)}var type=operator==="||"||operator==="&&"||operator==="??"?LOGICAL_EXP:BINARY_EXP;return{type:type,operator:operator,left:left,right:right}}function _isOptionalChaining(context){var expr=context.expr;if(expr.charCodeAt(context.index)===QUMARK_CODE&&expr.charCodeAt(context.index+1)===PERIOD_CODE&&!_isDecimalDigit(expr.charCodeAt(context.index+2))){return true}return false}function _isDecimalDigit(ch){return ch>=48&&ch<=57}function _isIdentifierStart(ch){return ch===36||ch===95||ch>=65&&ch<=90||ch>=97&&ch<=122||ch>=128&&!_binary_ops[String.fromCharCode(ch)]}function _isIdentifierPart(ch){return ch===36||ch===95||ch>=65&&ch<=90||ch>=97&&ch<=122||ch>=48&&ch<=57||ch>=128&&!_binary_ops[String.fromCharCode(ch)]}function _throwError(message,index){var error=new Error(message+" at character "+index);error.index=index;error.description=message;throw error}};const getKeyValue=function(keyObj){return keyObj.type===IDENTIFIER?keyObj.name:keyObj.value};module.exports=ExpParser;const COMPOUND="Compound";const IDENTIFIER="Identifier";const MEMBER_EXP="MemberExpression";const LITERAL="Literal";const CALL_EXP="CallExpression";const UNARY_EXP="UnaryExpression";const BINARY_EXP="BinaryExpression";const LOGICAL_EXP="LogicalExpression";const CONDITIONAL_EXP="ConditionalExpression";const ARRAY_EXP="ArrayExpression";const OBJECT_EXP="ObjectExpression";const FUNCTION_EXP="FunctionExpression";const NEW_EXP="NewExpression";const PROPERTY="Property";const TEMPLATE_LITERAL="TemplateLiteral";const TEMPLATE_ELEMENT="TemplateElement";const SEQUENCE_EXP="SequenceExpression";const ARROW_EXP="ArrowFunctionExpression";const RETURN_STATEMENT="ReturnStatement";const BLOCK_STATEMENT="BlockStatement";