/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const Utils=require("./jetwcutils-componentAuditUtils");const path=require("path");const TsxUtils=function(){};TsxUtils.prototype.extractComponentInfoFromTSXFile=function(auditContext,componentFolder,fileName,metadataPatches){const{msgLib,fsUtils}=auditContext.utils;const packRegEx=/@ojmetadata[\s]*pack[\s]*[\"|'](?<pack>[a-zA-Z\-0-9]*)[\"|']/mg;const versionRegEx=/@ojmetadata[\s]*version[\s]*[\"|'](?<version>[\.0-9\-a-zA-Z]*)[\"|']/mg;const jetVersionRegEx=/@ojmetadata[\s]*jetVersion[\s]*[\"|'](?<version>[\.0-9\-a-zA-Z^~><=]*)[\"|']/mg;const tsxFile=path.join(componentFolder,fileName);const fileAsStr=auditContext.utils.fsUtils.readFileSync(tsxFile);const componentIdentification=this.getVComponentElementNameAndImpl(fileAsStr,msgLib);const fullName=componentIdentification.elementName;const className=componentIdentification.class;const componentName=this.getVComponentComponentName(fileAsStr);let precompiledInfo=auditContext.utils.metaLib.getTagMetadata(fullName);if(!precompiledInfo&&auditContext.rulePack.getRuleCustomOptions().hasOwnProperty("precompileCache")&&auditContext.rulePack.getRuleCustomOption("testMode")){msgLib.info(`Test mode, bypassing Typescript compilation...`);const jsonLoc=path.join(auditContext.rulePack.getRuleCustomOption("precompileCache"),`${fullName}.json`);if(fsUtils.fileExistsSync(jsonLoc)){precompiledInfo=fsUtils.readJsonSync(jsonLoc)}else{msgLib.error(`Missing test mode metadata for ${jsonLoc}`)}}if(precompiledInfo){if(metadataPatches){let componentPatches;if(precompiledInfo.pack){componentPatches=metadataPatches?.[precompiledInfo.pack]?.[precompiledInfo.name]}else{componentPatches=metadataPatches?.[precompiledInfo.name]}if(componentPatches&&Array.isArray(componentPatches)){msgLib.info(`Processing metadata type patches for ${fullName} [${componentPatches.length} patch(es) specified]`);componentPatches.forEach(patch=>{switch(patch.target){case"property":this._handlePropertyTypePatch(patch,precompiledInfo);break;case"method":this._handleMethodTypePatch(patch,precompiledInfo);break;case"event":this._handleEventDetailTypePatch(patch,precompiledInfo);break;case"slot":this._handleSlotDataTypePatch(patch,precompiledInfo);break}})}}const componentInfo=Utils.extractComponentInfoFromMetadata(auditContext,precompiledInfo,componentFolder,true,true);componentInfo.compiledMetadata=precompiledInfo;componentInfo.vcomponent=true;componentInfo.viewModel={resolved:true,path:Utils.toJAFPath(tsxFile)};componentInfo.viewModel.className=className;if(!componentName){componentInfo.inferredName=true}if(componentInfo.pack){const matchPack=packRegEx.exec(fileAsStr);if(!matchPack||!matchPack.groups.pack){componentInfo.inferredPack=true}}const matchVer=versionRegEx.exec(fileAsStr);if(!matchVer||!matchVer.groups.version){componentInfo.inferredVersion=true}const matchJetVer=jetVersionRegEx.exec(fileAsStr);if(!matchJetVer||!matchJetVer.groups.version){componentInfo.inferredJetVersion=true}return componentInfo}else{if(fullName){msgLib.error(`Unable to audit VComponent ${fullName}, pre-compiled metadata is not available`)}return}};TsxUtils.prototype.getVComponentElementNameAndImpl=function(sourceCode,msgLib){var resolvedElementName,implementationClass;const elementRegExForFunction=/export const\s*(?<className>\w+)[\w\s\<\>:]*=\s*registerCustomElement[\s<>,\w]*\(\s*[\"\'](?<fullName>[\w-]*)\s*[\"\']\s*,/mg;const matchElementFunction=elementRegExForFunction.exec(sourceCode);if(matchElementFunction&&matchElementFunction.groups&&matchElementFunction.groups.fullName&&matchElementFunction.groups.className){resolvedElementName=matchElementFunction.groups.fullName;implementationClass=matchElementFunction.groups.className}else{const elementRegExForClass=/\s*@customElement\s*\(\s*[\"\']\s*(?<fullName>[\w-]*)\s*[\"\']\s*\)/mg;const matchElementClass=elementRegExForClass.exec(sourceCode);if(matchElementClass&&matchElementClass.groups&&matchElementClass.groups.fullName){resolvedElementName=matchElementClass.groups.fullName}const elementRegExForClassImpl=/[\s]*export[\s]*class[\s]*(?<className>[a-zA-Z\-0-9_]*)[\s<>,\w]*extends[\s]*(?<superClass>[a-zA-Z\-0-9_]*)/mg;while((classDef=elementRegExForClassImpl.exec(sourceCode))!==null){if(classDef.groups.superClass==="Component"){implementationClass=classDef.groups.className}}}if(resolvedElementName&&!implementationClass){msgLib.error(`Unable to determine VComponent class-name for ${resolvedElementName}`)}return{elementName:resolvedElementName,class:implementationClass}};TsxUtils.prototype.getVComponentComponentName=function(sourceCode){const nameRegEx=/@ojmetadata[\s]*name [\"|'](?<componentName>[a-zA-Z\-0-9]*)[\"|']/mg;const matchElement=nameRegEx.exec(sourceCode);if(matchElement&&matchElement.groups&&matchElement.groups.componentName){return matchElement.groups.componentName}else{return}};TsxUtils.prototype.matchToVComponentImpl=function(auditContext,testFileName){let componentInfo;let fileNameCanonical=Utils.toJAFPath(testFileName);if(fileNameCanonical.endsWith(".tsx")){const componentMatch=Utils.matchComponentPath(auditContext,fileNameCanonical);if(componentMatch){const testPossibleComponentInfo=Utils.componentInfo(auditContext,componentMatch);if(testPossibleComponentInfo.viewModel&&fileNameCanonical===testPossibleComponentInfo.viewModel.path){componentInfo=testPossibleComponentInfo}}}return componentInfo};TsxUtils.prototype._handlePropertyTypePatch=function(patch,metadata){this._patchPropertyViaPath(patch,patch.locator.split("."),metadata)};TsxUtils.prototype._patchPropertyViaPath=function(patch,path,node){const contactProp=path.shift();if(node.properties?.hasOwnProperty(contactProp)){if(path.length>0){this._patchPropertyViaPath(patch,path,node.properties[contactProp])}else{const propDef=node.properties[contactProp];const existingType=propDef.type;if(this._verifyType(existingType,patch)){propDef.type=patch.patchType}}}};TsxUtils.prototype._verifyType=function(existingType,patch){let expectedTypeMatches=existingType===patch?.expectedType||!patch?.expectedType;let abortNoMatch=false;if(patch.enforceMatch){if(!expectedTypeMatches){abortNoMatch=true}}return!abortNoMatch};TsxUtils.prototype._handleMethodTypePatch=function(patch,metadata){const locatorSegs=patch.locator.split(":");const methodName=locatorSegs[0];const methodTarget=locatorSegs[1];if(metadata.methods?.hasOwnProperty(methodName)){const methodDef=metadata.methods[methodName];if(methodTarget==="return"){this._patchMethodReturnType(patch,methodDef)}else{this._patchMethodParamType(patch,methodDef,methodTarget)}}};TsxUtils.prototype._patchMethodParamType=function(patch,methodDef,parameterName){let paramDef;for(let i=0;i<methodDef.params.length;i++){if(methodDef.params[i].name===parameterName){paramDef=methodDef.params[i]}}const existingType=paramDef.type;if(this._verifyType(existingType,patch)){paramDef.type=patch.patchType}};TsxUtils.prototype._patchMethodReturnType=function(patch,methodDef){const existingType=methodDef.return;if(this._verifyType(existingType,patch)){methodDef.return=patch.patchType}};TsxUtils.prototype._handleEventDetailTypePatch=function(patch,metadata){const locatorSegs=patch.locator.split(":");const eventName=locatorSegs[0];const detailName=locatorSegs[1];if(metadata.events?.hasOwnProperty(eventName)){const eventDef=metadata.events[eventName];if(eventDef.detail?.hasOwnProperty(detailName)){const existingType=eventDef.detail[detailName].type;if(this._verifyType(existingType,patch)){eventDef.detail[detailName].type=patch.patchType}}}};TsxUtils.prototype._handleSlotDataTypePatch=function(patch,metadata){const locatorSegs=patch.locator.split(":");const slotName=locatorSegs[0];const dataName=locatorSegs[1];if(metadata.slots?.hasOwnProperty(slotName)){const slotDef=metadata.slots[slotName];if(slotDef.data?.hasOwnProperty(dataName)){const existingType=slotDef.data[dataName].type;if(this._verifyType(existingType,patch)){slotDef.data[dataName].type=patch.patchType}}}};module.exports=new TsxUtils;