/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const VC=require("./jetwco-cacc-auditConstraints");const{fuzzyTypeMatch,generateFuzzyHistorical,generateFuzzyCurrent}=require("./jetwco-cacc-typeMappingOverrides");function calcRequiredVersionMatrix(controlProfile){const requiredVersions={patch:false,minor:false,major:false,major2:false,major3:false};for(const[auditCheck,ops]of Object.entries(controlProfile)){for(const[op,opDef]of Object.entries(ops)){if(["add","remove","mutate"].includes(op)){switch(opDef){case VC.SEMVER:requiredVersions.patch=true;requiredVersions.minor=true;requiredVersions.major=true;break;case VC.NEVER:break;case VC.PATCH:requiredVersions.patch=true;break;case VC.MINOR:requiredVersions.minor=true;break;case VC.MAJOR:case VC.MAJOR_DEPRECATED:requiredVersions.major=true;break;case VC.MAJOR_2_DEPRECATED:requiredVersions.major2=true;break;case VC.MAJOR_3_DEPRECATED:requiredVersions.major3=true;break}}}}return requiredVersions}function dependenciesDiff(compareDependencies,historicalDependencies){const compare=compareDependencies?compareDependencies:{};const historical=historicalDependencies?historicalDependencies:{};const diffs={add:[],remove:[],mutate:[]};for(const[dependency,dependencyVersion]of Object.entries(compare)){if(historical.hasOwnProperty(dependency)){if(dependencyVersion!==historical[dependency]){diffs.mutate.push({dependency:dependency,version:dependencyVersion,historicalVersion:historical[dependency]})}}else{diffs.add.push({dependency:dependency,version:dependencyVersion})}}for(const[dependency,dependencyVersion]of Object.entries(historical)){if(!compare.hasOwnProperty(dependency)){diffs.remove.push({dependency:dependency,version:dependencyVersion})}}return diffs}function apiDiff(compareAPI,historicalAPI){const compare=compareAPI?compareAPI:{};const historical=historicalAPI?historicalAPI:{};const diffs={add:[],remove:[],mutate:[]};for(const[apiName,definition]of Object.entries(compare)){if(historical.hasOwnProperty(apiName)){if(JSON.stringify(definition)!==JSON.stringify(historical[apiName])){diffs.mutate.push({name:apiName,definition:definition,historicalDefinition:historical[apiName]})}}else{diffs.add.push({name:apiName,definition:definition})}}for(const[apiName,definition]of Object.entries(historical)){if(!compare.hasOwnProperty(apiName)){diffs.remove.push({name:apiName,definition:definition})}}return diffs}function mapAttributesDiff(compareMap,historicalMap,attributeKey,isBooleanFlagAttribute){const compare=compareMap?compareMap:{};const historical=historicalMap?historicalMap:{};const diffs={add:[],remove:[],mutate:[]};for(const[entryName,entryDef]of Object.entries(compare)){if(historical.hasOwnProperty(entryName)){const matchingHistoricalDef=historical[entryName];if(entryDef.hasOwnProperty(attributeKey)){if(!matchingHistoricalDef.hasOwnProperty(attributeKey)){if(!isBooleanFlagAttribute){diffs.add.push({name:entryName,value:entryDef[attributeKey]})}else if(entryDef[attributeKey]){diffs.add.push({name:entryName,value:true})}}else if(JSON.stringify(entryDef[attributeKey])!==JSON.stringify(matchingHistoricalDef[attributeKey])){if(!isBooleanFlagAttribute){diffs.mutate.push({name:entryName,value:entryDef[attributeKey],historicalValue:matchingHistoricalDef[attributeKey]})}else{if(entryDef[attributeKey]){diffs.add.push({name:entryName,value:true,historicalValue:false})}else{diffs.remove.push({name:entryName,value:false,historicalValue:true})}}}}else if(matchingHistoricalDef.hasOwnProperty(attributeKey)){if(!isBooleanFlagAttribute){diffs.remove.push({name:entryName,historicalValue:matchingHistoricalDef[attributeKey]})}else if(matchingHistoricalDef[attributeKey]){diffs.remove.push({name:entryName,historicalValue:true})}}}}return diffs}function typeDiff(currentTypeDef,compareTypeDef,overrideTypeMappings){const currentStr=currentTypeDef?currentTypeDef:"";const historicalStr=compareTypeDef?compareTypeDef:"";const diffs={add:[],remove:[],mutate:[]};const current=currentStr.split("|").map(type=>type.trim()).filter(type=>type!=="null");const historical=historicalStr.split("|").map(type=>type.trim()).filter(type=>type!=="null");if(current.length===1&&historical.length===1){if(!fuzzyTypeMatch(historical[0],current[0],overrideTypeMappings)){diffs.mutate.push({type:current[0],historicalType:historical[0]})}}else{const expandedHistorical=generateFuzzyHistorical(historical,overrideTypeMappings);current.forEach(checkType=>{if(!expandedHistorical.includes(checkType)){diffs.add.push({type:checkType})}});const expandedCurrent=generateFuzzyCurrent(current,overrideTypeMappings);historical.forEach(checkType=>{if(!expandedCurrent.includes(checkType)){diffs.remove.push({historicalType:checkType})}})}return diffs}function stringArrayDiff(currentArray,compareArray){const compare=Array.isArray(currentArray)?currentArray:[];const historical=Array.isArray(compareArray)?compareArray:[];const diffs={add:[],remove:[]};compare.forEach(arrayEntry=>{if(!historical.includes(arrayEntry)){diffs.add.push(arrayEntry)}});historical.forEach(arrayEntry=>{if(!compare.includes(arrayEntry)){diffs.remove.push(arrayEntry)}});return diffs}function incrementMajorToMaxSupported(semver,startFrom,supportedRange){let{major:testMajor}=semver.parse(startFrom);let lastSupported=startFrom;while(semver.satisfiesRange(`${++testMajor}.0.0`,supportedRange)){lastSupported=semver.parse(`${testMajor}.0.0`)}return lastSupported}function deriveConstraintMetadata(baseline,constraint){let requiredConstraint=constraint;if(!constraint||constraint===VC.SEMVER){requiredConstraint=VC.LATEST}return baseline[requiredConstraint].metadata}function semanticDiff(semver,firstVersion,secondVersion){let diff=null;const first=tolerantSemverParse(semver,firstVersion);const second=tolerantSemverParse(semver,secondVersion);if(first&&second){if(semver.eq(first.version,second.version)){diff=0}else{const modifier=semver.gte(first.version,second.version)?1:-1;if(first.major!==second.major){diff=4}else if(first.minor!==second.minor){diff=3}else if(first.patch!==second.patch){diff=2}else{diff=1}diff=diff*modifier}}return diff}function tolerantSemverParse(semver,versionString){let parsed=null;if(semver.isValid(versionString)){parsed=semver.parse(versionString)}else if(semver.isValidRange(versionString)){parsed=semver.minVersion(versionString)}return parsed}function isMarkedAsDeprecated(cacheManager,componentName,version,scope,versionMetadata,statusTarget,statusValue){let deprecated=false;let metadata=versionMetadata;if(!metadata){metadata=cacheManager.getComponentMetadata(componentName,version)}if(metadata){let checkScope=castToScope(metadata,scope);if(checkScope&&checkScope.hasOwnProperty("status")){checkScope.status.forEach(statusRecord=>{if(statusRecord.type==="deprecated"){if(!statusTarget&&!statusRecord.target){deprecated=true}else if(statusRecord.target===statusTarget){if(Array.isArray(statusRecord.value)){statusRecord.value.forEach(srv=>{if(srv===statusValue){deprecated=true}})}}}})}}return deprecated}function castToScope(rootObject,scope){if(scope&&Array.isArray(scope)&&scope.length>0){const scopes=scope.slice();let workingObj=rootObject;while(workingObj&&scopes.length>0){let scopeKey=scopes.shift();if(scopeKey.startsWith("[")){if(Array.isArray(workingObj)){let match=scopeKey.slice(1,-1).split(":");workingObj=workingObj.find(row=>row[match[0]]===match[1])}else{return}}else{workingObj=workingObj[scopeKey]}}return workingObj}else{return rootObject}}function getPrintScope(scopeArray){const workingScope=scopeArray.slice(1);const printScope=workingScope.reduce((scopeString,scopeEntry)=>{return`${scopeString}${scopeEntry==="properties"?".":scopeEntry}`},"");return printScope}function getComponentFullName(metadata){return metadata.pack?metadata.pack+"-"+metadata.name:metadata.name}function getStdErrorContext(componentName,controlRuleName){return` component ${componentName} in contradiction of ${controlRuleName} API change constraint of `}function sharedMapAPICallback(apiName,controlRuleName,controlRuleDef,semver,cacheManager,metadata,compareMetadata,componentVersionDiff,baselines,componentType,componentName,errorMsgContext){let errorConditions=[];if(componentType==="composite"){const{add:addConstraint,remove:removeConstraint}=controlRuleDef;const removeControlMetadata=deriveConstraintMetadata(baselines,removeConstraint);const diffs=apiDiff(metadata[apiName],compareMetadata[apiName]);if(checkConstraintPatchMajor(diffs.add,addConstraint,componentVersionDiff)){errorConditions.push(`${apiName} ${diffs.add.map(added=>added.name).join(", ")} added to${errorMsgContext}'${addConstraint}'`)}const removeErrors=checkConstraintMajorWithDeprecation(diffs.remove,removeConstraint,componentVersionDiff,cacheManager,componentName,removeControlMetadata,diff=>{return[apiName,diff.name]});if(removeErrors.length>0){errorConditions.push(`${apiName} ${removeErrors.map(removed=>removed.name).join(", ")} removed from${errorMsgContext}'${removeConstraint}'`)}return errorConditions.join("\n")}};function flattenArrayByAttr(arrayOfObjects,keyAttrName){if(Array.isArray(arrayOfObjects)){return arrayOfObjects.map(instance=>instance[keyAttrName])}else{return[]}}function checkConstraintMajor(verbDiffs,constraint,versionDiff){let errorFlag=false;if(verbDiffs&&verbDiffs.length>0){switch(constraint){case VC.NEVER:errorFlag=true;break;default:if(versionDiff<4){errorFlag=true}break}}return errorFlag}function checkConstraintMajorWithDeprecation(verbDiffs,constraint,versionDiff,cacheManager,componentName,controlMetadata,scopeFn,statusTarget,statusValueFn){let errorDiffs=[];if(verbDiffs&&verbDiffs.length>0){switch(constraint){case VC.NEVER:errorDiffs=verbDiffs;break;case VC.PATCH:case VC.SEMVER:case VC.MINOR:case VC.MAJOR:if(versionDiff<4){errorDiffs=verbDiffs}break;default:if(versionDiff<4||!controlMetadata){errorDiffs=verbDiffs}else{verbDiffs.forEach(diff=>{const diffScope=scopeFn.call(this,diff);let statusValue;if(statusValueFn){statusValue=statusValueFn.call(this,diff)}if(!isMarkedAsDeprecated(cacheManager,componentName,controlMetadata.version,diffScope,controlMetadata,statusTarget,statusValue)){errorDiffs.push(diff)}})}break}}return errorDiffs}function checkConstraintMinorMajor(verbDiffs,constraint,versionDiff){let errorFlag=false;if(verbDiffs&&verbDiffs.length>0){switch(constraint){case VC.NEVER:errorFlag=true;break;case VC.SEMVER:case VC.PATCH:case VC.MINOR:if(versionDiff<3){errorFlag=true}break;default:if(versionDiff<4){errorFlag=true}break}}return errorFlag}function checkConstraintMinorMajorWithDeprecation(verbDiffs,constraint,versionDiff,cacheManager,componentName,controlMetadata,scopeFn,statusTarget,statusValueFn){let errorDiffs=[];if(verbDiffs&&verbDiffs.length>0){switch(constraint){case VC.NEVER:errorDiffs=verbDiffs;break;case VC.PATCH:case VC.SEMVER:case VC.MINOR:if(versionDiff<3){errorDiffs=verbDiffs}break;case VC.MAJOR:if(versionDiff<4){errorDiffs=verbDiffs}break;default:if(versionDiff<4||!controlMetadata){errorDiffs=verbDiffs}else{verbDiffs.forEach(diff=>{const diffScope=scopeFn.call(this,diff);let statusValue;if(statusValueFn){statusValue=statusValueFn.call(this,diff)}if(!isMarkedAsDeprecated(cacheManager,componentName,controlMetadata.version,diffScope,controlMetadata,statusTarget,statusValue)){errorDiffs.push(diff)}})}break}}return errorDiffs}function checkConstraintPatchMajor(verbDiffs,constraint,versionDiff){let errorFlag=false;if(verbDiffs&&verbDiffs.length>0){switch(constraint){case VC.NEVER:errorFlag=true;break;case VC.PATCH:if(versionDiff<2){errorFlag=true}break;case VC.SEMVER:case VC.MINOR:if(versionDiff<3){errorFlag=true}break;default:if(versionDiff<4){errorFlag=true}break}}return errorFlag}module.exports={calcRequiredVersionMatrix,dependenciesDiff,apiDiff,mapAttributesDiff,typeDiff,stringArrayDiff,incrementMajorToMaxSupported,deriveConstraintMetadata,semanticDiff,tolerantSemverParse,isMarkedAsDeprecated,castToScope,getPrintScope,getComponentFullName,getStdErrorContext,sharedMapAPICallback,flattenArrayByAttr,checkConstraintMajor,checkConstraintMajorWithDeprecation,checkConstraintMinorMajor,checkConstraintMinorMajorWithDeprecation,checkConstraintPatchMajor};