/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
var NT;const _GLOBAL="_@global";const ANON_FUNC_PREFIX="AnonFunc_";const COMMON=["oj","window","console","parseInt","parseFloat","setInterval","JSON","document","Number","BigInt","Math","Date","String","RegExp","arguments","Array","Promise","Object","Function","Boolean","Symbol","Error","EvalError","InternalError","RangeError","ReferenceError","SyntaxError","TypeError","URIError","Int8Array","Uint8Array","Uint8ClampedArray","Int16Array","Uint16Array","Int32Array","Uint32Array","Float32Array","Float64Array","Map","Set","WeakMap","WeakSet","Generator","GeneratorFunction","AsyncFunction","Reflection","Intl","WebAssembly","ArrayBuffer","SharedArrayBuffer","Atomics","DataView"];function VarTrack(){this._funcVarTable={};this._funcParentage={};this._funcStack=[];this._funcBlocks={};this._anonFuncSuffix=0;this._undeclared=null;this._nodeWithParent=[]};VarTrack.prototype.createFuncDeclarations=function(context,node){var args,arg,body,stmt,funcVars,funcName,i,n;NT=NT?NT:context.utils.AstUtils.getNodeTypes();funcName=this._pushFuncName(context,node);if(!funcName){return}if(this._funcVarTable[funcName]){return}funcVars=this._updateTrackingTable(node,false,funcName);args=node.params;for(i=0;i<args.length;i++){arg=args[i];if(arg.type===NT.IDENTIFIER){funcVars[arg.name]={type:"funcarg",pos:arg.start}}}body=node.body.body;for(i=0;i<body.length;i++){stmt=body[i];if(stmt.type===NT.VAR_DECLARATION){this._addVarToTrackingTable(stmt,funcVars)}else if(stmt.type===NT.FUNC_DECLARATION){this.createFuncDeclarations(context,stmt);this._popFuncName()}else if(stmt.type===NT.EXPR_STMT){var expr=stmt.expression;if(expr.type===NT.ASSIGNMENT_EXPR){n=expr.right;if(n.type===NT.FUNC_EXPR){this.createFuncDeclarations(context,n);this._popFuncName()}}}};return{funcVarTable:this._funcVarTable,funcVars:funcVars}};VarTrack.prototype.isFunctionKnown=function(context,node){var n;for(n in this._funcBlocks){n=this._funcBlocks[n];if(n===node){return true}}return false};VarTrack.prototype._addVarToTrackingTable=function(stmt,funcVars,global){var decls,decl,obj,i;decls=stmt.declarations;for(i=0;i<decls.length;i++){decl=decls[i];if(decl.type===NT.VAR_DECLARATOR){funcVars[decl.id.name]=obj={type:global?"globvar":"var"};obj.start=decl.start;if(decl.init){if(decl.init.type===NT.NEW_EXPR){obj.valType="new";if(decl.init.callee.type===NT.MEMBER_EXPR){if(decl.init.callee.object&&decl.init.callee.object.type===NT.IDENTIFIER){obj.obj=decl.init.callee.object.name;obj.class=decl.init.callee.property.name;obj.origClass=obj.class;obj.pos=decl.init.callee.object.start}}}else if(decl.init.type===NT.LITERAL){obj.valType="lit";obj.pos=decl.init.start}else if(decl.init.type===NT.CALL_EXPR){if(decl.init.callee.type===NT.IDENTIFIER){obj.valType="funcret";obj.func=decl.init.callee.name;obj.pos=decl.init.callee.start;if(obj.func==="$"){if(decl.init.arguments&&decl.init.arguments.length){let jqargs=decl.init.arguments;if(jqargs[0].type===NT.IDENTIFIER){if(jqargs[0].name==="window"){obj.funcarg="window"}}else if(jqargs[0].type===NT.LITERAL){if(jqargs[0].value==="body"){obj.funcarg="body"}}}}}}else if(decl.init.type===NT.IDENTIFIER){obj.valType="var";obj.varName=decl.init.name;obj.pos=decl.init.start}}}}};VarTrack.prototype._updateTrackingTable=function(node,global,funcName){var funcVars;if(!funcName){funcName=global?_GLOBAL:node.id?node.id.name:this._makeAnonFuncName()}if(!this._funcVarTable[funcName]){this._funcVarTable[funcName]=funcVars={}}else{funcVars=this._funcVarTable[funcName]}return funcVars};VarTrack.prototype.isVarDefined=function(context,node,useNode,varName){var fnName,fnParent,funcVars;if(this.isCommonVar(context,varName)){return}if(this._funcVarTable[varName]){return}fnName=this.getContainingFunctionName(context,node);if(fnName){funcVars=this._funcVarTable[fnName];if(funcVars&&funcVars[varName]){this.setReferenced(funcVars,varName);return}fnParent=fnName;while(true){if(this._funcParentage[fnParent]){fnParent=this._funcParentage[fnParent];funcVars=this._funcVarTable[fnParent];if(funcVars&&funcVars[varName]){this.setReferenced(funcVars,varName);return}}else{break}}}funcVars=this._funcVarTable[_GLOBAL];if(funcVars&&funcVars[varName]){this.setReferenced(funcVars,varName);return}if(!this._undeclared){this._undeclared={}}if(!this._undeclared[varName+useNode.start]){this._undeclared[varName+"!@#$%"+useNode.start]=useNode}};VarTrack.prototype.setReferenced=function(funcVars,varName){funcVars[varName].used=true};VarTrack.prototype.getGlobalVars=function(context){var funcVars,prog,stmt,i;NT=NT?NT:context.utils.AstUtils.getNodeTypes();funcVars=this._updateTrackingTable(null,true);prog=context.utils.AstUtils.getProgram();if(!prog){return}for(i=0;i<prog.body.length;i++){stmt=prog.body[i];if(stmt.type===NT.FUNC_DECLARATION){continue}if(stmt.type===NT.VAR_DECLARATION){this._addVarToTrackingTable(stmt,funcVars,true)}}};VarTrack.prototype.reset=function(){this._funcVarTable={};this._funcStack=[];this._funcParentage={};this._funcBlocks={};this._anonFuncSuffix=0;this._undeclared=null};VarTrack.prototype._pushFuncName=function(context,node){var funcName=node.id?node.id.name:this._makeAnonFuncName();if(this._funcParentage[funcName])return false;this._funcParentage[funcName]=this.getContainingFunctionName(context,node);this._funcBlocks[funcName]=node;this._funcStack.push(funcName);return funcName};VarTrack.prototype._popFuncName=function(){return this._funcStack.pop()};VarTrack.prototype.getContainingFunctionName=function(context,node){var funcName,n,b;var block=context.utils.AstUtils.getBlock(node);NT=NT?NT:context.utils.AstUtils.getNodeTypes();if(block&&block.type===NT.PROGRAM){return null}if(block&&block.parent){if(block.parent.type===NT.FUNC_DECLARATION||block.parent.type===NT.FUNC_EXPR){if(block.parent.id&&block.parent.id.type===NT.IDENTIFIER){return block.parent.id.name}funcName=this._isAnonymousFunc(block.parent);if(funcName){return funcName}}b=block.parent;while(b){if(b.type===NT.FUNC_DECLARATION||b.type===NT.FUNC_EXPR){if(b.id&&b.id.type===NT.IDENTIFIER){return b.id.name}}b=b.parent}funcName=this._isAnonymousFunc(block);if(funcName){return funcName}}if(node.type===NT.FUNC_EXPR||node.type===NT.FUNC_DECLARATION){if(this._funcStack.length){return this._funcStack[this._funcStack.length-1]}}if(this._nodeWithParent.length){return this.getContainingFunctionName(context,this._nodeWithParent[this._nodeWithParent.length-1])}return null};VarTrack.prototype._makeAnonFuncName=function(){return ANON_FUNC_PREFIX+ ++this._anonFuncSuffix};VarTrack.prototype._isAnonymousFunc=function(block){var funcName,node;if(this._funcBlocks){for(funcName in this._funcBlocks){if(funcName.startsWith(ANON_FUNC_PREFIX)){node=this._funcBlocks[funcName];if(node===block){return funcName}}}}return null};VarTrack.prototype.isCommonVar=function(context,varName){return COMMON.includes(varName)};VarTrack.prototype.pushNodeWithParent=function(node){this._nodeWithParent.push(node)};VarTrack.prototype.popNodeWithParent=function(node){return this._nodeWithParent.pop()};VarTrack.prototype.getUndeclared=function(){return this._undeclared};VarTrack.prototype.dump=function(context){var func;console.log("----------------------VarTrack Dump----------------------------");if(!this._funcVarTable){console.log("* empty");return}if(this._funcVarTable[_GLOBAL]){this._dumpFunc(context,_GLOBAL,true)}for(func in this._funcVarTable){if(func===_GLOBAL){continue}this._dumpFunc(context,func,false)}console.log("--------------------End-VarTrack Dump--------------------------\n")};VarTrack.prototype._dumpFunc=function(context,func,g){var funcVars,v,o,p,loc,rowcol,indent="    ",indent2="       ";var rowcol_unknown={row:"?",col:"?"};var utils=context.utils.utils;if(this._funcParentage){p=this._funcParentage[func];if(!p){p="none"}}if(this._funcBlocks){loc=this._funcBlocks[func];loc=loc?utils.getRowColFromIndex(context.data,loc.start):rowcol_unknown}console.log("\n"+(g?"*global vars":func)+(g?"":"()")+(g?"":" - ("+loc.row+", "+loc.col+")")+(g?"":"  parent: "+p));funcVars=this._funcVarTable[func];if(!funcVars||!utils.hasAnyProps(funcVars)){console.log(indent+"- none -");return}for(v in funcVars){o=funcVars[v];rowcol=context.data?utils.getRowColFromIndex(context.data,o.pos):rowcol_unknown;console.log(indent+v);console.log(indent2+"pos      : "+"("+rowcol.row+", "+rowcol.col+")");if(o.type){console.log(indent2+"type     : "+o.type)}if(o.valType){console.log(indent2+"valType  : "+o.valType)}if(o.class){console.log(indent2+"class    : "+o.class)}if(o.origClass){console.log(indent2+"origClass: "+o.origClass)}if(o.obj){console.log(indent2+"obj      : "+o.obj)}}};module.exports=VarTrack;