/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const cssHelper=require("./helpers/cssHelper");const RULE_NAME="oj-css-style-bp-color";const SHORT_DESCRIPT="For best practices, CSS color values should not be used - color classes such as 'oj-text-color-primary' are preferred.";const DESCRIPT="For best practices, CSS color values should not be used - color classes such as 'oj-text-color-primary' are preferred."+" See the Colors demo category in the JET cookbook under the Framework "+"<a href='https://www.oracle.com/webfolder/technetwork/jet/jetCookbook.html?component=colors&demo=bgcolors'>Utility CSS</a> category.";const IDENTIFIER="Identifier";const FUNCTION="Function";const HEXCOLOR="HexColor";const HASH="Hash";const VAR_PREFIX="--";function Rule(){this._checkList=null;this._isAccept=false};Rule.prototype.getName=function(){return RULE_NAME};Rule.prototype.getShortDescription=function(){return SHORT_DESCRIPT};Rule.prototype.getDescription=function(){return DESCRIPT};Rule.prototype.register=function(regCtx){if(!this._checkAcceptReject(regCtx)){return false}this._CssUtils=regCtx.utils.CssUtils;return{"css-rule":this._onRule}};Rule.prototype._onRule=function(ruleCtx,rule){var block,decl,val,b,i;if(!(rule.prelude&&rule.prelude.children&&rule.prelude.children.length)){return}block=rule.block.children;for(i=0;i<block.length;i++){decl=block[i];if(decl.type==="Declaration"){if(cssHelper.COLOR_PROPS.includes(decl.property)){if(this._okProp(decl.property)){if(decl.value.type==="Raw"){val=_encodeRaw(decl.value,ruleCtx.utils.utils);if(this._isHardColor(ruleCtx,val)){this._emitIssue(ruleCtx,decl.value)}return}if(_isColorFuncDecl(decl)){b=_isColorFuncDeclCssVar(decl)}else{b=_isCssVarDecl(decl)}if(!b){this._emitIssue(ruleCtx,decl.value)}}}else if(cssHelper.COLOR_PROPS_MULTI.includes(decl.property)){if(this._okProp(decl.property)){this._handleMulti(ruleCtx,decl)}}}}};Rule.prototype._handleMulti=function(ruleCtx,decl){if(decl.value.children){var a,val,ao,o,i,j;var a=decl.value.children;for(i=0;i<a.length;i++){val=a[i];if(val.children&&(val.type!==FUNCTION||!_isColorFunc(val.name))){ao=val.children;for(j=0;j<ao.length;j++){var o=ao[j];if(o.type===HEXCOLOR||o.type===HASH){this._emitIssue(ruleCtx,o)}else if(o.type===FUNCTION){if(_isColorFunc(o.name)){this._emitIssue(ruleCtx,o)}}}}else if(val.type===IDENTIFIER){if(this._CssUtils.isColorName(val.name)){this._emitIssue(ruleCtx,val)}}else if(val.type===HEXCOLOR||val.type===HASH){this._emitIssue(ruleCtx,val)}else if(val.type===FUNCTION){if(_isColorFunc(val.name)&&!_isColorFuncCssVar(val)){this._emitIssue(ruleCtx,val)}}}}};Rule.prototype._emitIssue=function(ruleCtx,o){var issue;issue=new ruleCtx.Issue("CSS color '"+this._encodeColor(o,ruleCtx)+"' - best practices: use the utility CSS selectors available (see 'Text', 'Icons', and 'Link' pages)");issue.setPosition(this._CssUtils.getPosition(ruleCtx,o.loc));ruleCtx.reporter.addIssue(issue,ruleCtx)};Rule.prototype._encodeColor=function(v,ruleCtx){var val,ret;val=v;if(val.type===HEXCOLOR||val.type===HASH){ret="#"+val.value}else if(val.type===IDENTIFIER){ret=val.name}else if(val.type===FUNCTION&&_isColorFunc(val.name)){ret=_encodeColorFunction(val)}else if(val.type==="Value"){ret=this._encodeColor(val.children[0])}else if(val.type==="Raw"){ret=_encodeRaw(val,ruleCtx.utils.utils)}else{ret="??"};return ret};function _encodeColorFunction(val){var s,c,i;s=val.name+"(";c=val.children;if(c[0].name==="var"){val=c[0];if(val.children&&val.children.length){val=val.children[0];if(val.name){s+=val.name}}}else{for(i=0;i<c.length;i++){s+=c[i].value}}return s+=")"};function _encodeRaw(val,utils){var s,i;s=val.value.trim();if(s.startsWith("#")){for(i=1;i<s.length;i++){if(!_isHex(s.charAt(i))){s=s.substring(0,i);break}}return s}else if(_isColorFunc(s)){i=s.indexOf(")");return i>=0?s.substring(0,i+1):s}else{i=utils.getIndexToWhitespace(s);s=i>=0?s.substring(0,i):s;return s.replace(/[\\,:;\[\{}]/g,"")}};function _isHex(c){const HEX="0123456789ABCDEFabcdef";return HEX.indexOf(c)>=0};Rule.prototype._okProp=function(prop){var i;if(this._checkList){for(i=0;i<this._checkList.length;i++){if(this._checkList[i]===prop){return this._isAccept}}return!this._isAccept}return true};Rule.prototype._isHardColor=function(ruleCtx,s){var x,ret=false;if(s.startsWith("#")){ret=true}else if(s.startsWith("--")){}else if(_isColorFunc(s)){x=s.indexOf("(");if(x<0){return false}s=s.substring(x);ret=!s.startsWith("--")}else{ret=ruleCtx.utils.CssUtils.isColorName(s)}return ret};function _isCssVarDecl(decl){var c,v;c=decl.value.children;if(c){v=c[0];return v.name==="var"}return false};function _isColorFunc(s){var ret;if(s){s=s.toLowerCase();ret=s.startsWith("rgb")||s.startsWith("hsl")}return ret};function _isColorFuncDecl(decl){var c,v;c=decl.value.children;if(c){v=c[0];return _isColorFunc(v.name)}return false}function _isColorFuncCssVar(s){return _isColorFunc(s)&&_isColorFuncCssVar(s)};function _isColorFuncDeclCssVar(decl){var c,v;var ret=false;c=decl.value.children;if(c){v=c[0];ret=_isColorFuncDecl(decl)&&_isColorFuncCssVar(v)}return ret}function _isColorFuncCssVar(v){var ret=false;if(v.children&&v.children.length&&v.children[0].type==="Function"){v=v.children[0].children;if(v&&v.length===1){v=v[0];ret=v.type===IDENTIFIER&&v.name.startsWith(VAR_PREFIX)}}return ret};Rule.prototype._checkAcceptReject=function(regCtx){var customOpts,accept,reject;if(!(customOpts=regCtx.ruleOpts.customOpts)){return true}accept=customOpts.accept;reject=customOpts.reject;if(accept||reject){if(accept&&reject){regCtx.utils.msgLib.error("Rule "+RULE_NAME+":  options 'accept' and 'reject' are mutually exclusive");return false}if(accept){this._checkList=accept;this._isAccept=true}else{this._checkList=reject}if(!Array.isArray(this._checkList)){regCtx.utils.msgLib.error("Rule "+RULE_NAME+":  option '"+(accept?"accept":"reject")+"' is not an array");return false}for(let i=0;i<this._checkList.length;i++){if(typeof this._checkList[i]==="string"){this._checkList[i]=this._checkList[i].trim()}}}return true};module.exports=Rule;