/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULE_NAME="oj-html-wctag-$props";const LONG_DESCRIPT="Any use of $properties.xxx in a web component should ensure that xxx is a declared property for the web component.";const SHORT_DESCRIPT="Any use of $properties.xxx in a web component should ensure that xxx is a declared property for the web component.";const PROPS="$properties.";const AT_OJAF="@ojaf";const PROPS_AT_OJAF=PROPS+AT_OJAF;const RE=/\s/;const DELIMS="}]!><+-|=/%&?[,()";const COMPJSON="component.json";const LENGTH="length";const OBJECT="object";const FUNCTION="function";const ARRAY="array";const STRING="string";const DOT=".";const CHAIN_METHOD="?.(";const CHAIN_ARRAY="?.[";const CHAIN_LENGTH="?.length";const CHAIN="?.";const LPAREN="(";const LBRACKET="[";class Rule{constructor(){this._curFile=null;this._tagName=null;this._libPath=require("path");this._libFs=require("fs")}getName(){return RULE_NAME}getShortDescription(){return SHORT_DESCRIPT}getDescription(){return LONG_DESCRIPT}register(regCtx){this._metaLib=regCtx.utils.metaLib;return{"attrexpr-$props":this._onExpr}}_onExpr(ruleCtx,attrName,attrValue){if(!ruleCtx.filepath.includes("jet-composites")){return}let ar=attrValue.replace(/\$properties\./g,PROPS_AT_OJAF).split(PROPS);ar.forEach(prop=>{if(prop.startsWith(AT_OJAF)){this._doProp(ruleCtx,attrName,prop.substring(AT_OJAF.length).trim())}})}_doProp(ruleCtx,attrName,attrVal){var $props,prop,term,tagName,propType;if(this._curFile!==ruleCtx.filepath){this._curFile=ruleCtx.filepath;this._tagName=this._getComponentName(this._curFile)}if(!(tagName=this._tagName)){return}$props=this._findProp(attrVal);if(!(prop=$props.prop)){return}let issue,attrPos;if(this._metaLib.isTagCompProp(tagName,prop)){term=$props.term;if(term===CHAIN_METHOD||term===LPAREN){propType=this._metaLib.getTagPropType(tagName,prop);if(propType&&!propType.toLowerCase().startsWith(FUNCTION)){let lastProp=_getLastProp(prop);issue=new ruleCtx.Issue(`Expression $properties.${prop} : ${lastProp} is not a function - web component <${tagName}>`);attrPos=ruleCtx.utils.DomUtils.getAttribPosition(ruleCtx.data,ruleCtx.tagNode,attrName);issue.setPosition(attrPos.row,attrPos.col,attrPos.start,attrPos.end);issue.setMsgKey(RULE_NAME+"_3");ruleCtx.reporter.addIssue(issue,ruleCtx)}}return}if(prop.endsWith(DOT)){issue=new ruleCtx.Issue(`'$properties.${prop}' : unexpected dot, did you intend the chaining operator ?. (web component <${tagName}>)`);attrPos=ruleCtx.utils.DomUtils.getAttribPosition(ruleCtx.data,ruleCtx.tagNode,attrName);issue.setPosition(attrPos.row,attrPos.col,attrPos.start,attrPos.end);issue.setMsgKey(RULE_NAME+"_2");ruleCtx.reporter.addIssue(issue,ruleCtx);return}let subProps=prop.split(DOT);let len=subProps.length-1;let soFar,curType;if(len>=1){let subProp,remainder,attrPos,i;soFar="";curType=null;for(i=0;i<len;i++){subProp=subProps[i];soFar=soFar+(i?DOT:"")+subProp;curType=this._metaLib.getTagPropType(tagName,soFar);if(curType&&curType.toLowerCase()===OBJECT){if(!this._metaLib.hasTagCompPropSubprop(tagName,soFar)){remainder=_getRemainder(subProps,i);issue=new ruleCtx.Issue(`$properties.${soFar} is an 'object' : cannot verify that '${remainder}' is defined by <${tagName}>`);issue.setSeverity("info");attrPos=ruleCtx.utils.DomUtils.getAttribPosition(ruleCtx.data,ruleCtx.tagNode,attrName);issue.setPosition(attrPos.row,attrPos.col,attrPos.start,attrPos.end);issue.setMsgKey(RULE_NAME+"_1");ruleCtx.reporter.addIssue(issue,ruleCtx);return}}}}len=subProps.length;if(len>1&&subProps[len-1]===LENGTH){subProps.splice(len-1,1);soFar=subProps.join(DOT);curType=this._metaLib.getTagPropType(tagName,soFar);curType=curType?curType.toLowerCase():curType;if(curType&&(curType.startsWith(ARRAY)||curType.startsWith(STRING))){return}}if(!this._metaLib.isTagCompProp(tagName,prop)){issue=new ruleCtx.Issue(`Expression refers to $properties.${prop} : not defined by web component <${tagName}>`);attrPos=ruleCtx.utils.DomUtils.getAttribPosition(ruleCtx.data,ruleCtx.tagNode,attrName);issue.setPosition(attrPos.row,attrPos.col,attrPos.start,attrPos.end);ruleCtx.reporter.addIssue(issue,ruleCtx)}}_findProp(attrValue){var x,s,end,inSq;for(x=0;x<attrValue.length;x++){s=attrValue.charAt(x);if(!inSq&&s==="["){inSq=true}if(DELIMS.includes(s)||RE.test(s)){end=attrValue.substring(x,x+8);if(end!==CHAIN_LENGTH){end=attrValue.substring(x,x+3);if(end!==CHAIN_METHOD&&end!==CHAIN_ARRAY){if(end.startsWith(LPAREN)){end=LPAREN}else if(end.startsWith(LBRACKET)){end=LBRACKET}else if(end.startsWith(CHAIN)){end=CHAIN}else{end=undefined}}}if(inSq&&s==="]"){inSq=false;continue}s=attrValue.substring(0,x);if(end===CHAIN_LENGTH){s+=".length"}break}}return{prop:s,term:end}}_getComponentName(file){var path,name,meta;path=this._libPath.dirname(file);meta=this._getCompMeta(path);if(meta){name=(meta.pack?meta.pack+"-":"")+meta.name}return name}_getCompMeta(filepath){var metaPath,json;try{metaPath=this._libPath.join(filepath,COMPJSON);json=this._readFile(metaPath);if(json){json=JSON.parse(json)}}catch(e){}return json}_readFile(file){var data;try{data=this._libFs.readFileSync(file,"utf8")}catch(e){}return data}}function _getLastProp(props){var subProps=props.split(DOT);return subProps[subProps.length-1]};function _getRemainder(a,i){var len=a.length;var n=len-i;var s="";i++;n=i;while(i<len){s+=(i>n?DOT:"")+a[i];i++}return s}module.exports=Rule;