/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const helperClass=require("./helpers/vartrack");const RULE_NAME="oj-js-comp-attr-deprecated";const _GLOBAL="_@global";const THIS="this";var nt;var depMembers;var delMembers;function Rule(){this._reset();this._scope=null};Rule.prototype.getName=function(){return RULE_NAME};Rule.prototype.getShortDescription=function(){return"JET component class deprecated members should not be referenced"};Rule.prototype.getDescription=function(){return"JET component class deprecated members should not be referenced"};Rule.prototype.register=function(regCtx){if(!this._getRuleOptions(regCtx)){return null}var ret={file:this._newFile,startscript:this._newFile,endfile:this._endFile,endscript:this._endFile};nt=regCtx.jsNodeTypes;ret[nt.FUNC_DECLARATION]=this._setup;ret[nt.FUNC_EXPR]=this._setup;ret[nt.MEMBER_EXPR]=this._handleMemberExpr;ret[nt.ASSIGNMENT_EXPR]=this._handleAssign;ret[nt.CALL_EXPR]=this._handleCall;return ret};Rule.prototype._reset=function(){this._funcVarTable=null;this._globalVars=false;this._define=false;if(this._helper){this._helper.reset()}};Rule.prototype._handleCall=function(ruleCtx,node){if(node.callee&&(node.callee.name==="define"||node.callee.name==="require")){this._funcVarTable=this._handleViewModelDefine(ruleCtx,node);return}if(!depMembers){depMembers=ruleCtx.utils.metaLib.getDeprecatedMemberList(ruleCtx)}if(!delMembers){delMembers=ruleCtx.utils.metaLib.getDeletedMemberList(ruleCtx)}};Rule.prototype._handleViewModelDefine=function(ruleCtx,node){var args,stmt,o,i;args=node.arguments;if(!args){return}for(i=0;i<args.length;i++){stmt=args[i];if(stmt.type===nt.FUNC_EXPR){o=this._helper.createFuncDeclarations(ruleCtx,stmt);this._funcVarTable=o.funcVarTable}}this._define=true;return this._funcVarTable};Rule.prototype._handleMemberExpr=function(ruleCtx,node){var component,member,objName,status,comment,issue,version,deleted;var thoughtToBe,emitDep,emitDel;var metaLib=ruleCtx.utils.metaLib;if(!depMembers){depMembers=metaLib.getDeprecatedMemberList(ruleCtx)}if(!delMembers){delMembers=metaLib.getDeletedMemberList(ruleCtx)}if(node.parent&&node.parent.type===nt.CALL_EXPR){return}objName=this._getVarFromMemberExpr(node);if(this._isCommonObject(ruleCtx,objName)){return}if(node.property){member=node.property.name}if(!(member&&objName)){return}if(!depMembers[member]){deleted=delMembers[member];if(!deleted){return}}component=this._findInstantiatedComponent(ruleCtx,node,objName);if(ruleCtx.utils.AstUtils.isFuncArg(node,objName)||!component){if(member!=="constructor"&&!objName.endsWith(".constructor")){if(deleted&&this._scope.deleted.unsure||!deleted&&this._scope.deprecated.unsure){issue=new ruleCtx.Issue("Possible use of "+(deleted?"deleted (in "+deleted[0]+", "+deleted[1]+")":"deprecated")+" JET member '"+member+"' on var '"+objName+"' (class cannot be determined)");issue.setMsgKey(ruleCtx.ruleName+"_1");issue.setPosition(null,null,node.property.start,node.property.end);ruleCtx.reporter.addIssue(issue,ruleCtx)}}return}if(member.startsWith("_")){return}if(status=metaLib.isClassMemberDeprecated(component,member)){comment=ruleCtx.utils.utils.removeMarkup(status[0].description)}thoughtToBe=this._isOrigVarValue(ruleCtx,node,objName)?"":"thought to be ";emitDep=thoughtToBe&&this._scope.deprecated.unsure||!thoughtToBe&&this._scope.deprecated.sure;emitDel=thoughtToBe&&this._scope.deleted.unsure||!thoughtToBe&&this._scope.deleted.sure;if(comment){if(emitDep){issue=new ruleCtx.Issue("Member '"+member+"' on var '"+objName+"' ("+thoughtToBe+component+")"+(comment.toLowerCase().includes("deprecated")?". ":" is deprecated. ")+comment)}}else{if(metaLib.isClassDeprecated(component)){if(emitDep){issue=new ruleCtx.Issue("Method '"+member+"' on var '"+objName+"' called on deprecated component ("+thoughtToBe+component+").")}}}if(!issue){version=metaLib.isClassMemberDeleted(component,member);if(version){if(deleted&&emitDel){issue=new ruleCtx.Issue("Member '"+member+"' on var '"+objName+"' ("+thoughtToBe+component+")"+" was removed in version "+version)}}else if(metaLib.isClassDeleted(component)){if(deleted&&emitDel){issue=new ruleCtx.Issue("Member '"+member+"' on var '"+objName+"' called on deleted class ("+thoughtToBe+component+").");issue.setSeverity("critical")}}if(issue){issue.setSeverity("critical");issue.setMsgKey(RULE_NAME+"_2")}}if(issue){ruleCtx.reporter.addIssue(issue,ruleCtx)}};Rule.prototype._handleAssign=function(ruleCtx,node){if(node.left){this._handleAssign2(ruleCtx,node,node.left,true)}if(node.right){this._handleAssign2(ruleCtx,node,node.right,false)}};Rule.prototype._handleAssign2=function(ruleCtx,exprNode,node){var component,objName,member,status,comment,issue;if(node.property){if(!node.object){return}objName=node.object.name;if(!objName){if(node.object&&node.object.object){if(node.object.object.name){objName=node.object.object.name}else if(node.object.object.type===nt.THIS_EXPR){objName=THIS}}}if(!objName){if(node.object.type===nt.THIS_EXPR){objName=THIS}}if(!objName){return}if(node.property.type==="Identifier"){member=node.property.name;if(!depMembers){depMembers=ruleCtx.utils.metaLib.getDeprecatedMemberList(ruleCtx)}if(!delMembers){delMembers=ruleCtx.utils.metaLib.getDeletedMemberList(ruleCtx)}if(!depMembers[member]){return}component=this._findInstantiatedComponent(ruleCtx,exprNode,objName);if(!component&&objName!=="this"){if(member!=="constructor"&&!objName.endsWith(".constructor")){if(this._scope.deprecated.unsure){issue=new ruleCtx.Issue("Possible use of deprecated JET member '"+member+"' on var '"+objName+"' (class cannot be determined)");issue.setMsgKey(ruleCtx.ruleName+"_1");ruleCtx.reporter.addIssue(issue,ruleCtx)}}return}if(!this._scope.deprecated.unsure){return}if(status=ruleCtx.utils.metaLib.isClassMemberDeprecated(component,member)){comment=ruleCtx.utils.utils.removeMarkup(status[0].description);issue=new ruleCtx.Issue("Member '"+member+"' on var '"+objName+"' (thought to be "+component+")"+(comment.toLowerCase().includes("deprecated")?". ":" is deprecated. ")+comment)}else{if(ruleCtx.utils.metaLib.isClassDeprecated(component)){issue=new ruleCtx.Issue("Member '"+member+"' on var '"+objName+"' called on deprecated component (thought to be "+component+").")}}if(issue){ruleCtx.reporter.addIssue(issue,ruleCtx)}}}};Rule.prototype._newFile=function(ruleCtx){if(ruleCtx.type==="file"&&ruleCtx.filetype==="html"){return}if(!this._helper){this._helper=new helperClass}this._reset();if(!nt&&ruleCtx.utils.AstUtils){nt=ruleCtx.utils.AstUtils.getNodeTypes()}};Rule.prototype._endFile=function(){this._define=false;if(this._helper){this._helper.reset()}};Rule.prototype._setup=function(ruleCtx,node){if(!depMembers){depMembers=ruleCtx.utils.metaLib.getDeprecatedMemberList(ruleCtx)}if(!this._globalVars){this._helper.getGlobalVars(ruleCtx);this._globalVars=true}var o=this._helper.createFuncDeclarations(ruleCtx,node);if(o){this._funcVarTable=o.funcVarTable;var funcName;for(funcName in this._funcVarTable){this._handleVarAssignments(ruleCtx,node,this._funcVarTable[funcName])}}};Rule.prototype._addVarToTrackingTable=function(stmt,funcVars,global){var decls,decl,obj,i;decls=stmt.declarations;for(i=0;i<decls.length;i++){decl=decls[i];if(decl.type===nt.VAR_DECLARATOR){funcVars[decl.id.name]=obj={type:global?"globvar":"var"};if(decl.init){if(decl.init.type===nt.NEW_EXPR){obj.valType="new";if(decl.init.callee.type===nt.MEMBER_EXPR){if(decl.init.callee.object&&decl.init.callee.object.type===nt.IDENTIFIER){obj.obj=decl.init.callee.object.name;obj.class=decl.init.callee.property.name;obj.origClass=obj.class}}}else if(decl.init.type===nt.LITERAL){obj.valType="lit"}else if(decl.init.type===nt.CALL_EXPR){if(decl.init.callee.type===nt.IDENTIFIER){obj.valType="funcret";obj.func=decl.init.callee.name}}else if(decl.init.type===nt.IDENTIFIER){obj.valType="var";obj.varName=decl.init.name}}}}};Rule.prototype._findInstantiatedComponent=function(ruleCtx,node,varName){var funcName=ruleCtx.utils.AstUtils.getContainingFunctionName(node);var funcVars=funcName&&this._funcVarTable?this._funcVarTable[funcName]:null;var varDef;if(funcVars){varDef=funcVars[varName];if(!varDef){funcVars=this._funcVarTable[_GLOBAL];if(funcVars){varDef=funcVars[varName]}}if(varDef&&varDef.valType){while(varDef.valType==="var"||varDef.valType==="globvar"){varDef=funcVars[varDef.varName];if(!varDef.valType){return}}if(varDef.class){return(varDef.obj?varDef.obj+".":"")+varDef.class}}}};Rule.prototype._handleVarAssignments=function(ruleCtx,node,funcVars){var body,stmt,leftObj,rightObj,i;body=node.body.body;for(i=0;i<body.length;i++){stmt=body[i];if(stmt.type===nt.EXPR_STMT){if(stmt.expression){if(stmt.expression.type===nt.ASSIGNMENT_EXPR){if(stmt.expression.left.type===nt.IDENTIFIER){if(!funcVars[stmt.expression.left.name]){funcVars[stmt.expression.left.name]={type:"globvar"}}if(stmt.expression.right.type===nt.IDENTIFIER){if(!funcVars[stmt.expression.right.name]){funcVars[stmt.expression.right.name]={type:"globvar"}}leftObj=funcVars[stmt.expression.left.name];rightObj=funcVars[stmt.expression.right.name];leftObj.valType=rightObj.valType;leftObj.varName=rightObj.varName}}}}}}};Rule.prototype._getVarFromMemberExpr=function(me,varSoFar,level){var obj;level=typeof level==="number"?level+1:0;if(me.object){obj=me.object;if(obj.type===nt.IDENTIFIER){varSoFar=varSoFar?varSoFar+"."+obj.name:obj.name}else if(obj.type===nt.MEMBER_EXPR){varSoFar=this._getVarFromMemberExpr(obj,varSoFar,level)}else if(obj.type===nt.THIS_EXPR){varSoFar=THIS}if(me.property&&level){if(me.property.type===nt.IDENTIFIER){varSoFar=varSoFar?varSoFar+"."+me.property.name:me.property.name}else if(me.property.type===nt.MEMBER_EXPR){varSoFar=this._getVarFromMemberExpr(me.property,varSoFar,level)}}}return varSoFar};Rule.prototype._isCommonObject=function(ruleCtx,objName){return objName==="this"||objName==="self"||objName==="_self"||objName==="window"||objName==="console"||this._helper.isCommonVar(objName)};Rule.prototype._isOrigVarValue=function(ruleCtx,node,varName){var funcName,funcVars,varDef;funcName=ruleCtx.utils.AstUtils.getContainingFunctionName(node);if(funcName){funcVars=this._funcVarTable[funcName];if(funcVars){varDef=funcVars[varName]}}if(!varDef){funcVars=this._funcVarTable[_GLOBAL];if(funcVars){varDef=funcVars[varName]}}if(!varDef){return false}while(varDef.valType!=="new"){if(varDef.valType==="lit"){break}if(varDef.valType==="var"){varDef=funcVars[varDef.varName]}}return varDef&&varDef.valType==="new"&&varDef.class===varDef.origClass};Rule.prototype._getRuleOptions=function(regCtx){var scope,customOpts;if(customOpts=regCtx.ruleOpts.customOpts){if(scope=customOpts.scope){if(typeof scope!=="object"){regCtx.error("Rule "+RULE_NAME+" : invalid config 'ruleMods.scope' property. Rule disabled.");return false}}}this._scope={deprecated:{sure:true,unsure:false},deleted:{sure:true,unsure:false}};if(!scope){return true}var o=scope.deprecated;if(o){if(o.hasOwnProperty("sure")){this._scope.deprecated.sure=!!scope.deprecated.sure}if(o.hasOwnProperty("unsure")){this._scope.deprecated.unsure=!!scope.deprecated.unsure}}o=scope.deleted;if(o){if(o.hasOwnProperty("sure")){this._scope.deleted.sure=!!scope.deleted.sure}if(o.hasOwnProperty("unsure")){this._scope.deleted.unsure=!!scope.deleted.unsure}}return this._scope.deprecated.sure||this._scope.deprecated.unsure||this._scope.deleted.sure||this._scope.deleted.unsure};module.exports=Rule;