/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const helperClass=require("./helpers/vartrack");const RULE_NAME="oj-js-comp-meth-deprecated";const _GLOBAL="_@global";var NT;var depMethods;var delMethods;function Rule(){this._reset();this._scope=null};Rule.prototype.getName=function(){return RULE_NAME};Rule.prototype.getShortDescription=function(){return"JET component class deprecated methods should not be invoked"};Rule.prototype.getDescription=function(){return"JET component class deprecated methods should not be invoked"};Rule.prototype.register=function(regCtx){if(!this._getRuleOptions(regCtx)){return null}return{CallExpression:this._handleCall,FunctionDeclaration:this._setup,FunctionExpression:this._setup,file:this._newFile,endfile:this._endFile,startscript:this._newFile,endscript:this._endFile}};Rule.prototype._reset=function(){this._funcVarTable=null;this._globalVars=false;this._define=false;if(this._helper){this._helper.reset()}};Rule.prototype._handleCall=function(context,node){var component,method,objName,status,comment,version,issue;var me,prop,method,del;var thoughtToBe,emitDep,emitDel;var metaLib=context.utils.metaLib;if(!NT){NT=context.utils.AstUtils.getNodeTypes()}if(node.callee&&(node.callee.name==="define"||node.callee.name==="require")){this._funcVarTable=this._handleViewModelDefine(context,node);return}if(!depMethods){depMethods=metaLib.getDeprecatedMethodList(context)}if(!delMethods){delMethods=metaLib.getDeletedMethodList(context)}me=node.callee;if(me.name&&me.name==="$"){return}if(me.type!==NT.MEMBER_EXPR){return}objName=this._getVarFromMemberExpr(me);prop=me.property;if(prop&&prop.name){method=prop.name}if(!(method&&objName)){return}if(this._isCommonMethod(context,objName,method)){return}if(!depMethods[method]){del=delMethods[method];if(!del){return}}if(context.utils.AstUtils.isFuncArg(node,objName)){if(del&&this._scope.deleted.unsure||!del&&this._scope.deprecated.unsure){issue=new context.Issue("Possible use of "+(del?"deleted":"deprecated")+" JET method "+method+"() on var '"+objName+"' (class cannot be determined)");issue.setMsgKey(context.ruleName+"_1");context.reporter.addIssue(issue,context);return}}component=this._findInstantiatedComponent(context,node,objName);if(!component){return}if(status=metaLib.isClassMethodDeprecated(component,method)){comment=context.utils.utils.removeMarkup(status[0].description)}thoughtToBe=this._isOrigVarValue(context,node,objName)?"":"thought to be ";emitDep=thoughtToBe&&this._scope.deprecated.unsure||!thoughtToBe&&this._scope.deprecated.sure;emitDel=thoughtToBe&&this._scope.deleted.unsure||!thoughtToBe&&this._scope.deleted.sure;if(del&&emitDel||!del&&emitDep){if(comment){comment=context.utils.utils.removeMarkup(comment);issue=new context.Issue("Method "+method+"() on var '"+objName+"' ("+thoughtToBe+component+")"+(comment.toLowerCase().includes("deprecated")?". ":" is "+(del?"deleted":"deprecated")+". ")+comment)}else{if(metaLib.isClassDeprecated(component)){issue=new context.Issue("Method "+method+"() on var '"+objName+"' called on deprecated class ("+thoughtToBe+component+").")}}}if(!issue){if(emitDel){version=metaLib.isClassMethodDeleted(component,method);if(version){issue=new context.Issue("Method "+method+"() on var '"+objName+"' ("+thoughtToBe+component+")"+" was removed in version "+version)}else if(metaLib.isClassDeleted(component)){issue=new context.Issue("Method "+method+"() on var '"+objName+"' called on deleted class ("+thoughtToBe+component+").")}if(issue){issue.setSeverity("critical");issue.setMsgKey(RULE_NAME+"_2")}}}if(issue){context.reporter.addIssue(issue,context)}};Rule.prototype._newFile=function(context){if(context.type==="file"&&context.filetype==="html"){return}if(!this._helper){this._helper=new helperClass}this._reset();if(!NT&&context.utils.AstUtils){NT=context.utils.AstUtils.getNodeTypes()}};Rule.prototype._endFile=function(context){this._define=false;if(this._helper){this._helper.reset()}};Rule.prototype._setup=function(context,node){var funcName;if(!depMethods){depMethods=context.utils.metaLib.getDeprecatedMethodList(context)}if(!delMethods){delMethods=context.utils.metaLib.getDeletedMethodList(context)}if(!NT){NT=context.utils.AstUtils.getNodeTypes()}if(!this._globalVars){this._helper.getGlobalVars(context);this._globalVars=true}if(this._define){return}var o=this._helper.createFuncDeclarations(context,node);if(o){this._funcVarTable=o.funcVarTable;for(funcName in this._funcVarTable){this._handleVarAssignments(context,node,this._funcVarTable[funcName])}}else{this._funcVarTable=null}};Rule.prototype._findInstantiatedComponent=function(context,node,varName){var funcName=this._helper.getContainingFunctionName(context,node);var funcVars=funcName&&this._funcVarTable?this._funcVarTable[funcName]:null;var varDef;if(funcVars){varDef=funcVars[varName];if(!varDef){funcVars=this._funcVarTable[_GLOBAL];if(funcVars){varDef=funcVars[varName]}}if(varDef&&varDef.valType){if(varDef.valType==="funcret"&&varDef.func==="$")return null;while(varDef.valType==="var"||varDef.valType==="globvar"){varDef=funcVars[varDef.varName];if(!varDef.valType){return}}if(varDef.class){return(varDef.obj?varDef.obj+".":"")+varDef.class}}}};Rule.prototype._handleVarAssignments=function(context,node,funcVars){var body,stmt,leftObj,rightObj,i;body=node.body.body;for(i=0;i<body.length;i++){stmt=body[i];if(stmt.type===NT.EXPR_STMT){if(stmt.expression){if(stmt.expression.type===NT.ASSIGNMENT_EXPR){if(stmt.expression.left.type===NT.IDENTIFIER){if(!funcVars[stmt.expression.left.name]){funcVars[stmt.expression.left.name]={type:"globvar"}}if(stmt.expression.right.type===NT.IDENTIFIER){if(!funcVars[stmt.expression.right.name]){funcVars[stmt.expression.right.name]={type:"globvar"}}leftObj=funcVars[stmt.expression.left.name];rightObj=funcVars[stmt.expression.right.name];leftObj.valType=rightObj.valType;leftObj.varName=rightObj.varName}}}}}}};Rule.prototype._getVarFromMemberExpr=function(me,varSoFar,level){var obj;level=typeof level==="number"?level+1:0;if(me.object){obj=me.object;if(obj.type===NT.IDENTIFIER){varSoFar=varSoFar?varSoFar+"."+obj.name:obj.name}else if(obj.type===NT.MEMBER_EXPR){varSoFar=this._getVarFromMemberExpr(obj,varSoFar,level)}if(me.property&&level){if(me.property.type===NT.IDENTIFIER){varSoFar=varSoFar?varSoFar+"."+me.property.name:me.property.name}else if(me.property.type===NT.MEMBER_EXPR){varSoFar=this._getVarFromMemberExpr(me.property,varSoFar,level)}}}return varSoFar};Rule.prototype._isOrigVarValue=function(context,node,varName){var funcName,funcVars,varDef;funcName=this._helper.getContainingFunctionName(context,node);if(funcName){funcVars=this._funcVarTable[funcName];if(funcVars){varDef=funcVars[varName]}}if(!varDef){funcVars=this._funcVarTable[_GLOBAL];if(funcVars){varDef=funcVars[varName]}}if(!varDef){return false}while(varDef.valType!=="new"){if(varDef.valType==="lit"){break}if(varDef.valType==="var"){varDef=funcVars[varDef.varName]}}return varDef&&varDef.valType==="new"&&varDef.class===varDef.origClass};Rule.prototype._handleViewModelDefine=function(context,node){var p,args,stmt,o,i;args=node.arguments;if(!args){return}for(i=0;i<args.length;i++){stmt=args[i];if(stmt.type===NT.FUNC_EXPR){o=this._helper.createFuncDeclarations(context,stmt);this._funcVarTable=o.funcVarTable}}this._define=true;return this._funcVarTable};Rule.prototype._isCommonMethod=function(context,objName,method){return method.charAt(0)==="_"||method==="observable"||method==="applyBindings"||method==="addEventListener"||method==="removeEventListener"||context.utils.AstUtils.isCommonDocApi(method)||objName==="this"||objName==="self"||objName==="_self"||objName==="window"||objName==="console"||this._helper.isCommonVar(objName)};Rule.prototype._getRuleOptions=function(regCtx){var scope,customOpts;if(customOpts=regCtx.ruleOpts.customOpts){scope=customOpts.scope;if(scope&&typeof scope!=="object"){regCtx.error("Rule "+RULE_NAME+" : invalid config 'ruleMods.scope' property. Rule disabled.");return false}}this._scope={deprecated:{sure:true,unsure:false},deleted:{sure:true,unsure:false}};if(!scope){return true}var o=scope.deprecated;if(o){if(o.hasOwnProperty("sure")){this._scope.deprecated.sure=!!scope.deprecated.sure}if(o.hasOwnProperty("unsure")){this._scope.deprecated.unsure=!!scope.deprecated.unsure}}o=scope.deleted;if(o){if(o.hasOwnProperty("sure")){this._scope.deleted.sure=!!scope.deleted.sure}if(o.hasOwnProperty("unsure")){this._scope.deleted.unsure=!!scope.deleted.unsure}}return this._scope.deprecated.sure||this._scope.deprecated.unsure||this._scope.deleted.sure||this._scope.deleted.unsure};module.exports=Rule;