/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULE="oj-tsx-ojattr-deprecated";const SHORT="Deprecated web component attributes or deprecated event attributes should not be used";const LONG="Deprecated web component attributes, or event attributes referring to a deprecated attribute, "+"should not be used. Refer to the API doc for potential removal date.";const DASH_CHANGED="-changed";const DATA_DASH="data-";const STATUS_PROP_TYPE="propertyType";const STATUS_PROP_VALUE="propertyValue";const STATUS_PROPERTY="property";const OBJECT="object";const STRING="string";const ARRAY_DOT_STRING="array.<string>";const ARRAY_STRING="array<string>";const JSX_SPREAD_ATTRIBUTE="JSXSpreadAttribute";const OJ_DYNAMIC="oj-dynamic";const OJ_DYN="oj-dyn";const JET_RELS=2;const SEV_BLOCKER="blocker";const MSG_ID_AGED="_aged";const MSG_ID_USER="_user";const OR="|";function Rule(){}Rule.prototype.getName=function(){return RULE};Rule.prototype.getShortDescription=function(){return SHORT};Rule.prototype.getDescription=function(){return LONG};Rule.prototype.register=function(regCtx){this._tsxUtils=regCtx.utils.tsxUtils;this._metaLib=regCtx.utils.metaLib;return{"TsxWebComponent":this._onWComp}};Rule.prototype._onWComp=function(ruleCtx,tsxComp){var props,tsxProp,propName,i;if(props=tsxComp.properties){for(i=0;i<props.length;i++){tsxProp=props[i];if(!(propName=tsxProp.name)||tsxProp.node.type===JSX_SPREAD_ATTRIBUTE){continue}if(this._tsxUtils.isAriaAttr(propName)||this._tsxUtils.isCommonAttr(propName)||this._tsxUtils.isCommonEventAttr(propName)||propName.startsWith(DATA_DASH)){continue}this._checkAttr(ruleCtx,tsxProp)}}};Rule.prototype._checkAttr=function(ruleCtx,tsxProp){var deps,status,metaLib;var tagName,propType,propName,pName,attrValType;var exprObj;var emitted=false;metaLib=ruleCtx.utils.metaLib;propName=pName=tsxProp.name;tagName=tsxProp.parent.name;if(_isEventProp(propName)){if(deps=metaLib.isTagEventDeprecated(tagName,propName)){this._emitEventIssues(ruleCtx,deps,tagName,tsxProp)}return}deps=metaLib.isTagAttrDeprecated(tagName,pName);if(!deps&&!(exprObj=this._tsxUtils.getExpressionObject(tsxProp))){return}this._checkObjectProps(ruleCtx,tagName,tsxProp,exprObj);return;propType=metaLib.getTagAttrType(tagName,pName);if(!deps&&!isEvent&&propType){if(!_isObjectType(propType)){return}_checkObjectProps(ruleCtx,tagName,propName,attrVal);return}if(!deps){return}attrValType=_getValueType(attrVal);for(status of deps){if(status.target===STATUS_PROPERTY){if(isEvent){return}}else if(status.target===STATUS_PROP_TYPE||status.target===STATUS_PROP_VALUE){if(attrValType==="expr"||attrValType==="Object"){continue}if(status.value){if(status.target===STATUS_PROP_VALUE){emitted=_doPropValue(ruleCtx,attrValType,tagName,propName,attrVal,status,isEvent)}else{emitted=_doPropType(ruleCtx,propType,attrValType,tagName,propName,attrVal,status,isEvent)}}else{_emitIssue(ruleCtx,tagName,propName,attrVal,status,isEvent?"event":"attr");emitted=true}}else if(!status.value){_emitIssue(ruleCtx,tagName,propName,attrVal,status,isEvent?"event":"attr");emitted=true}if(emitted){break}}};Rule.prototype._emitEventIssues=function(ruleCtx,deps,tagName,tsxProp){var status,issue,msgKey,since,descript;for(status of deps){if(status.target!==STATUS_PROPERTY){since=status.since?" (since "+status.since+")":"";descript=status.description?" "+status.description:"";issue=new ruleCtx.Issue(`Event '${tsxProp.name}' is deprecated${since} for <${tagName}>.${descript}`);this._tsxUtils.setIssuePosition(issue,tsxProp);msgKey=RULE+"_1";if(this._metaLib.isJetTag(tagName)||tagName===OJ_DYNAMIC||tagName===OJ_DYN){if(status.since&&ruleCtx.utils.jafLib.getMajorReleaseCount(status.since)>JET_RELS){issue.setSeverity(SEV_BLOCKER);msgKey+=MSG_ID_AGED}}else{msgKey+=MSG_ID_USER}issue.setMsgKey(msgKey);ruleCtx.reporter.addIssue(issue,ruleCtx)}}};function _isEventProp(propName){return propName.startsWith("on")&&propName.length>2};function _emitIssue(ruleCtx,tag,tsxProp,attrVal,status,scope,key){var issue;issue=_makeIssue(ruleCtx,tag,tsxProp,attrVal,status,scope,key);issue.setPosition(tsxProp.loc.start.row,tsxProp.loc.start.column,tsxProp.range[0],tsxProp.range[1]);ruleCtx.reporter.addIssue(issue,ruleCtx)};function _makeIssue(ruleCtx,tag,tsxProp,attrVal,status,scope,key){var issue,msgKey,since,descript;since=status.since?" (since "+status.since+")":"";descript=status.description?" "+status.description:"";if(scope==="val"){issue=new ruleCtx.Issue(`<${tag}> attribute '${tsxProp.name}' value '${attrVal}' is deprecated${since}!${descript}`);msgKey="_2"}else if(scope==="type"){issue=new ruleCtx.Issue(`<${tag}> attribute '${tsxProp.name}' value type '${attrVal}' is deprecated${since}!${descript}`);msgKey="_3"}else if(scope==="attr"){issue=new ruleCtx.Issue(`<${tag}> attribute '${tsxProp.name}' is deprecated${since}!${descript}`)}else if(scope==="attrprop"){issue=new ruleCtx.Issue(`<${tag}> attribute '${tsxProp.name}' property '${key}' is deprecated${since}!${descript}`)}else if(scope==="attrpropval"){issue=new ruleCtx.Issue(`<${tag}> attribute '${tsxProp.name}' property '${key}' value '${attrVal}' is deprecated${since}!${descript}`)}msgKey=RULE+(msgKey?msgKey:"");if(status.since&&(ruleCtx.utils.metaLib.isJetTag(tag)||tag===OJ_DYNAMIC||tag===OJ_DYN)){if(ruleCtx.utils.jafLib.getMajorReleaseCount(status.since)>JET_RELS){issue.setSeverity(SEV_BLOCKER);msgKey+=MSG_ID_AGED}}else{msgKey+=MSG_ID_USER}issue.setMsgKey(msgKey);return issue};Rule.prototype._checkObjectProps=function(ruleCtx,tag,tsxProp,exprObj){var key,deps,dep,propVal;for(key in exprObj){let prop=tsxProp.name+"."+key;if(deps=this._metaLib.isTagAttrDeprecated(tag,prop)){let propType=this._metaLib.getTagAttrTypeEx(tag,prop);for(dep of deps){if(!dep.target||!dep.value){_emitIssue(ruleCtx,tag,tsxProp,null,dep,"attrprop",key);return true}if(!Array.isArray(dep.value)){return}if(dep.target===STATUS_PROP_VALUE&&dep.value){if(_isStringType(propType)){propVal=this._tsxUtils.getPropertyStringValue(tsxProp);if(dep.value.includes(propVal)){_emitIssue(ruleCtx,tag,tsxProp,propVal,dep,"attrpropval",key);return true}}return false}else if(dep.target===STATUS_PROP_TYPE&&dep.value){}}}}};function _getStringValsFromType(ar){var val,ret=[];for(val of ar){if(!val.startsWith("Array<")){if(val.startsWith("'")&&val.endsWith("'")){val=val.substring(1,val.length-1)}ret.push(val)}else{let s=val.substring(6,val.length-1);let elems=s.split(OR);elems.forEach(val=>{val=val.trim();if(val.charAt(0)==="'"){val=val.substring(1,val.length-1)}ret.push(val.trim())})}}return ret};function _getStringValsFromAttr(s){var ret=[];if(s.startsWith("[")){s=s.substring(1,s.length-1);let elems=s.split(",");elems.forEach(val=>{if(val.charAt(0)==="'"){val=val.substring(1,val.length-1)}ret.push(val.trim())})}return ret};function _getValueType(v){var ret;if(v.startsWith("{{")||v.startsWith("[[")){ret="expr"}else{let s=v.charAt(0);if(s==="{"){ret="Object"}else if(s==="["){ret="Array"}else if(!isNaN(parseInt(v))){ret="number"}s=v.toLowerCase();if(s==="true"||s==="false"){ret="boolean"}else if(s==="null"){ret="null"}else if(!ret){ret="string"}}if(ret==="Array"){ret="Array<string>"}return ret};function _isStringArrayType(s){s=s.toLowerCase();return s===ARRAY_STRING||s===ARRAY_DOT_STRING};function _isStringType(propType){return propType.types.includes(STRING)};function _isObjectType(s){return s&&s.toLowerCase()===OBJECT};module.exports=Rule;