/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const getParentNodeForSlot=require("./helpers/tsx/has-slot-name");const RULE_NAME="oj-tsx-slot-pref-content";const DESCRIPT="When component metadata defines 'preferredContent' for a slot, child elements placed into that slot should "+"implement one or more of the requested interfaces and document that through their 'implements' metadata. "+"This rule applies to components that are directly allocated to a slot, or which are direct children "+"of a template allocated to that slot.";const SHORT=DESCRIPT;const IGNORE_TAG=["oj-defer","html","head","body","script"];const FLATTENABLE_TAGS=["div","oj-bind-if","oj-bind-for-each","oj-defer","template","oj-refresher","oj-validation-group","span","p"];const TEMPLATE="template";const OJ_SWITCHER="oj-switcher";const OJ_IF="oj-if";const OJ_DEFER="oj-defer";const OJ_BIND="oj-bind";const OJ_TOOLBAR="oj-toolbar";const OJ_BIND_SLOT="oj-bind-slot";const OJ_MODULE="oj-module";const OJ_VB_FRAGMENT="oj-vb-fragment";const DIV="div";const SPAN="span";const SLOT="slot";const _isBindTag=tagName=>{return tagName.startsWith("oj-bind")};const _ignoreTag=tagName=>{return IGNORE_TAG.includes(tagName)||tagName.startsWith("oj-bind")};const _isExempt=tagName=>{return tagName===OJ_VB_FRAGMENT||tagName===OJ_MODULE};class Rule{getName(){return RULE_NAME}getDescription(){return DESCRIPT}getShortDescription(){return SHORT}register(regCtx){this._utils=regCtx.utils.utils;this._metaLib=regCtx.utils.metaLib;this._tsxUtils=regCtx.utils.tsxUtils;this._hasJetWCInterfaces=this._metaLib.hasJetWCInterfaces();return{"TsxRenderComponent":this._onTsxRC,"TsxFunction":this._noteFunc}}_noteFunc(ruleCtx,tsxFunc){if(!this._tsxFuncs){this._tsxFuncs={}}this._tsxFuncs[tsxFunc.name]=tsxFunc}_onTsxRC(ruleCtx,tsxRC){tsxRC.components.forEach(tsxComp=>{this._checkComp(ruleCtx,tsxComp)})}_checkComp(ruleCtx,tsxComp){var tagName=tsxComp.name;var isTag;if(!(isTag=this._metaLib.isWCTag(tagName))){if(isTag=this._tsxUtils.isCommonElem(tagName)||tagName==="template"){isTag=!_ignoreTag(tagName)}}if(isTag){this._checkTag(ruleCtx,tsxComp)}if(tsxComp.children){tsxComp.children.forEach(child=>{this._checkComp(ruleCtx,child)})}}_checkTag(ruleCtx,tsxComp){var tsxProp,slotx,slotName="";this._slotDefined=false;if(tsxProp=this._tsxUtils.getProperty(tsxComp,SLOT)){if(this._tsxUtils.isPropertyString(tsxProp)){slotx=this._tsxUtils.getPropertyRawValue(tsxComp,SLOT,true)}}if(slotx||slotx===""){slotName=slotx;this._slotDefined=true}this._onSlot(ruleCtx,tsxComp,slotName)}_onSlot(ruleCtx,tsxComp,slotName){var pnode,slotTag=tsxComp.name,psc,tsxProp;if(slotName&&tsxComp.name===OJ_BIND_SLOT){return}if(!(pnode=getParentNodeForSlot(ruleCtx,tsxComp,slotName))){return}if(!this._metaLib.isWCTag(pnode.name)){return}if(this._metaLib.isJetTag(pnode.name)&&!this._hasJetWCInterfaces){return}psc=this._metaLib.getPreferredSlotContentEx(pnode.name,slotName);if(!(psc&&psc.interfaces)){return}if(_isExempt(slotTag)){return}if(slotTag===DIV||slotTag===OJ_IF||slotTag===OJ_SWITCHER||slotTag.startsWith(OJ_BIND)||slotTag===OJ_DEFER||slotTag===TEMPLATE){let childs;if(childs=this._flattenDivChildren(psc,pnode,tsxComp,slotName)){let child;for(let i=0;i<childs.length;i++){child=childs[i];if(!_isExempt(child.name)){if(this._tsxUtils.getProperty(child,SLOT)){continue}if(!this._isSlotInterfaceSupported(child,psc)){this._emitIssue(ruleCtx,child,slotName,pnode.name,psc,1)}}};return}else{if(slotTag===TEMPLATE){if(tsxProp=this._tsxUtils.getProperty(tsxComp,"render")){let handlerFunc;if(handlerFunc=this._getRenderHandlerFunc(tsxProp)){if(!this._renderHandlerSupportsInterface(tsxProp,handlerFunc,psc)){this._emitIssue(ruleCtx,tsxComp,slotName,pnode.name,psc,4)}return}}}this._emitIssue(ruleCtx,tsxComp,slotName,pnode.name,psc,2)}if(slotTag===OJ_SWITCHER||slotTag===OJ_IF){return}}if(this._tsxUtils.isCommonElem(slotTag)){if(pnode.name!==OJ_TOOLBAR&&slotName!==SPAN){this._emitIssue(ruleCtx,tsxComp,slotName,pnode.name,psc,3)}return}if(this._metaLib.isWCTag(slotTag)){if(!_isBindTag(slotTag)&&slotTag!==OJ_DEFER&&slotTag!==TEMPLATE){if(!this._isSlotInterfaceSupported(tsxComp,psc)){this._emitIssue(ruleCtx,tsxComp,slotName,pnode.name,psc,1)}}}}_renderHandlerSupportsInterface(tsxProp,handlerFunc,psc){if(this._tsxFuncs&&handlerFunc){let tsxComp;let tsxFunc=this._tsxFuncs[handlerFunc];if(tsxFunc&&tsxFunc.returns){for(let i=0;i<tsxFunc.returns.length;i++){if(tsxComp=tsxFunc.returns[i].tsxComponent){let retComp=tsxComp.name;if(this._isSlotInterfaceSupported(tsxComp,psc)){return true}}}}}return false}_isSlotInterfaceSupported(tsxComp,psc){var ret,aIfc;if(aIfc=this._metaLib.getInterfaces(tsxComp.name)){for(let ifc of aIfc){if(psc.interfaces.includes(ifc)){ret=true;break}}}return ret}_getRenderHandlerFunc(tsxProp){var func;var value=tsxProp.node.value;if(value.type==="JSXExpressionContainer"){if(value?.expression?.type==="Identifier"){func=value.expression.name}}return func}_flattenDivChildren(psc,pnode,tagNode,slotName,children){var nodes,node,tagName,i;if((nodes=tagNode.children)&&nodes.length){for(i=0;i<nodes.length;i++){node=nodes[i];if(node.type!=="TsxComponent"){continue}tagName=node.name;if(FLATTENABLE_TAGS.includes(tagName)){if(!this._tsxUtils.isPropertyString(node,SLOT)){children=this._flattenDivChildren(psc,pnode,node,slotName,children)}continue}if(!children){children=[]}children.push(node)}}return children}_emitIssue(ruleCtx,tsxComp,slotName,slotOwner,psci,issueType){var ifc=_list(psci.interfaces,"or");var comp=psci.components?` (e.g. ${_list(psci.components,"or",true)})`:"";var multi=psci.interfaces.length>1;var actualSlot=slotName;var slotName=slotName?`slot '${slotName}'`:"default slot";var tagName=tsxComp.name;var isDefSlot=!slotName;var issue,msg;if(issueType===1){msg=`<${tagName}> is in${isDefSlot?" the":""} ${slotName} of <${slotOwner}> but does not implement interface${multi?"s":""} ${ifc}${comp}`}else if(issueType===2){msg=`<${tagName}> is in${isDefSlot?" the":""} ${slotName} of <${slotOwner}> but its first child does not implement interface${multi?"s":""} ${ifc}${comp}`}else if(issueType===3){msg=`${slotName} on <${tagName}> for <${slotOwner}> cannot provide ${multi?"interfaces":"an interface"} of type ${ifc}${comp}`}else if(issueType===4){msg=`<${tagName}> is in${isDefSlot?" the":""} ${slotName} of <${slotOwner}> but its render attribute does not implement interface${multi?"s":""} ${ifc}${comp}`}else{return}issue=new ruleCtx.Issue(msg);if(issueType===4){issue.setMsgKey(RULE_NAME+"_1")}if(this._slotDefined){let tsxProp=this._tsxUtils.getProperty(tsxComp,SLOT);if(tsxProp){this._tsxUtils.setIssuePosition(issue,tsxProp)}}issue.setMsgEx({slotName:actualSlot,slotElem:tagName,slotOwner:slotOwner});ruleCtx.reporter.addIssue(issue,ruleCtx)}_getFirstChildTag(childs){var ret,childs,child;if(childs){for(let i=0;i<childs.length;i++){child=childs[i];if(child.name.startsWith("oj-bind-")||child.name===OJ_DEFER||child.name===TEMPLATE){return this._getFirstChildTag(child.children)}ret=child;break}}return ret}}function _list(a,orand,isComp){var s="";for(let i=0;i<a.length;i++){if(i){if(i===a.length-1){s+=(isComp?">":"'")+" "+orand+" "}else{s+=(isComp?">":"'")+", "}}s+=(isComp?"<":"'")+a[i]}return s?s+=isComp?">":"'":s};module.exports=Rule;