/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULENAME="oj-tsx-style-bp-margin-padding";const DESCRIPTION="For best practices, margin/padding classes such as 'oj-sm-margin-4x' and 'oj-sm-padding-4x' are preferred "+"over numeric values.  See the "+"<a href='https://jet.oraclecorp.com/trunk/jetCookbook.html?component=spacing&demo=spacingvariants'>Margins & Padding</a> "+"demo category in the JET cookbook under the Framework Utility CSS category.\n"+"Negative values are not supported.";const SHORT_DESCRIPTION="For best practices, margin classes such as 'oj-sm-margin-4x' and padding classes such as 'oj-sm-padding-4x' are preferred. .";const MARGIN="margin";const PADDING="padding";const MARGIN_BLOCK="margin-block";const PADDING_BLOCK="padding-block";const OJ_SM_MARGIN="oj-sm-margin-";const OJ_SM_PADDING="oj-sm-padding-";const MARGIN_PROPS=[MARGIN,"margin-top","margin-right","margin-bottom","margin-left","marginTop","marginRight","marginBottom","marginLeft","margin-block","margin-block-start","margin-block-end","margin-inline","margin-inline-start","margin-inline-end","marginBlock","marginBlockStart","marginBlockEnd","marginInline","marginInlineStart","marginInlineEnd"];const PADDING_PROPS=[PADDING,"padding-top","padding-right","padding-bottom","padding-left","paddingTop","paddingRight","paddingBottom","paddingLeft","padding-block","padding-block-start","padding-block-end","padding-inline","padding-inline-start","padding-inline-end","paddingBlock","paddingBlockStart","paddingBlockEnd","paddInline","paddingInlineStart","paddingInlineEnd"];const NON_LENGTH=["auto","initial","inherit"];const PX="px";const MIN_PX=4;const MAX_PX=48;const REM="rem";const MIN_REM=0.25;const MAX_REM=12;const EM="em";const MIN_EM=0.25;const MAX_EM=12;const COLON=":";class Rule{getName(){return RULENAME}getDescription(){return DESCRIPTION}getShortDescription(){return SHORT_DESCRIPTION}register(regCtx){this._tsxUtils=regCtx.utils.tsxUtils;return{"Tsx<style=>":this._onStyle}}_onStyle(ruleCtx,tsxProp){var prop,values;this._CssUtils=ruleCtx.utils.CssUtils;if((values=this._tsxUtils.getPropertyStringValue(tsxProp))!==null){values=_convertToObj(values)}else if(!(values=this._tsxUtils.getExpressionObject(tsxProp))){return}if(values){let style,val;for(style in values){if(val=values[style]){if(MARGIN_PROPS.includes(style)||PADDING_PROPS.includes(style)){this._onProp(ruleCtx,style,val)}}}}}_onProp(ruleCtx,prop,value){if(NON_LENGTH.includes(value)||value.endsWith("%")){return}let a,x;a=value.split(" ");if(prop===MARGIN||prop===PADDING){a.forEach(val=>{if(!(val.startsWith(OJ_SM_MARGIN)||val.startsWith(OJ_SM_PADDING))){this._handleProp(ruleCtx,prop,val)}})}else if(prop.startsWith(MARGIN_BLOCK)||prop.startsWith(PADDING_BLOCK)){this._handleBlock(ruleCtx,prop,value)}else{this._handleProp(ruleCtx,prop,value)}}_handleProp(ruleCtx,prop,value){let numVal=parseFloat(value);if(!isNaN(numVal)){if(value.endsWith("px")){this._checkPxRange(ruleCtx,prop,numVal)}else if(value.endsWith("rem")){this._checkRemRange(ruleCtx,prop,numVal)}else if(value.endsWith("em")){this._checkEmRange(ruleCtx,prop,numVal)}else if(""+numVal===value){this._checkNoUnit(ruleCtx,prop,numVal)}}}_handleBlock(ruleCtx,prop,value){var a,val,i;a=value.split(" ");for(i=0;i<a.length;i++){if(val=a[i]){this._handleProp(ruleCtx,prop,val)}}}_checkPxRange(ruleCtx,prop,value){if(value<0&&(PADDING_PROPS.includes(prop)||MARGIN_PROPS.includes(prop))){this._emitIssue(ruleCtx,2,prop,PX,value);return}if(value<MIN_PX||value>MAX_PX){return}this._emitIssue(ruleCtx,1,prop,PX,value)}_checkRemRange(ruleCtx,prop,value){if(value<0&&(PADDING_PROPS.includes(prop)||MARGIN_PROPS.includes(prop))){this._emitIssue(ruleCtx,2,prop,REM,value);return}if(value<MIN_REM||value>MAX_REM){return}this._emitIssue(ruleCtx,1,prop,REM,value)}_checkEmRange(ruleCtx,prop,value){if(value<0&&(PADDING_PROPS.includes(prop)||MARGIN_PROPS.includes(prop))){this._emitIssue(ruleCtx,2,prop,EM,value);return}if(value<MIN_EM||value>MAX_EM){return}this._emitIssue(ruleCtx,1,prop,EM,value)}_checkNoUnit(ruleCtx,prop,value){if(value<0&&(PADDING_PROPS.includes(prop)||MARGIN_PROPS.includes(prop))){this._emitIssue(ruleCtx,2,prop,"",value)}if(value>0){this._emitIssue(ruleCtx,3,prop,"",value)}if(value<MIN_PX||value<MIN_REM||value<MIN_EM||value>MAX_PX||value>MIN_REM||value>MIN_EM){return}}_emitIssue(ruleCtx,msgType,prop,unit,value,min,max){var issue;if(msgType===1){issue=new ruleCtx.Issue(`style '${prop}' value ${value}${unit} - for best practice margin/padding classes such as 'oj-sm-margin-*/oj-sm-padding-*' are preferred.`)}else if(msgType===2){issue=new ruleCtx.Issue(`style '${prop}' value ${value}${unit} must not be negative.`);issue.setMsgKey(RULENAME+"_1")}else if(msgType===3){issue=new ruleCtx.Issue(`style '${prop}' value ${value} should declare a unit.`);issue.setMsgKey(RULENAME+"_2")}if(issue){this._tsxUtils.setIssuePosition(issue,ruleCtx.node);ruleCtx.reporter.addIssue(issue,ruleCtx)}}}function _convertToObj(s){var a,x,elem,prop,val,n=0,obj={};a=s.split(";");if(a?.length){for(i=0;i<a.length;i++){elem=a[i];if((x=elem.indexOf(COLON))>0){prop=elem.substring(0,x).trimEnd();val=elem.substring(x+1).trimStart();n++;obj[prop]=val}}}return n?obj:null}module.exports=Rule;